/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* DAG Instruction Selector for the WebAssembly target                        *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

// *** NOTE: This file is #included into the middle of the target
// *** instruction selector class.  These functions are really methods.

// If GET_DAGISEL_DECL is #defined with any value, only function
// declarations will be included when this file is included.
// If GET_DAGISEL_BODY is #defined, its value should be the name of
// the instruction selector class. Function bodies will be emitted
// and each function's name will be qualified with the name of the
// class.
//
// When neither of the GET_DAGISEL* macros is defined, the functions
// are emitted inline.

#if defined(GET_DAGISEL_DECL) && defined(GET_DAGISEL_BODY)
#error GET_DAGISEL_DECL and GET_DAGISEL_BODY cannot be both defined, undef both for inline definitions
#endif

#ifdef GET_DAGISEL_BODY
#define LOCAL_DAGISEL_STRINGIZE(X) LOCAL_DAGISEL_STRINGIZE_(X)
#define LOCAL_DAGISEL_STRINGIZE_(X) #X
static_assert(sizeof(LOCAL_DAGISEL_STRINGIZE(GET_DAGISEL_BODY)) > 1,
   "GET_DAGISEL_BODY is empty: it should be defined with the class name");
#undef LOCAL_DAGISEL_STRINGIZE_
#undef LOCAL_DAGISEL_STRINGIZE
#endif

#if !defined(GET_DAGISEL_DECL) && !defined(GET_DAGISEL_BODY)
#define DAGISEL_INLINE 1
#else
#define DAGISEL_INLINE 0
#endif

#if !DAGISEL_INLINE
#define DAGISEL_CLASS_COLONCOLON GET_DAGISEL_BODY ::
#else
#define DAGISEL_CLASS_COLONCOLON
#endif

#ifdef GET_DAGISEL_DECL
void SelectCode(SDNode *N);
#endif
#if defined(GET_DAGISEL_BODY) || DAGISEL_INLINE
void DAGISEL_CLASS_COLONCOLON SelectCode(SDNode *N)
{
  // Some target values are emitted as 2 bytes, TARGET_VAL handles
  // this. Coverage indexes are emitted as 4 bytes,
  // COVERAGE_IDX_VAL handles this.
  #define TARGET_VAL(X) X & 255, unsigned(X) >> 8
  #define COVERAGE_IDX_VAL(X) X & 255, (unsigned(X) >> 8) & 255, (unsigned(X) >> 16) & 255, (unsigned(X) >> 24) & 255
  static const unsigned char MatcherTable[] = {
 OPC_SwitchOpcode , 44|128,9, TARGET_VAL(ISD::ZERO_EXTEND),
  OPC_Scope, 32|128,9, 
   OPC_MoveChild0,
   OPC_SwitchOpcode , 124, TARGET_VAL(ISD::AssertZext),
    OPC_MoveChild0,
    OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),
    OPC_RecordMemRef,
    OPC_RecordNode,
    OPC_CheckFoldableChainNode,
    OPC_RecordChild1,
    OPC_Scope, 56, 
     OPC_CheckChild1TypeI32,
     OPC_MoveChild2,
     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
     OPC_RecordChild0,
     OPC_MoveSibling3,
     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
     OPC_RecordChild0,
     OPC_MoveParent,
     OPC_Scope, 20, 
      OPC_CheckPredicate1, 
      OPC_MoveParent,
      OPC_MoveParent,
      OPC_CheckPatternPredicate3,
      OPC_CheckComplexPat0, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 5, 6, 4, 5, 2, 3, 
     20, 
      OPC_CheckPredicate2, 
      OPC_MoveParent,
      OPC_MoveParent,
      OPC_CheckPatternPredicate3,
      OPC_CheckComplexPat0, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 5, 6, 4, 5, 2, 3, 
     0, 
    56, 
     OPC_CheckChild1TypeI64,
     OPC_MoveChild2,
     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
     OPC_RecordChild0,
     OPC_MoveSibling3,
     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
     OPC_RecordChild0,
     OPC_MoveParent,
     OPC_Scope, 20, 
      OPC_CheckPredicate1, 
      OPC_MoveParent,
      OPC_MoveParent,
      OPC_CheckPatternPredicate4,
      OPC_CheckComplexPat1, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 5, 6, 4, 5, 2, 3, 
     20, 
      OPC_CheckPredicate2, 
      OPC_MoveParent,
      OPC_MoveParent,
      OPC_CheckPatternPredicate4,
      OPC_CheckComplexPat1, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 5, 6, 4, 5, 2, 3, 
     0, 
    0, 
   69, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),
    OPC_RecordMemRef,
    OPC_RecordNode,
    OPC_RecordChild1,
    OPC_Scope, 31, 
     OPC_CheckChild1TypeI32,
     OPC_MoveChild2,
     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
     OPC_RecordChild0,
     OPC_MoveSibling3,
     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
     OPC_RecordChild0,
     OPC_MoveParent,
     OPC_CheckPredicate3, 
     OPC_MoveParent,
     OPC_CheckPatternPredicate3,
     OPC_CheckComplexPat0, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   8, 5, 6, 4, 5, 2, 3, 
    31, 
     OPC_CheckChild1TypeI64,
     OPC_MoveChild2,
     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
     OPC_RecordChild0,
     OPC_MoveSibling3,
     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
     OPC_RecordChild0,
     OPC_MoveParent,
     OPC_CheckPredicate3, 
     OPC_MoveParent,
     OPC_CheckPatternPredicate4,
     OPC_CheckComplexPat1, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   8, 5, 6, 4, 5, 2, 3, 
    0, 
   11|128,1, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),
    OPC_RecordMemRef,
    OPC_RecordNode,
    OPC_RecordChild1,
    OPC_Scope, 66, 
     OPC_CheckChild1TypeI32,
     OPC_MoveChild2,
     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
     OPC_RecordChild0,
     OPC_MoveParent,
     OPC_Scope, 18, 
      OPC_CheckPredicate1, 
      OPC_MoveParent,
      OPC_CheckPatternPredicate3,
      OPC_CheckComplexPat0, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 4, 5, 3, 4, 2, 
     18, 
      OPC_CheckPredicate2, 
      OPC_MoveParent,
      OPC_CheckPatternPredicate3,
      OPC_CheckComplexPat0, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 4, 5, 3, 4, 2, 
     18, 
      OPC_CheckPredicate3, 
      OPC_MoveParent,
      OPC_CheckPatternPredicate3,
      OPC_CheckComplexPat0, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 4, 5, 3, 4, 2, 
     0, 
    66, 
     OPC_CheckChild1TypeI64,
     OPC_MoveChild2,
     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
     OPC_RecordChild0,
     OPC_MoveParent,
     OPC_Scope, 18, 
      OPC_CheckPredicate1, 
      OPC_MoveParent,
      OPC_CheckPatternPredicate4,
      OPC_CheckComplexPat1, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 4, 5, 3, 4, 2, 
     18, 
      OPC_CheckPredicate2, 
      OPC_MoveParent,
      OPC_CheckPatternPredicate4,
      OPC_CheckComplexPat1, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 4, 5, 3, 4, 2, 
     18, 
      OPC_CheckPredicate3, 
      OPC_MoveParent,
      OPC_CheckPatternPredicate4,
      OPC_CheckComplexPat1, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 4, 5, 3, 4, 2, 
     0, 
    0, 
   11|128,1, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),
    OPC_RecordMemRef,
    OPC_RecordNode,
    OPC_RecordChild1,
    OPC_Scope, 66, 
     OPC_CheckChild1TypeI32,
     OPC_MoveChild2,
     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
     OPC_RecordChild0,
     OPC_MoveParent,
     OPC_Scope, 18, 
      OPC_CheckPredicate1, 
      OPC_MoveParent,
      OPC_CheckPatternPredicate3,
      OPC_CheckComplexPat0, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 4, 5, 3, 4, 2, 
     18, 
      OPC_CheckPredicate2, 
      OPC_MoveParent,
      OPC_CheckPatternPredicate3,
      OPC_CheckComplexPat0, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 4, 5, 3, 4, 2, 
     18, 
      OPC_CheckPredicate3, 
      OPC_MoveParent,
      OPC_CheckPatternPredicate3,
      OPC_CheckComplexPat0, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 4, 5, 3, 4, 2, 
     0, 
    66, 
     OPC_CheckChild1TypeI64,
     OPC_MoveChild2,
     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
     OPC_RecordChild0,
     OPC_MoveParent,
     OPC_Scope, 18, 
      OPC_CheckPredicate1, 
      OPC_MoveParent,
      OPC_CheckPatternPredicate4,
      OPC_CheckComplexPat1, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 4, 5, 3, 4, 2, 
     18, 
      OPC_CheckPredicate2, 
      OPC_MoveParent,
      OPC_CheckPatternPredicate4,
      OPC_CheckComplexPat1, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 4, 5, 3, 4, 2, 
     18, 
      OPC_CheckPredicate3, 
      OPC_MoveParent,
      OPC_CheckPatternPredicate4,
      OPC_CheckComplexPat1, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 4, 5, 3, 4, 2, 
     0, 
    0, 
   11|128,1, TARGET_VAL(ISD::ATOMIC_LOAD_AND),
    OPC_RecordMemRef,
    OPC_RecordNode,
    OPC_RecordChild1,
    OPC_Scope, 66, 
     OPC_CheckChild1TypeI32,
     OPC_MoveChild2,
     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
     OPC_RecordChild0,
     OPC_MoveParent,
     OPC_Scope, 18, 
      OPC_CheckPredicate1, 
      OPC_MoveParent,
      OPC_CheckPatternPredicate3,
      OPC_CheckComplexPat0, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 4, 5, 3, 4, 2, 
     18, 
      OPC_CheckPredicate2, 
      OPC_MoveParent,
      OPC_CheckPatternPredicate3,
      OPC_CheckComplexPat0, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 4, 5, 3, 4, 2, 
     18, 
      OPC_CheckPredicate3, 
      OPC_MoveParent,
      OPC_CheckPatternPredicate3,
      OPC_CheckComplexPat0, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 4, 5, 3, 4, 2, 
     0, 
    66, 
     OPC_CheckChild1TypeI64,
     OPC_MoveChild2,
     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
     OPC_RecordChild0,
     OPC_MoveParent,
     OPC_Scope, 18, 
      OPC_CheckPredicate1, 
      OPC_MoveParent,
      OPC_CheckPatternPredicate4,
      OPC_CheckComplexPat1, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 4, 5, 3, 4, 2, 
     18, 
      OPC_CheckPredicate2, 
      OPC_MoveParent,
      OPC_CheckPatternPredicate4,
      OPC_CheckComplexPat1, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 4, 5, 3, 4, 2, 
     18, 
      OPC_CheckPredicate3, 
      OPC_MoveParent,
      OPC_CheckPatternPredicate4,
      OPC_CheckComplexPat1, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 4, 5, 3, 4, 2, 
     0, 
    0, 
   11|128,1, TARGET_VAL(ISD::ATOMIC_LOAD_OR),
    OPC_RecordMemRef,
    OPC_RecordNode,
    OPC_RecordChild1,
    OPC_Scope, 66, 
     OPC_CheckChild1TypeI32,
     OPC_MoveChild2,
     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
     OPC_RecordChild0,
     OPC_MoveParent,
     OPC_Scope, 18, 
      OPC_CheckPredicate1, 
      OPC_MoveParent,
      OPC_CheckPatternPredicate3,
      OPC_CheckComplexPat0, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 4, 5, 3, 4, 2, 
     18, 
      OPC_CheckPredicate2, 
      OPC_MoveParent,
      OPC_CheckPatternPredicate3,
      OPC_CheckComplexPat0, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 4, 5, 3, 4, 2, 
     18, 
      OPC_CheckPredicate3, 
      OPC_MoveParent,
      OPC_CheckPatternPredicate3,
      OPC_CheckComplexPat0, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 4, 5, 3, 4, 2, 
     0, 
    66, 
     OPC_CheckChild1TypeI64,
     OPC_MoveChild2,
     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
     OPC_RecordChild0,
     OPC_MoveParent,
     OPC_Scope, 18, 
      OPC_CheckPredicate1, 
      OPC_MoveParent,
      OPC_CheckPatternPredicate4,
      OPC_CheckComplexPat1, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 4, 5, 3, 4, 2, 
     18, 
      OPC_CheckPredicate2, 
      OPC_MoveParent,
      OPC_CheckPatternPredicate4,
      OPC_CheckComplexPat1, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 4, 5, 3, 4, 2, 
     18, 
      OPC_CheckPredicate3, 
      OPC_MoveParent,
      OPC_CheckPatternPredicate4,
      OPC_CheckComplexPat1, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 4, 5, 3, 4, 2, 
     0, 
    0, 
   11|128,1, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),
    OPC_RecordMemRef,
    OPC_RecordNode,
    OPC_RecordChild1,
    OPC_Scope, 66, 
     OPC_CheckChild1TypeI32,
     OPC_MoveChild2,
     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
     OPC_RecordChild0,
     OPC_MoveParent,
     OPC_Scope, 18, 
      OPC_CheckPredicate1, 
      OPC_MoveParent,
      OPC_CheckPatternPredicate3,
      OPC_CheckComplexPat0, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 4, 5, 3, 4, 2, 
     18, 
      OPC_CheckPredicate2, 
      OPC_MoveParent,
      OPC_CheckPatternPredicate3,
      OPC_CheckComplexPat0, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 4, 5, 3, 4, 2, 
     18, 
      OPC_CheckPredicate3, 
      OPC_MoveParent,
      OPC_CheckPatternPredicate3,
      OPC_CheckComplexPat0, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 4, 5, 3, 4, 2, 
     0, 
    66, 
     OPC_CheckChild1TypeI64,
     OPC_MoveChild2,
     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
     OPC_RecordChild0,
     OPC_MoveParent,
     OPC_Scope, 18, 
      OPC_CheckPredicate1, 
      OPC_MoveParent,
      OPC_CheckPatternPredicate4,
      OPC_CheckComplexPat1, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 4, 5, 3, 4, 2, 
     18, 
      OPC_CheckPredicate2, 
      OPC_MoveParent,
      OPC_CheckPatternPredicate4,
      OPC_CheckComplexPat1, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 4, 5, 3, 4, 2, 
     18, 
      OPC_CheckPredicate3, 
      OPC_MoveParent,
      OPC_CheckPatternPredicate4,
      OPC_CheckComplexPat1, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 4, 5, 3, 4, 2, 
     0, 
    0, 
   11|128,1, TARGET_VAL(ISD::ATOMIC_SWAP),
    OPC_RecordMemRef,
    OPC_RecordNode,
    OPC_RecordChild1,
    OPC_Scope, 66, 
     OPC_CheckChild1TypeI32,
     OPC_MoveChild2,
     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
     OPC_RecordChild0,
     OPC_MoveParent,
     OPC_Scope, 18, 
      OPC_CheckPredicate1, 
      OPC_MoveParent,
      OPC_CheckPatternPredicate3,
      OPC_CheckComplexPat0, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 4, 5, 3, 4, 2, 
     18, 
      OPC_CheckPredicate2, 
      OPC_MoveParent,
      OPC_CheckPatternPredicate3,
      OPC_CheckComplexPat0, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 4, 5, 3, 4, 2, 
     18, 
      OPC_CheckPredicate3, 
      OPC_MoveParent,
      OPC_CheckPatternPredicate3,
      OPC_CheckComplexPat0, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 4, 5, 3, 4, 2, 
     0, 
    66, 
     OPC_CheckChild1TypeI64,
     OPC_MoveChild2,
     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
     OPC_RecordChild0,
     OPC_MoveParent,
     OPC_Scope, 18, 
      OPC_CheckPredicate1, 
      OPC_MoveParent,
      OPC_CheckPatternPredicate4,
      OPC_CheckComplexPat1, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 4, 5, 3, 4, 2, 
     18, 
      OPC_CheckPredicate2, 
      OPC_MoveParent,
      OPC_CheckPatternPredicate4,
      OPC_CheckComplexPat1, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 4, 5, 3, 4, 2, 
     18, 
      OPC_CheckPredicate3, 
      OPC_MoveParent,
      OPC_CheckPatternPredicate4,
      OPC_CheckComplexPat1, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 4, 5, 3, 4, 2, 
     0, 
    0, 
   121, TARGET_VAL(ISD::ATOMIC_LOAD),
    OPC_RecordMemRef,
    OPC_RecordNode,
    OPC_RecordChild1,
    OPC_Scope, 57, 
     OPC_CheckChild1TypeI32,
     OPC_Scope, 17, 
      OPC_CheckPredicate1, 
      OPC_MoveParent,
      OPC_CheckPatternPredicate1,
      OPC_CheckComplexPat0, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 3, 4, 2, 3, 
     17, 
      OPC_CheckPredicate2, 
      OPC_MoveParent,
      OPC_CheckPatternPredicate1,
      OPC_CheckComplexPat0, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 3, 4, 2, 3, 
     17, 
      OPC_CheckPredicate3, 
      OPC_MoveParent,
      OPC_CheckPatternPredicate1,
      OPC_CheckComplexPat0, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD32_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 3, 4, 2, 3, 
     0, 
    57, 
     OPC_CheckChild1TypeI64,
     OPC_Scope, 17, 
      OPC_CheckPredicate1, 
      OPC_MoveParent,
      OPC_CheckPatternPredicate2,
      OPC_CheckComplexPat1, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 3, 4, 2, 3, 
     17, 
      OPC_CheckPredicate2, 
      OPC_MoveParent,
      OPC_CheckPatternPredicate2,
      OPC_CheckComplexPat1, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 3, 4, 2, 3, 
     17, 
      OPC_CheckPredicate3, 
      OPC_MoveParent,
      OPC_CheckPatternPredicate2,
      OPC_CheckComplexPat1, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD32_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 3, 4, 2, 3, 
     0, 
    0, 
   0,
  7, 
   OPC_RecordChild0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_EXTEND_U_I32),
                 8, 1, 0, 
  0, 
 86|128,6, TARGET_VAL(ISD::ANY_EXTEND),
  OPC_Scope, 74|128,6, 
   OPC_MoveChild0,
   OPC_SwitchOpcode , 124, TARGET_VAL(ISD::AssertZext),
    OPC_MoveChild0,
    OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),
    OPC_RecordMemRef,
    OPC_RecordNode,
    OPC_CheckFoldableChainNode,
    OPC_RecordChild1,
    OPC_Scope, 56, 
     OPC_CheckChild1TypeI32,
     OPC_MoveChild2,
     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
     OPC_RecordChild0,
     OPC_MoveSibling3,
     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
     OPC_RecordChild0,
     OPC_MoveParent,
     OPC_Scope, 20, 
      OPC_CheckPredicate1, 
      OPC_MoveParent,
      OPC_MoveParent,
      OPC_CheckPatternPredicate3,
      OPC_CheckComplexPat0, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 5, 6, 4, 5, 2, 3, 
     20, 
      OPC_CheckPredicate2, 
      OPC_MoveParent,
      OPC_MoveParent,
      OPC_CheckPatternPredicate3,
      OPC_CheckComplexPat0, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 5, 6, 4, 5, 2, 3, 
     0, 
    56, 
     OPC_CheckChild1TypeI64,
     OPC_MoveChild2,
     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
     OPC_RecordChild0,
     OPC_MoveSibling3,
     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
     OPC_RecordChild0,
     OPC_MoveParent,
     OPC_Scope, 20, 
      OPC_CheckPredicate1, 
      OPC_MoveParent,
      OPC_MoveParent,
      OPC_CheckPatternPredicate4,
      OPC_CheckComplexPat1, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 5, 6, 4, 5, 2, 3, 
     20, 
      OPC_CheckPredicate2, 
      OPC_MoveParent,
      OPC_MoveParent,
      OPC_CheckPatternPredicate4,
      OPC_CheckComplexPat1, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 5, 6, 4, 5, 2, 3, 
     0, 
    0, 
   101, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),
    OPC_RecordMemRef,
    OPC_RecordNode,
    OPC_RecordChild1,
    OPC_Scope, 47, 
     OPC_CheckChild1TypeI32,
     OPC_MoveChild2,
     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
     OPC_RecordChild0,
     OPC_MoveParent,
     OPC_Scope, 18, 
      OPC_CheckPredicate1, 
      OPC_MoveParent,
      OPC_CheckPatternPredicate3,
      OPC_CheckComplexPat0, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 4, 5, 3, 4, 2, 
     18, 
      OPC_CheckPredicate2, 
      OPC_MoveParent,
      OPC_CheckPatternPredicate3,
      OPC_CheckComplexPat0, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 4, 5, 3, 4, 2, 
     0, 
    47, 
     OPC_CheckChild1TypeI64,
     OPC_MoveChild2,
     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
     OPC_RecordChild0,
     OPC_MoveParent,
     OPC_Scope, 18, 
      OPC_CheckPredicate1, 
      OPC_MoveParent,
      OPC_CheckPatternPredicate4,
      OPC_CheckComplexPat1, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 4, 5, 3, 4, 2, 
     18, 
      OPC_CheckPredicate2, 
      OPC_MoveParent,
      OPC_CheckPatternPredicate4,
      OPC_CheckComplexPat1, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 4, 5, 3, 4, 2, 
     0, 
    0, 
   101, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),
    OPC_RecordMemRef,
    OPC_RecordNode,
    OPC_RecordChild1,
    OPC_Scope, 47, 
     OPC_CheckChild1TypeI32,
     OPC_MoveChild2,
     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
     OPC_RecordChild0,
     OPC_MoveParent,
     OPC_Scope, 18, 
      OPC_CheckPredicate1, 
      OPC_MoveParent,
      OPC_CheckPatternPredicate3,
      OPC_CheckComplexPat0, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 4, 5, 3, 4, 2, 
     18, 
      OPC_CheckPredicate2, 
      OPC_MoveParent,
      OPC_CheckPatternPredicate3,
      OPC_CheckComplexPat0, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 4, 5, 3, 4, 2, 
     0, 
    47, 
     OPC_CheckChild1TypeI64,
     OPC_MoveChild2,
     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
     OPC_RecordChild0,
     OPC_MoveParent,
     OPC_Scope, 18, 
      OPC_CheckPredicate1, 
      OPC_MoveParent,
      OPC_CheckPatternPredicate4,
      OPC_CheckComplexPat1, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 4, 5, 3, 4, 2, 
     18, 
      OPC_CheckPredicate2, 
      OPC_MoveParent,
      OPC_CheckPatternPredicate4,
      OPC_CheckComplexPat1, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 4, 5, 3, 4, 2, 
     0, 
    0, 
   101, TARGET_VAL(ISD::ATOMIC_LOAD_AND),
    OPC_RecordMemRef,
    OPC_RecordNode,
    OPC_RecordChild1,
    OPC_Scope, 47, 
     OPC_CheckChild1TypeI32,
     OPC_MoveChild2,
     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
     OPC_RecordChild0,
     OPC_MoveParent,
     OPC_Scope, 18, 
      OPC_CheckPredicate1, 
      OPC_MoveParent,
      OPC_CheckPatternPredicate3,
      OPC_CheckComplexPat0, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 4, 5, 3, 4, 2, 
     18, 
      OPC_CheckPredicate2, 
      OPC_MoveParent,
      OPC_CheckPatternPredicate3,
      OPC_CheckComplexPat0, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 4, 5, 3, 4, 2, 
     0, 
    47, 
     OPC_CheckChild1TypeI64,
     OPC_MoveChild2,
     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
     OPC_RecordChild0,
     OPC_MoveParent,
     OPC_Scope, 18, 
      OPC_CheckPredicate1, 
      OPC_MoveParent,
      OPC_CheckPatternPredicate4,
      OPC_CheckComplexPat1, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 4, 5, 3, 4, 2, 
     18, 
      OPC_CheckPredicate2, 
      OPC_MoveParent,
      OPC_CheckPatternPredicate4,
      OPC_CheckComplexPat1, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 4, 5, 3, 4, 2, 
     0, 
    0, 
   101, TARGET_VAL(ISD::ATOMIC_LOAD_OR),
    OPC_RecordMemRef,
    OPC_RecordNode,
    OPC_RecordChild1,
    OPC_Scope, 47, 
     OPC_CheckChild1TypeI32,
     OPC_MoveChild2,
     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
     OPC_RecordChild0,
     OPC_MoveParent,
     OPC_Scope, 18, 
      OPC_CheckPredicate1, 
      OPC_MoveParent,
      OPC_CheckPatternPredicate3,
      OPC_CheckComplexPat0, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 4, 5, 3, 4, 2, 
     18, 
      OPC_CheckPredicate2, 
      OPC_MoveParent,
      OPC_CheckPatternPredicate3,
      OPC_CheckComplexPat0, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 4, 5, 3, 4, 2, 
     0, 
    47, 
     OPC_CheckChild1TypeI64,
     OPC_MoveChild2,
     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
     OPC_RecordChild0,
     OPC_MoveParent,
     OPC_Scope, 18, 
      OPC_CheckPredicate1, 
      OPC_MoveParent,
      OPC_CheckPatternPredicate4,
      OPC_CheckComplexPat1, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 4, 5, 3, 4, 2, 
     18, 
      OPC_CheckPredicate2, 
      OPC_MoveParent,
      OPC_CheckPatternPredicate4,
      OPC_CheckComplexPat1, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 4, 5, 3, 4, 2, 
     0, 
    0, 
   101, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),
    OPC_RecordMemRef,
    OPC_RecordNode,
    OPC_RecordChild1,
    OPC_Scope, 47, 
     OPC_CheckChild1TypeI32,
     OPC_MoveChild2,
     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
     OPC_RecordChild0,
     OPC_MoveParent,
     OPC_Scope, 18, 
      OPC_CheckPredicate1, 
      OPC_MoveParent,
      OPC_CheckPatternPredicate3,
      OPC_CheckComplexPat0, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 4, 5, 3, 4, 2, 
     18, 
      OPC_CheckPredicate2, 
      OPC_MoveParent,
      OPC_CheckPatternPredicate3,
      OPC_CheckComplexPat0, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 4, 5, 3, 4, 2, 
     0, 
    47, 
     OPC_CheckChild1TypeI64,
     OPC_MoveChild2,
     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
     OPC_RecordChild0,
     OPC_MoveParent,
     OPC_Scope, 18, 
      OPC_CheckPredicate1, 
      OPC_MoveParent,
      OPC_CheckPatternPredicate4,
      OPC_CheckComplexPat1, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 4, 5, 3, 4, 2, 
     18, 
      OPC_CheckPredicate2, 
      OPC_MoveParent,
      OPC_CheckPatternPredicate4,
      OPC_CheckComplexPat1, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 4, 5, 3, 4, 2, 
     0, 
    0, 
   101, TARGET_VAL(ISD::ATOMIC_SWAP),
    OPC_RecordMemRef,
    OPC_RecordNode,
    OPC_RecordChild1,
    OPC_Scope, 47, 
     OPC_CheckChild1TypeI32,
     OPC_MoveChild2,
     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
     OPC_RecordChild0,
     OPC_MoveParent,
     OPC_Scope, 18, 
      OPC_CheckPredicate1, 
      OPC_MoveParent,
      OPC_CheckPatternPredicate3,
      OPC_CheckComplexPat0, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 4, 5, 3, 4, 2, 
     18, 
      OPC_CheckPredicate2, 
      OPC_MoveParent,
      OPC_CheckPatternPredicate3,
      OPC_CheckComplexPat0, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 4, 5, 3, 4, 2, 
     0, 
    47, 
     OPC_CheckChild1TypeI64,
     OPC_MoveChild2,
     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
     OPC_RecordChild0,
     OPC_MoveParent,
     OPC_Scope, 18, 
      OPC_CheckPredicate1, 
      OPC_MoveParent,
      OPC_CheckPatternPredicate4,
      OPC_CheckComplexPat1, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 4, 5, 3, 4, 2, 
     18, 
      OPC_CheckPredicate2, 
      OPC_MoveParent,
      OPC_CheckPatternPredicate4,
      OPC_CheckComplexPat1, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 4, 5, 3, 4, 2, 
     0, 
    0, 
   85, TARGET_VAL(ISD::ATOMIC_LOAD),
    OPC_RecordMemRef,
    OPC_RecordNode,
    OPC_RecordChild1,
    OPC_Scope, 39, 
     OPC_CheckChild1TypeI32,
     OPC_Scope, 17, 
      OPC_CheckPredicate1, 
      OPC_MoveParent,
      OPC_CheckPatternPredicate1,
      OPC_CheckComplexPat0, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 3, 4, 2, 3, 
     17, 
      OPC_CheckPredicate2, 
      OPC_MoveParent,
      OPC_CheckPatternPredicate1,
      OPC_CheckComplexPat0, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 3, 4, 2, 3, 
     0, 
    39, 
     OPC_CheckChild1TypeI64,
     OPC_Scope, 17, 
      OPC_CheckPredicate1, 
      OPC_MoveParent,
      OPC_CheckPatternPredicate2,
      OPC_CheckComplexPat1, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 3, 4, 2, 3, 
     17, 
      OPC_CheckPredicate2, 
      OPC_MoveParent,
      OPC_CheckPatternPredicate2,
      OPC_CheckComplexPat1, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 3, 4, 2, 3, 
     0, 
    0, 
   0,
  7, 
   OPC_RecordChild0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_EXTEND_U_I32),
                 8, 1, 0, 
  0, 
 67|128,7, TARGET_VAL(ISD::STORE),
  OPC_RecordMemRef,
  OPC_RecordNode,
  OPC_Scope, 127|128,1, 
   OPC_MoveChild1,
   OPC_CheckOpcode, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),
   OPC_RecordChild0,
   OPC_Scope, 64, 
    OPC_CheckChild0Type, 39, 
    OPC_RecordChild1,
    OPC_MoveChild1,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_CheckPredicate, 18,
    OPC_CheckTypeI32,
    OPC_MoveParent,
    OPC_CheckTypeI32,
    OPC_MoveParent,
    OPC_RecordChild2,
    OPC_Scope, 23, 
     OPC_CheckChild2TypeI32,
     OPC_CheckPredicate4, 
     OPC_CheckPredicate, 14,
     OPC_CheckPredicate, 19,
     OPC_CheckPatternPredicate1,
     OPC_CheckComplexPat0, /*#*/3,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_EmitConvertToTarget2,
     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I8x16_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   5, 6, 4, 7, 5, 1, 
    23, 
     OPC_CheckChild2TypeI64,
     OPC_CheckPredicate4, 
     OPC_CheckPredicate, 14,
     OPC_CheckPredicate, 19,
     OPC_CheckPatternPredicate2,
     OPC_CheckComplexPat1, /*#*/3,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_EmitConvertToTarget2,
     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I8x16_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   5, 6, 4, 7, 5, 1, 
    0, 
   64, 
    OPC_CheckChild0Type, 50, 
    OPC_RecordChild1,
    OPC_MoveChild1,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_CheckPredicate, 13,
    OPC_CheckTypeI32,
    OPC_MoveParent,
    OPC_CheckTypeI32,
    OPC_MoveParent,
    OPC_RecordChild2,
    OPC_Scope, 23, 
     OPC_CheckChild2TypeI32,
     OPC_CheckPredicate4, 
     OPC_CheckPredicate, 14,
     OPC_CheckPredicate, 20,
     OPC_CheckPatternPredicate1,
     OPC_CheckComplexPat0, /*#*/3,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_EmitConvertToTarget2,
     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   5, 6, 4, 7, 5, 1, 
    23, 
     OPC_CheckChild2TypeI64,
     OPC_CheckPredicate4, 
     OPC_CheckPredicate, 14,
     OPC_CheckPredicate, 20,
     OPC_CheckPatternPredicate2,
     OPC_CheckComplexPat1, /*#*/3,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_EmitConvertToTarget2,
     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   5, 6, 4, 7, 5, 1, 
    0, 
   58, 
    OPC_CheckChild0Type, 60, 
    OPC_RecordChild1,
    OPC_MoveChild1,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_CheckPredicate, 11,
    OPC_CheckTypeI32,
    OPC_MoveParent,
    OPC_CheckTypeI32,
    OPC_MoveParent,
    OPC_RecordChild2,
    OPC_Scope, 20, 
     OPC_CheckChild2TypeI32,
     OPC_CheckPredicate4, 
     OPC_CheckPredicate5, 
     OPC_CheckPatternPredicate1,
     OPC_CheckComplexPat0, /*#*/3,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_EmitConvertToTarget2,
     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   5, 6, 4, 7, 5, 1, 
    20, 
     OPC_CheckChild2TypeI64,
     OPC_CheckPredicate4, 
     OPC_CheckPredicate5, 
     OPC_CheckPatternPredicate2,
     OPC_CheckComplexPat1, /*#*/3,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_EmitConvertToTarget2,
     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   5, 6, 4, 7, 5, 1, 
    0, 
   58, 
    OPC_CheckChild0Type, 78, 
    OPC_RecordChild1,
    OPC_MoveChild1,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_CheckPredicate, 12,
    OPC_CheckTypeI32,
    OPC_MoveParent,
    OPC_CheckTypeI64,
    OPC_MoveParent,
    OPC_RecordChild2,
    OPC_Scope, 20, 
     OPC_CheckChild2TypeI32,
     OPC_CheckPredicate4, 
     OPC_CheckPredicate5, 
     OPC_CheckPatternPredicate1,
     OPC_CheckComplexPat0, /*#*/3,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_EmitConvertToTarget2,
     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   5, 6, 4, 7, 5, 1, 
    20, 
     OPC_CheckChild2TypeI64,
     OPC_CheckPredicate4, 
     OPC_CheckPredicate5, 
     OPC_CheckPatternPredicate2,
     OPC_CheckComplexPat1, /*#*/3,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_EmitConvertToTarget2,
     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   5, 6, 4, 7, 5, 1, 
    0, 
   0, 
  60|128,5, 
   OPC_RecordChild1,
   OPC_Scope, 2|128,1, 
    OPC_CheckChild1TypeI32,
    OPC_RecordChild2,
    OPC_Scope, 62, 
     OPC_CheckChild2TypeI32,
     OPC_CheckPredicate4, 
     OPC_Scope, 16, 
      OPC_CheckPredicate5, 
      OPC_CheckPatternPredicate1,
      OPC_CheckComplexPat0, /*#*/2,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4, 5, 3, 4, 1, 
     40, 
      OPC_CheckPredicate, 14,
      OPC_Scope, 17, 
       OPC_CheckPredicate, 19,
       OPC_CheckPatternPredicate1,
       OPC_CheckComplexPat0, /*#*/2,
       OPC_EmitMergeInputChains1_0,
       OPC_EmitInteger32, 0, 
       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4, 5, 3, 4, 1, 
      17, 
       OPC_CheckPredicate, 20,
       OPC_CheckPatternPredicate1,
       OPC_CheckComplexPat0, /*#*/2,
       OPC_EmitMergeInputChains1_0,
       OPC_EmitInteger32, 0, 
       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4, 5, 3, 4, 1, 
      0, 
     0, 
    62, 
     OPC_CheckChild2TypeI64,
     OPC_CheckPredicate4, 
     OPC_Scope, 16, 
      OPC_CheckPredicate5, 
      OPC_CheckPatternPredicate2,
      OPC_CheckComplexPat1, /*#*/2,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4, 5, 3, 4, 1, 
     40, 
      OPC_CheckPredicate, 14,
      OPC_Scope, 17, 
       OPC_CheckPredicate, 19,
       OPC_CheckPatternPredicate2,
       OPC_CheckComplexPat1, /*#*/2,
       OPC_EmitMergeInputChains1_0,
       OPC_EmitInteger32, 0, 
       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4, 5, 3, 4, 1, 
      17, 
       OPC_CheckPredicate, 20,
       OPC_CheckPatternPredicate2,
       OPC_CheckComplexPat1, /*#*/2,
       OPC_EmitMergeInputChains1_0,
       OPC_EmitInteger32, 0, 
       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4, 5, 3, 4, 1, 
      0, 
     0, 
    0, 
   38|128,1, 
    OPC_CheckChild1TypeI64,
    OPC_RecordChild2,
    OPC_Scope, 80, 
     OPC_CheckChild2TypeI32,
     OPC_CheckPredicate4, 
     OPC_Scope, 16, 
      OPC_CheckPredicate5, 
      OPC_CheckPatternPredicate1,
      OPC_CheckComplexPat0, /*#*/2,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4, 5, 3, 4, 1, 
     58, 
      OPC_CheckPredicate, 14,
      OPC_Scope, 17, 
       OPC_CheckPredicate, 19,
       OPC_CheckPatternPredicate1,
       OPC_CheckComplexPat0, /*#*/2,
       OPC_EmitMergeInputChains1_0,
       OPC_EmitInteger32, 0, 
       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4, 5, 3, 4, 1, 
      17, 
       OPC_CheckPredicate, 20,
       OPC_CheckPatternPredicate1,
       OPC_CheckComplexPat0, /*#*/2,
       OPC_EmitMergeInputChains1_0,
       OPC_EmitInteger32, 0, 
       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4, 5, 3, 4, 1, 
      17, 
       OPC_CheckPredicate, 25,
       OPC_CheckPatternPredicate1,
       OPC_CheckComplexPat0, /*#*/2,
       OPC_EmitMergeInputChains1_0,
       OPC_EmitInteger32, 0, 
       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE32_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4, 5, 3, 4, 1, 
      0, 
     0, 
    80, 
     OPC_CheckChild2TypeI64,
     OPC_CheckPredicate4, 
     OPC_Scope, 16, 
      OPC_CheckPredicate5, 
      OPC_CheckPatternPredicate2,
      OPC_CheckComplexPat1, /*#*/2,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4, 5, 3, 4, 1, 
     58, 
      OPC_CheckPredicate, 14,
      OPC_Scope, 17, 
       OPC_CheckPredicate, 19,
       OPC_CheckPatternPredicate2,
       OPC_CheckComplexPat1, /*#*/2,
       OPC_EmitMergeInputChains1_0,
       OPC_EmitInteger32, 0, 
       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4, 5, 3, 4, 1, 
      17, 
       OPC_CheckPredicate, 20,
       OPC_CheckPatternPredicate2,
       OPC_CheckComplexPat1, /*#*/2,
       OPC_EmitMergeInputChains1_0,
       OPC_EmitInteger32, 0, 
       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4, 5, 3, 4, 1, 
      17, 
       OPC_CheckPredicate, 25,
       OPC_CheckPatternPredicate2,
       OPC_CheckComplexPat1, /*#*/2,
       OPC_EmitMergeInputChains1_0,
       OPC_EmitInteger32, 0, 
       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE32_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4, 5, 3, 4, 1, 
      0, 
     0, 
    0, 
   43, 
    OPC_CheckChild1Type, 12, 
    OPC_RecordChild2,
    OPC_Scope, 18, 
     OPC_CheckChild2TypeI32,
     OPC_CheckPredicate4, 
     OPC_CheckPredicate5, 
     OPC_CheckPatternPredicate1,
     OPC_CheckComplexPat0, /*#*/2,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4, 5, 3, 4, 1, 
    18, 
     OPC_CheckChild2TypeI64,
     OPC_CheckPredicate4, 
     OPC_CheckPredicate5, 
     OPC_CheckPatternPredicate2,
     OPC_CheckComplexPat1, /*#*/2,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4, 5, 3, 4, 1, 
    0, 
   43, 
    OPC_CheckChild1Type, 13, 
    OPC_RecordChild2,
    OPC_Scope, 18, 
     OPC_CheckChild2TypeI32,
     OPC_CheckPredicate4, 
     OPC_CheckPredicate5, 
     OPC_CheckPatternPredicate1,
     OPC_CheckComplexPat0, /*#*/2,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4, 5, 3, 4, 1, 
    18, 
     OPC_CheckChild2TypeI64,
     OPC_CheckPredicate4, 
     OPC_CheckPredicate5, 
     OPC_CheckPatternPredicate2,
     OPC_CheckComplexPat1, /*#*/2,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4, 5, 3, 4, 1, 
    0, 
   43, 
    OPC_CheckChild1Type, 39, 
    OPC_RecordChild2,
    OPC_Scope, 18, 
     OPC_CheckChild2TypeI32,
     OPC_CheckPredicate4, 
     OPC_CheckPredicate5, 
     OPC_CheckPatternPredicate1,
     OPC_CheckComplexPat0, /*#*/2,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4, 5, 3, 4, 1, 
    18, 
     OPC_CheckChild2TypeI64,
     OPC_CheckPredicate4, 
     OPC_CheckPredicate5, 
     OPC_CheckPatternPredicate2,
     OPC_CheckComplexPat1, /*#*/2,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4, 5, 3, 4, 1, 
    0, 
   43, 
    OPC_CheckChild1Type, 50, 
    OPC_RecordChild2,
    OPC_Scope, 18, 
     OPC_CheckChild2TypeI32,
     OPC_CheckPredicate4, 
     OPC_CheckPredicate5, 
     OPC_CheckPatternPredicate1,
     OPC_CheckComplexPat0, /*#*/2,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4, 5, 3, 4, 1, 
    18, 
     OPC_CheckChild2TypeI64,
     OPC_CheckPredicate4, 
     OPC_CheckPredicate5, 
     OPC_CheckPatternPredicate2,
     OPC_CheckComplexPat1, /*#*/2,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4, 5, 3, 4, 1, 
    0, 
   43, 
    OPC_CheckChild1Type, 60, 
    OPC_RecordChild2,
    OPC_Scope, 18, 
     OPC_CheckChild2TypeI32,
     OPC_CheckPredicate4, 
     OPC_CheckPredicate5, 
     OPC_CheckPatternPredicate1,
     OPC_CheckComplexPat0, /*#*/2,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4, 5, 3, 4, 1, 
    18, 
     OPC_CheckChild2TypeI64,
     OPC_CheckPredicate4, 
     OPC_CheckPredicate5, 
     OPC_CheckPatternPredicate2,
     OPC_CheckComplexPat1, /*#*/2,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4, 5, 3, 4, 1, 
    0, 
   43, 
    OPC_CheckChild1Type, 78, 
    OPC_RecordChild2,
    OPC_Scope, 18, 
     OPC_CheckChild2TypeI32,
     OPC_CheckPredicate4, 
     OPC_CheckPredicate5, 
     OPC_CheckPatternPredicate1,
     OPC_CheckComplexPat0, /*#*/2,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4, 5, 3, 4, 1, 
    18, 
     OPC_CheckChild2TypeI64,
     OPC_CheckPredicate4, 
     OPC_CheckPredicate5, 
     OPC_CheckPatternPredicate2,
     OPC_CheckComplexPat1, /*#*/2,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4, 5, 3, 4, 1, 
    0, 
   43, 
    OPC_CheckChild1Type, 111, 
    OPC_RecordChild2,
    OPC_Scope, 18, 
     OPC_CheckChild2TypeI32,
     OPC_CheckPredicate4, 
     OPC_CheckPredicate5, 
     OPC_CheckPatternPredicate1,
     OPC_CheckComplexPat0, /*#*/2,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4, 5, 3, 4, 1, 
    18, 
     OPC_CheckChild2TypeI64,
     OPC_CheckPredicate4, 
     OPC_CheckPredicate5, 
     OPC_CheckPatternPredicate2,
     OPC_CheckComplexPat1, /*#*/2,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4, 5, 3, 4, 1, 
    0, 
   44, 
    OPC_CheckChild1Type, 1|128,1, 
    OPC_RecordChild2,
    OPC_Scope, 18, 
     OPC_CheckChild2TypeI32,
     OPC_CheckPredicate4, 
     OPC_CheckPredicate5, 
     OPC_CheckPatternPredicate1,
     OPC_CheckComplexPat0, /*#*/2,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4, 5, 3, 4, 1, 
    18, 
     OPC_CheckChild2TypeI64,
     OPC_CheckPredicate4, 
     OPC_CheckPredicate5, 
     OPC_CheckPatternPredicate2,
     OPC_CheckComplexPat1, /*#*/2,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4, 5, 3, 4, 1, 
    0, 
   43, 
    OPC_CheckChild1Type, 92, 
    OPC_RecordChild2,
    OPC_Scope, 18, 
     OPC_CheckChild2TypeI32,
     OPC_CheckPredicate4, 
     OPC_CheckPredicate5, 
     OPC_CheckPatternPredicate1,
     OPC_CheckComplexPat0, /*#*/2,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4, 5, 3, 4, 1, 
    18, 
     OPC_CheckChild2TypeI64,
     OPC_CheckPredicate4, 
     OPC_CheckPredicate5, 
     OPC_CheckPatternPredicate2,
     OPC_CheckComplexPat1, /*#*/2,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4, 5, 3, 4, 1, 
    0, 
   0, 
  0, 
 7|128,2, TARGET_VAL(ISD::INTRINSIC_VOID),
  OPC_Scope, 40, 
   OPC_RecordNode,
   OPC_CheckChild1Integer, 12|128,74|128,1, 
   OPC_MoveChild2,
   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
   OPC_RecordChild0,
   OPC_MoveChild0,
   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
   OPC_MoveParent,
   OPC_MoveSibling3,
   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
   OPC_RecordChild0,
   OPC_MoveChild0,
   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
   OPC_MoveParent,
   OPC_MoveParent,
   OPC_RecordChild4,
   OPC_RecordChild5,
   OPC_RecordChild6,
   OPC_CheckPatternPredicate6,
   OPC_EmitMergeInputChains1_0,
   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_COPY),
                 5, 1, 2, 3, 4, 5, 
  44, 
   OPC_RecordMemRef,
   OPC_RecordNode,
   OPC_CheckChild1Integer, 8|128,74|128,1, 
   OPC_RecordChild2,
   OPC_RecordChild3,
   OPC_Scope, 16, 
    OPC_CheckChild3TypeI32,
    OPC_CheckPatternPredicate1,
    OPC_CheckComplexPat0, /*#*/2,
    OPC_EmitMergeInputChains1_0,
    OPC_EmitInteger32, 0, 
    OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F16_F32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  4, 5, 3, 4, 1, 
   16, 
    OPC_CheckChild3TypeI64,
    OPC_CheckPatternPredicate2,
    OPC_CheckComplexPat1, /*#*/2,
    OPC_EmitMergeInputChains1_0,
    OPC_EmitInteger32, 0, 
    OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F16_F32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  4, 5, 3, 4, 1, 
   0, 
  45|128,1, 
   OPC_RecordNode,
   OPC_Scope, 26, 
    OPC_CheckChild1Integer, 36|128,74|128,1, 
    OPC_MoveChild2,
    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
    OPC_RecordChild0,
    OPC_MoveChild0,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
    OPC_MoveParent,
    OPC_MoveParent,
    OPC_RecordChild3,
    OPC_RecordChild4,
    OPC_CheckPatternPredicate6,
    OPC_EmitMergeInputChains1_0,
    OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_SET_FUNCREF),
                  3, 1, 2, 3, 
   28, 
    OPC_CheckChild1Integer, 18|128,74|128,1, 
    OPC_MoveChild2,
    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
    OPC_RecordChild0,
    OPC_MoveChild0,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
    OPC_MoveParent,
    OPC_MoveParent,
    OPC_RecordChild3,
    OPC_RecordChild4,
    OPC_RecordChild5,
    OPC_CheckPatternPredicate6,
    OPC_EmitMergeInputChains1_0,
    OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_FILL_FUNCREF),
                  4, 1, 2, 3, 4, 
   26, 
    OPC_CheckChild1Integer, 34|128,74|128,1, 
    OPC_MoveChild2,
    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
    OPC_RecordChild0,
    OPC_MoveChild0,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
    OPC_MoveParent,
    OPC_MoveParent,
    OPC_RecordChild3,
    OPC_RecordChild4,
    OPC_CheckPatternPredicate6,
    OPC_EmitMergeInputChains1_0,
    OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_SET_EXTERNREF),
                  3, 1, 2, 3, 
   28, 
    OPC_CheckChild1Integer, 16|128,74|128,1, 
    OPC_MoveChild2,
    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
    OPC_RecordChild0,
    OPC_MoveChild0,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
    OPC_MoveParent,
    OPC_MoveParent,
    OPC_RecordChild3,
    OPC_RecordChild4,
    OPC_RecordChild5,
    OPC_CheckPatternPredicate6,
    OPC_EmitMergeInputChains1_0,
    OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_FILL_EXTERNREF),
                  4, 1, 2, 3, 4, 
   27, 
    OPC_CheckChild1Integer, 32|128,74|128,1, 
    OPC_MoveChild2,
    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
    OPC_RecordChild0,
    OPC_MoveChild0,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
    OPC_MoveParent,
    OPC_MoveParent,
    OPC_RecordChild3,
    OPC_RecordChild4,
    OPC_CheckPatternPredicate, 8,
    OPC_EmitMergeInputChains1_0,
    OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_SET_EXNREF),
                  3, 1, 2, 3, 
   29, 
    OPC_CheckChild1Integer, 14|128,74|128,1, 
    OPC_MoveChild2,
    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
    OPC_RecordChild0,
    OPC_MoveChild0,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
    OPC_MoveParent,
    OPC_MoveParent,
    OPC_RecordChild3,
    OPC_RecordChild4,
    OPC_RecordChild5,
    OPC_CheckPatternPredicate, 8,
    OPC_EmitMergeInputChains1_0,
    OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_FILL_EXNREF),
                  4, 1, 2, 3, 4, 
   0, 
  0, 
 81|128,3, TARGET_VAL(ISD::INTRINSIC_W_CHAIN),
  OPC_Scope, 22|128,1, 
   OPC_RecordMemRef,
   OPC_RecordNode,
   OPC_Scope, 45, 
    OPC_CheckChild1Integer, 68|128,73|128,1, 
    OPC_RecordChild2,
    OPC_Scope, 18, 
     OPC_CheckChild2TypeI32,
     OPC_RecordChild3,
     OPC_CheckPatternPredicate3,
     OPC_CheckComplexPat0, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_NOTIFY_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 4, 5, 3, 4, 2, 
    18, 
     OPC_CheckChild2TypeI64,
     OPC_RecordChild3,
     OPC_CheckPatternPredicate4,
     OPC_CheckComplexPat1, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_NOTIFY_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 4, 5, 3, 4, 2, 
    0, 
   49, 
    OPC_CheckChild1Integer, 70|128,73|128,1, 
    OPC_RecordChild2,
    OPC_Scope, 20, 
     OPC_CheckChild2TypeI32,
     OPC_RecordChild3,
     OPC_RecordChild4,
     OPC_CheckPatternPredicate3,
     OPC_CheckComplexPat0, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 5, 6, 4, 5, 2, 3, 
    20, 
     OPC_CheckChild2TypeI64,
     OPC_RecordChild3,
     OPC_RecordChild4,
     OPC_CheckPatternPredicate4,
     OPC_CheckComplexPat1, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 5, 6, 4, 5, 2, 3, 
    0, 
   49, 
    OPC_CheckChild1Integer, 72|128,73|128,1, 
    OPC_RecordChild2,
    OPC_Scope, 20, 
     OPC_CheckChild2TypeI32,
     OPC_RecordChild3,
     OPC_RecordChild4,
     OPC_CheckPatternPredicate3,
     OPC_CheckComplexPat0, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 5, 6, 4, 5, 2, 3, 
    20, 
     OPC_CheckChild2TypeI64,
     OPC_RecordChild3,
     OPC_RecordChild4,
     OPC_CheckPatternPredicate4,
     OPC_CheckComplexPat1, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 5, 6, 4, 5, 2, 3, 
    0, 
   0, 
  9|128,2, 
   OPC_RecordNode,
   OPC_Scope, 26, 
    OPC_CheckChild1Integer, 24|128,74|128,1, 
    OPC_MoveChild2,
    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
    OPC_RecordChild0,
    OPC_MoveChild0,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
    OPC_MoveParent,
    OPC_MoveParent,
    OPC_RecordChild3,
    OPC_CheckPatternPredicate6,
    OPC_EmitMergeInputChains1_0,
    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_GET_FUNCREF),
                  99|128,1, 2, 1, 2, 
   27, 
    OPC_CheckChild1Integer, 30|128,74|128,1, 
    OPC_MoveChild2,
    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
    OPC_RecordChild0,
    OPC_MoveChild0,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
    OPC_MoveParent,
    OPC_MoveParent,
    OPC_RecordChild3,
    OPC_RecordChild4,
    OPC_CheckPatternPredicate6,
    OPC_EmitMergeInputChains1_0,
    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_GROW_FUNCREF),
                  7, 3, 1, 2, 3, 
   26, 
    OPC_CheckChild1Integer, 22|128,74|128,1, 
    OPC_MoveChild2,
    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
    OPC_RecordChild0,
    OPC_MoveChild0,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
    OPC_MoveParent,
    OPC_MoveParent,
    OPC_RecordChild3,
    OPC_CheckPatternPredicate6,
    OPC_EmitMergeInputChains1_0,
    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_GET_EXTERNREF),
                  100|128,1, 2, 1, 2, 
   27, 
    OPC_CheckChild1Integer, 28|128,74|128,1, 
    OPC_MoveChild2,
    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
    OPC_RecordChild0,
    OPC_MoveChild0,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
    OPC_MoveParent,
    OPC_MoveParent,
    OPC_RecordChild3,
    OPC_RecordChild4,
    OPC_CheckPatternPredicate6,
    OPC_EmitMergeInputChains1_0,
    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_GROW_EXTERNREF),
                  7, 3, 1, 2, 3, 
   27, 
    OPC_CheckChild1Integer, 20|128,74|128,1, 
    OPC_MoveChild2,
    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
    OPC_RecordChild0,
    OPC_MoveChild0,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
    OPC_MoveParent,
    OPC_MoveParent,
    OPC_RecordChild3,
    OPC_CheckPatternPredicate, 8,
    OPC_EmitMergeInputChains1_0,
    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_GET_EXNREF),
                  101|128,1, 2, 1, 2, 
   28, 
    OPC_CheckChild1Integer, 26|128,74|128,1, 
    OPC_MoveChild2,
    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
    OPC_RecordChild0,
    OPC_MoveChild0,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
    OPC_MoveParent,
    OPC_MoveParent,
    OPC_RecordChild3,
    OPC_RecordChild4,
    OPC_CheckPatternPredicate, 8,
    OPC_EmitMergeInputChains1_0,
    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_GROW_EXNREF),
                  7, 3, 1, 2, 3, 
   23, 
    OPC_CheckChild1Integer, 38|128,74|128,1, 
    OPC_MoveChild2,
    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
    OPC_RecordChild0,
    OPC_MoveChild0,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
    OPC_MoveParent,
    OPC_MoveParent,
    OPC_CheckPatternPredicate6,
    OPC_EmitMergeInputChains1_0,
    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_SIZE),
                  7, 1, 1, 
   32, 
    OPC_CheckChild1Integer, 76|128,73|128,1, 
    OPC_RecordChild2,
    OPC_MoveChild2,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_MoveParent,
    OPC_SwitchType , 8, 7, 
     OPC_EmitMergeInputChains1_0,
     OPC_EmitConvertToTarget1,
     OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::anonymous_8526MEMORY_SIZE_A32),
                   7, 1, 2, 
    8, 8, 
     OPC_EmitMergeInputChains1_0,
     OPC_EmitConvertToTarget1,
     OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::anonymous_8527MEMORY_SIZE_A64),
                   8, 1, 2, 
    0,
   37, 
    OPC_CheckChild1Integer, 74|128,73|128,1, 
    OPC_RecordChild2,
    OPC_MoveChild2,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_MoveParent,
    OPC_RecordChild3,
    OPC_SwitchType , 10, 7, 
     OPC_CheckChild3TypeI32,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitConvertToTarget1,
     OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::anonymous_8526MEMORY_GROW_A32),
                   7, 2, 3, 2, 
    10, 8, 
     OPC_CheckChild3TypeI64,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitConvertToTarget1,
     OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::anonymous_8527MEMORY_GROW_A64),
                   8, 2, 3, 2, 
    0,
   0, 
  43, 
   OPC_RecordMemRef,
   OPC_RecordNode,
   OPC_CheckChild1Integer, 64|128,73|128,1, 
   OPC_RecordChild2,
   OPC_Scope, 16, 
    OPC_CheckChild2TypeI32,
    OPC_CheckPatternPredicate1,
    OPC_CheckComplexPat0, /*#*/1,
    OPC_EmitMergeInputChains1_0,
    OPC_EmitInteger32, 0, 
    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F16_F32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  12, 3, 4, 2, 3, 
   16, 
    OPC_CheckChild2TypeI64,
    OPC_CheckPatternPredicate2,
    OPC_CheckComplexPat1, /*#*/1,
    OPC_EmitMergeInputChains1_0,
    OPC_EmitInteger32, 0, 
    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F16_F32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  12, 3, 4, 2, 3, 
   0, 
  0, 
 29|128,2, TARGET_VAL(ISD::ATOMIC_STORE),
  OPC_RecordMemRef,
  OPC_RecordNode,
  OPC_Scope, 119, 
   OPC_MoveChild1,
   OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
   OPC_RecordChild0,
   OPC_MoveParent,
   OPC_RecordChild2,
   OPC_Scope, 54, 
    OPC_CheckChild2TypeI32,
    OPC_Scope, 16, 
     OPC_CheckPredicate1, 
     OPC_CheckPatternPredicate3,
     OPC_CheckComplexPat0, /*#*/2,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4, 5, 3, 4, 1, 
    16, 
     OPC_CheckPredicate2, 
     OPC_CheckPatternPredicate3,
     OPC_CheckComplexPat0, /*#*/2,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4, 5, 3, 4, 1, 
    16, 
     OPC_CheckPredicate3, 
     OPC_CheckPatternPredicate3,
     OPC_CheckComplexPat0, /*#*/2,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE32_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4, 5, 3, 4, 1, 
    0, 
   54, 
    OPC_CheckChild2TypeI64,
    OPC_Scope, 16, 
     OPC_CheckPredicate1, 
     OPC_CheckPatternPredicate4,
     OPC_CheckComplexPat1, /*#*/2,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4, 5, 3, 4, 1, 
    16, 
     OPC_CheckPredicate2, 
     OPC_CheckPatternPredicate4,
     OPC_CheckComplexPat1, /*#*/2,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4, 5, 3, 4, 1, 
    16, 
     OPC_CheckPredicate3, 
     OPC_CheckPatternPredicate4,
     OPC_CheckComplexPat1, /*#*/2,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE32_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4, 5, 3, 4, 1, 
    0, 
   0, 
  31|128,1, 
   OPC_RecordChild1,
   OPC_Scope, 114, 
    OPC_CheckChild1TypeI32,
    OPC_RecordChild2,
    OPC_Scope, 54, 
     OPC_CheckChild2TypeI32,
     OPC_Scope, 16, 
      OPC_CheckPredicate3, 
      OPC_CheckPatternPredicate3,
      OPC_CheckComplexPat0, /*#*/2,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4, 5, 3, 4, 1, 
     16, 
      OPC_CheckPredicate1, 
      OPC_CheckPatternPredicate3,
      OPC_CheckComplexPat0, /*#*/2,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4, 5, 3, 4, 1, 
     16, 
      OPC_CheckPredicate2, 
      OPC_CheckPatternPredicate3,
      OPC_CheckComplexPat0, /*#*/2,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4, 5, 3, 4, 1, 
     0, 
    54, 
     OPC_CheckChild2TypeI64,
     OPC_Scope, 16, 
      OPC_CheckPredicate3, 
      OPC_CheckPatternPredicate4,
      OPC_CheckComplexPat1, /*#*/2,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4, 5, 3, 4, 1, 
     16, 
      OPC_CheckPredicate1, 
      OPC_CheckPatternPredicate4,
      OPC_CheckComplexPat1, /*#*/2,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4, 5, 3, 4, 1, 
     16, 
      OPC_CheckPredicate2, 
      OPC_CheckPatternPredicate4,
      OPC_CheckComplexPat1, /*#*/2,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4, 5, 3, 4, 1, 
     0, 
    0, 
   40, 
    OPC_CheckChild1TypeI64,
    OPC_RecordChild2,
    OPC_Scope, 17, 
     OPC_CheckChild2TypeI32,
     OPC_CheckPredicate7, 
     OPC_CheckPatternPredicate3,
     OPC_CheckComplexPat0, /*#*/2,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4, 5, 3, 4, 1, 
    17, 
     OPC_CheckChild2TypeI64,
     OPC_CheckPredicate7, 
     OPC_CheckPatternPredicate4,
     OPC_CheckComplexPat1, /*#*/2,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4, 5, 3, 4, 1, 
    0, 
   0, 
  0, 
 90|128,2, TARGET_VAL(ISD::AND),
  OPC_Scope, 118, 
   OPC_MoveChild0,
   OPC_CheckOpcode, TARGET_VAL(ISD::INTRINSIC_WO_CHAIN),
   OPC_Scope, 55, 
    OPC_CheckChild0Integer, 40|128,73|128,1, 
    OPC_RecordChild1,
    OPC_Scope, 11, 
     OPC_CheckChild1Type, 39, 
     OPC_MoveParent,
     OPC_CheckChild1Integer, 2, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                   7, 1, 0, 
    11, 
     OPC_CheckChild1Type, 50, 
     OPC_MoveParent,
     OPC_CheckChild1Integer, 2, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                   7, 1, 0, 
    11, 
     OPC_CheckChild1Type, 60, 
     OPC_MoveParent,
     OPC_CheckChild1Integer, 2, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                   7, 1, 0, 
    11, 
     OPC_CheckChild1Type, 78, 
     OPC_MoveParent,
     OPC_CheckChild1Integer, 2, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                   7, 1, 0, 
    0, 
   55, 
    OPC_CheckChild0Integer, 38|128,73|128,1, 
    OPC_RecordChild1,
    OPC_Scope, 11, 
     OPC_CheckChild1Type, 39, 
     OPC_MoveParent,
     OPC_CheckChild1Integer, 2, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I8x16),
                   7, 1, 0, 
    11, 
     OPC_CheckChild1Type, 50, 
     OPC_MoveParent,
     OPC_CheckChild1Integer, 2, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I16x8),
                   7, 1, 0, 
    11, 
     OPC_CheckChild1Type, 60, 
     OPC_MoveParent,
     OPC_CheckChild1Integer, 2, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I32x4),
                   7, 1, 0, 
    11, 
     OPC_CheckChild1Type, 78, 
     OPC_MoveParent,
     OPC_CheckChild1Integer, 2, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I64x2),
                   7, 1, 0, 
    0, 
   0, 
  29, 
   OPC_CheckAndImm, 127|128,1, 
   OPC_MoveChild0,
   OPC_CheckOpcode, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),
   OPC_RecordChild0,
   OPC_CheckChild0Type, 39, 
   OPC_RecordChild1,
   OPC_MoveChild1,
   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
   OPC_CheckPredicate, 18,
   OPC_CheckTypeI32,
   OPC_MoveParent,
   OPC_MoveParent,
   OPC_CheckTypeI32,
   OPC_EmitConvertToTarget1,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I8x16_u),
                 7, 2, 0, 2, 
  30, 
   OPC_CheckAndImm, 127|128,127|128,3, 
   OPC_MoveChild0,
   OPC_CheckOpcode, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),
   OPC_RecordChild0,
   OPC_CheckChild0Type, 50, 
   OPC_RecordChild1,
   OPC_MoveChild1,
   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
   OPC_CheckPredicate, 13,
   OPC_CheckTypeI32,
   OPC_MoveParent,
   OPC_MoveParent,
   OPC_CheckTypeI32,
   OPC_EmitConvertToTarget1,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I16x8_u),
                 7, 2, 0, 2, 
  73, 
   OPC_RecordChild0,
   OPC_Scope, 21, 
    OPC_RecordChild1,
    OPC_SwitchType , 7, 7, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AND_I32),
                   7, 2, 0, 1, 
    7, 8, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AND_I64),
                   8, 2, 0, 1, 
    0,
   47, 
    OPC_MoveChild1,
    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
    OPC_RecordChild0,
    OPC_MoveChild1,
    OPC_CheckImmAllOnesV,
    OPC_MoveParent,
    OPC_MoveParent,
    OPC_SwitchType , 7, 39, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                   39, 2, 0, 1, 
    7, 50, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                   50, 2, 0, 1, 
    7, 60, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                   60, 2, 0, 1, 
    7, 78, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                   78, 2, 0, 1, 
    0,
   0, 
  48, 
   OPC_MoveChild0,
   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
   OPC_RecordChild0,
   OPC_MoveChild1,
   OPC_CheckImmAllOnesV,
   OPC_MoveParent,
   OPC_MoveParent,
   OPC_RecordChild1,
   OPC_SwitchType , 7, 39, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                  39, 2, 1, 0, 
   7, 50, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                  50, 2, 1, 0, 
   7, 60, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                  60, 2, 1, 0, 
   7, 78, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                  78, 2, 1, 0, 
   0,
  40, 
   OPC_RecordChild0,
   OPC_RecordChild1,
   OPC_SwitchType , 7, 39, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AND),
                  39, 2, 0, 1, 
   7, 50, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AND),
                  50, 2, 0, 1, 
   7, 60, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AND),
                  60, 2, 0, 1, 
   7, 78, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AND),
                  78, 2, 0, 1, 
   0,
  0, 
 125|128,11, TARGET_VAL(ISD::SETCC),
  OPC_Scope, 126|128,1, 
   OPC_MoveChild0,
   OPC_CheckOpcode, TARGET_VAL(ISD::INTRINSIC_WO_CHAIN),
   OPC_Scope, 123, 
    OPC_CheckChild0Integer, 40|128,73|128,1, 
    OPC_RecordChild1,
    OPC_Scope, 28, 
     OPC_CheckChild1Type, 39, 
     OPC_MoveParent,
     OPC_CheckTypeI32,
     OPC_Scope, 10, 
      OPC_CheckChild1Integer, 0, 
      OPC_CheckChild2CondCode, ISD::SETNE,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    7, 1, 0, 
     10, 
      OPC_CheckChild1Integer, 2, 
      OPC_CheckChild2CondCode, ISD::SETEQ,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    7, 1, 0, 
     0, 
    28, 
     OPC_CheckChild1Type, 50, 
     OPC_MoveParent,
     OPC_CheckTypeI32,
     OPC_Scope, 10, 
      OPC_CheckChild1Integer, 0, 
      OPC_CheckChild2CondCode, ISD::SETNE,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    7, 1, 0, 
     10, 
      OPC_CheckChild1Integer, 2, 
      OPC_CheckChild2CondCode, ISD::SETEQ,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    7, 1, 0, 
     0, 
    28, 
     OPC_CheckChild1Type, 60, 
     OPC_MoveParent,
     OPC_CheckTypeI32,
     OPC_Scope, 10, 
      OPC_CheckChild1Integer, 0, 
      OPC_CheckChild2CondCode, ISD::SETNE,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    7, 1, 0, 
     10, 
      OPC_CheckChild1Integer, 2, 
      OPC_CheckChild2CondCode, ISD::SETEQ,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    7, 1, 0, 
     0, 
    28, 
     OPC_CheckChild1Type, 78, 
     OPC_MoveParent,
     OPC_CheckTypeI32,
     OPC_Scope, 10, 
      OPC_CheckChild1Integer, 0, 
      OPC_CheckChild2CondCode, ISD::SETNE,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    7, 1, 0, 
     10, 
      OPC_CheckChild1Integer, 2, 
      OPC_CheckChild2CondCode, ISD::SETEQ,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    7, 1, 0, 
     0, 
    0, 
   123, 
    OPC_CheckChild0Integer, 38|128,73|128,1, 
    OPC_RecordChild1,
    OPC_Scope, 28, 
     OPC_CheckChild1Type, 39, 
     OPC_MoveParent,
     OPC_CheckTypeI32,
     OPC_Scope, 10, 
      OPC_CheckChild1Integer, 0, 
      OPC_CheckChild2CondCode, ISD::SETNE,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I8x16),
                    7, 1, 0, 
     10, 
      OPC_CheckChild1Integer, 2, 
      OPC_CheckChild2CondCode, ISD::SETEQ,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I8x16),
                    7, 1, 0, 
     0, 
    28, 
     OPC_CheckChild1Type, 50, 
     OPC_MoveParent,
     OPC_CheckTypeI32,
     OPC_Scope, 10, 
      OPC_CheckChild1Integer, 0, 
      OPC_CheckChild2CondCode, ISD::SETNE,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I16x8),
                    7, 1, 0, 
     10, 
      OPC_CheckChild1Integer, 2, 
      OPC_CheckChild2CondCode, ISD::SETEQ,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I16x8),
                    7, 1, 0, 
     0, 
    28, 
     OPC_CheckChild1Type, 60, 
     OPC_MoveParent,
     OPC_CheckTypeI32,
     OPC_Scope, 10, 
      OPC_CheckChild1Integer, 0, 
      OPC_CheckChild2CondCode, ISD::SETNE,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I32x4),
                    7, 1, 0, 
     10, 
      OPC_CheckChild1Integer, 2, 
      OPC_CheckChild2CondCode, ISD::SETEQ,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I32x4),
                    7, 1, 0, 
     0, 
    28, 
     OPC_CheckChild1Type, 78, 
     OPC_MoveParent,
     OPC_CheckTypeI32,
     OPC_Scope, 10, 
      OPC_CheckChild1Integer, 0, 
      OPC_CheckChild2CondCode, ISD::SETNE,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I64x2),
                    7, 1, 0, 
     10, 
      OPC_CheckChild1Integer, 2, 
      OPC_CheckChild2CondCode, ISD::SETEQ,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I64x2),
                    7, 1, 0, 
     0, 
    0, 
   0, 
  121|128,9, 
   OPC_RecordChild0,
   OPC_SwitchType , 108|128,3, 7, 
    OPC_Scope, 118, 
     OPC_CheckChild0TypeI32,
     OPC_Scope, 10, 
      OPC_CheckChild1Integer, 0, 
      OPC_CheckChild2CondCode, ISD::SETEQ,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQZ_I32),
                    7, 1, 0, 
     103, 
      OPC_RecordChild1,
      OPC_Scope, 9, 
       OPC_CheckChild2CondCode, ISD::SETEQ,
       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_I32),
                     7, 2, 0, 1, 
      9, 
       OPC_CheckChild2CondCode, ISD::SETNE,
       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_I32),
                     7, 2, 0, 1, 
      9, 
       OPC_CheckChild2CondCode, ISD::SETLT,
       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_S_I32),
                     7, 2, 0, 1, 
      9, 
       OPC_CheckChild2CondCode, ISD::SETULT,
       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_U_I32),
                     7, 2, 0, 1, 
      9, 
       OPC_CheckChild2CondCode, ISD::SETGT,
       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_S_I32),
                     7, 2, 0, 1, 
      9, 
       OPC_CheckChild2CondCode, ISD::SETUGT,
       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_U_I32),
                     7, 2, 0, 1, 
      9, 
       OPC_CheckChild2CondCode, ISD::SETLE,
       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_S_I32),
                     7, 2, 0, 1, 
      9, 
       OPC_CheckChild2CondCode, ISD::SETULE,
       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_U_I32),
                     7, 2, 0, 1, 
      9, 
       OPC_CheckChild2CondCode, ISD::SETGE,
       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_S_I32),
                     7, 2, 0, 1, 
      9, 
       OPC_CheckChild2CondCode, ISD::SETUGE,
       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_U_I32),
                     7, 2, 0, 1, 
      0, 
     0, 
    118, 
     OPC_CheckChild0TypeI64,
     OPC_Scope, 10, 
      OPC_CheckChild1Integer, 0, 
      OPC_CheckChild2CondCode, ISD::SETEQ,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQZ_I64),
                    7, 1, 0, 
     103, 
      OPC_RecordChild1,
      OPC_Scope, 9, 
       OPC_CheckChild2CondCode, ISD::SETEQ,
       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_I64),
                     7, 2, 0, 1, 
      9, 
       OPC_CheckChild2CondCode, ISD::SETNE,
       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_I64),
                     7, 2, 0, 1, 
      9, 
       OPC_CheckChild2CondCode, ISD::SETLT,
       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_S_I64),
                     7, 2, 0, 1, 
      9, 
       OPC_CheckChild2CondCode, ISD::SETULT,
       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_U_I64),
                     7, 2, 0, 1, 
      9, 
       OPC_CheckChild2CondCode, ISD::SETGT,
       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_S_I64),
                     7, 2, 0, 1, 
      9, 
       OPC_CheckChild2CondCode, ISD::SETUGT,
       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_U_I64),
                     7, 2, 0, 1, 
      9, 
       OPC_CheckChild2CondCode, ISD::SETLE,
       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_S_I64),
                     7, 2, 0, 1, 
      9, 
       OPC_CheckChild2CondCode, ISD::SETULE,
       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_U_I64),
                     7, 2, 0, 1, 
      9, 
       OPC_CheckChild2CondCode, ISD::SETGE,
       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_S_I64),
                     7, 2, 0, 1, 
      9, 
       OPC_CheckChild2CondCode, ISD::SETUGE,
       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_U_I64),
                     7, 2, 0, 1, 
      0, 
     0, 
    125, 
     OPC_CheckChild0Type, 12, 
     OPC_RecordChild1,
     OPC_Scope, 9, 
      OPC_CheckChild2CondCode, ISD::SETOEQ,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F32),
                    7, 2, 0, 1, 
     9, 
      OPC_CheckChild2CondCode, ISD::SETUNE,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F32),
                    7, 2, 0, 1, 
     9, 
      OPC_CheckChild2CondCode, ISD::SETOLT,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F32),
                    7, 2, 0, 1, 
     9, 
      OPC_CheckChild2CondCode, ISD::SETOLE,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F32),
                    7, 2, 0, 1, 
     9, 
      OPC_CheckChild2CondCode, ISD::SETOGT,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F32),
                    7, 2, 0, 1, 
     9, 
      OPC_CheckChild2CondCode, ISD::SETOGE,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F32),
                    7, 2, 0, 1, 
     9, 
      OPC_CheckChild2CondCode, ISD::SETEQ,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F32),
                    7, 2, 0, 1, 
     9, 
      OPC_CheckChild2CondCode, ISD::SETNE,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F32),
                    7, 2, 0, 1, 
     9, 
      OPC_CheckChild2CondCode, ISD::SETLT,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F32),
                    7, 2, 0, 1, 
     9, 
      OPC_CheckChild2CondCode, ISD::SETLE,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F32),
                    7, 2, 0, 1, 
     9, 
      OPC_CheckChild2CondCode, ISD::SETGT,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F32),
                    7, 2, 0, 1, 
     9, 
      OPC_CheckChild2CondCode, ISD::SETGE,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F32),
                    7, 2, 0, 1, 
     0, 
    125, 
     OPC_CheckChild0Type, 13, 
     OPC_RecordChild1,
     OPC_Scope, 9, 
      OPC_CheckChild2CondCode, ISD::SETOEQ,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F64),
                    7, 2, 0, 1, 
     9, 
      OPC_CheckChild2CondCode, ISD::SETUNE,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F64),
                    7, 2, 0, 1, 
     9, 
      OPC_CheckChild2CondCode, ISD::SETOLT,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F64),
                    7, 2, 0, 1, 
     9, 
      OPC_CheckChild2CondCode, ISD::SETOLE,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F64),
                    7, 2, 0, 1, 
     9, 
      OPC_CheckChild2CondCode, ISD::SETOGT,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F64),
                    7, 2, 0, 1, 
     9, 
      OPC_CheckChild2CondCode, ISD::SETOGE,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F64),
                    7, 2, 0, 1, 
     9, 
      OPC_CheckChild2CondCode, ISD::SETEQ,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F64),
                    7, 2, 0, 1, 
     9, 
      OPC_CheckChild2CondCode, ISD::SETNE,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F64),
                    7, 2, 0, 1, 
     9, 
      OPC_CheckChild2CondCode, ISD::SETLT,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F64),
                    7, 2, 0, 1, 
     9, 
      OPC_CheckChild2CondCode, ISD::SETLE,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F64),
                    7, 2, 0, 1, 
     9, 
      OPC_CheckChild2CondCode, ISD::SETGT,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F64),
                    7, 2, 0, 1, 
     9, 
      OPC_CheckChild2CondCode, ISD::SETGE,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F64),
                    7, 2, 0, 1, 
     0, 
    0, 
   115, 39, 
    OPC_CheckChild0Type, 39, 
    OPC_RecordChild1,
    OPC_Scope, 10, 
     OPC_CheckChild2CondCode, ISD::SETEQ,
     OPC_CheckPatternPredicate0,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_I8x16),
                   39, 2, 0, 1, 
    10, 
     OPC_CheckChild2CondCode, ISD::SETNE,
     OPC_CheckPatternPredicate0,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_I8x16),
                   39, 2, 0, 1, 
    10, 
     OPC_CheckChild2CondCode, ISD::SETLT,
     OPC_CheckPatternPredicate0,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_S_I8x16),
                   39, 2, 0, 1, 
    10, 
     OPC_CheckChild2CondCode, ISD::SETULT,
     OPC_CheckPatternPredicate0,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_U_I8x16),
                   39, 2, 0, 1, 
    10, 
     OPC_CheckChild2CondCode, ISD::SETGT,
     OPC_CheckPatternPredicate0,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_S_I8x16),
                   39, 2, 0, 1, 
    10, 
     OPC_CheckChild2CondCode, ISD::SETUGT,
     OPC_CheckPatternPredicate0,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_U_I8x16),
                   39, 2, 0, 1, 
    10, 
     OPC_CheckChild2CondCode, ISD::SETLE,
     OPC_CheckPatternPredicate0,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_S_I8x16),
                   39, 2, 0, 1, 
    10, 
     OPC_CheckChild2CondCode, ISD::SETULE,
     OPC_CheckPatternPredicate0,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_U_I8x16),
                   39, 2, 0, 1, 
    10, 
     OPC_CheckChild2CondCode, ISD::SETGE,
     OPC_CheckPatternPredicate0,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_S_I8x16),
                   39, 2, 0, 1, 
    10, 
     OPC_CheckChild2CondCode, ISD::SETUGE,
     OPC_CheckPatternPredicate0,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_U_I8x16),
                   39, 2, 0, 1, 
    0, 
   62|128,1, 50, 
    OPC_Scope, 115, 
     OPC_CheckChild0Type, 50, 
     OPC_RecordChild1,
     OPC_Scope, 10, 
      OPC_CheckChild2CondCode, ISD::SETEQ,
      OPC_CheckPatternPredicate0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_I16x8),
                    50, 2, 0, 1, 
     10, 
      OPC_CheckChild2CondCode, ISD::SETNE,
      OPC_CheckPatternPredicate0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_I16x8),
                    50, 2, 0, 1, 
     10, 
      OPC_CheckChild2CondCode, ISD::SETLT,
      OPC_CheckPatternPredicate0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_S_I16x8),
                    50, 2, 0, 1, 
     10, 
      OPC_CheckChild2CondCode, ISD::SETULT,
      OPC_CheckPatternPredicate0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_U_I16x8),
                    50, 2, 0, 1, 
     10, 
      OPC_CheckChild2CondCode, ISD::SETGT,
      OPC_CheckPatternPredicate0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_S_I16x8),
                    50, 2, 0, 1, 
     10, 
      OPC_CheckChild2CondCode, ISD::SETUGT,
      OPC_CheckPatternPredicate0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_U_I16x8),
                    50, 2, 0, 1, 
     10, 
      OPC_CheckChild2CondCode, ISD::SETLE,
      OPC_CheckPatternPredicate0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_S_I16x8),
                    50, 2, 0, 1, 
     10, 
      OPC_CheckChild2CondCode, ISD::SETULE,
      OPC_CheckPatternPredicate0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_U_I16x8),
                    50, 2, 0, 1, 
     10, 
      OPC_CheckChild2CondCode, ISD::SETGE,
      OPC_CheckPatternPredicate0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_S_I16x8),
                    50, 2, 0, 1, 
     10, 
      OPC_CheckChild2CondCode, ISD::SETUGE,
      OPC_CheckPatternPredicate0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_U_I16x8),
                    50, 2, 0, 1, 
     0, 
    71, 
     OPC_CheckChild0Type, 92, 
     OPC_RecordChild1,
     OPC_Scope, 10, 
      OPC_CheckChild2CondCode, ISD::SETOEQ,
      OPC_CheckPatternPredicate5,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F16x8),
                    50, 2, 0, 1, 
     10, 
      OPC_CheckChild2CondCode, ISD::SETUNE,
      OPC_CheckPatternPredicate5,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F16x8),
                    50, 2, 0, 1, 
     10, 
      OPC_CheckChild2CondCode, ISD::SETOLT,
      OPC_CheckPatternPredicate5,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F16x8),
                    50, 2, 0, 1, 
     10, 
      OPC_CheckChild2CondCode, ISD::SETOGT,
      OPC_CheckPatternPredicate5,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F16x8),
                    50, 2, 0, 1, 
     10, 
      OPC_CheckChild2CondCode, ISD::SETOLE,
      OPC_CheckPatternPredicate5,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F16x8),
                    50, 2, 0, 1, 
     10, 
      OPC_CheckChild2CondCode, ISD::SETOGE,
      OPC_CheckPatternPredicate5,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F16x8),
                    50, 2, 0, 1, 
     0, 
    0, 
   123|128,1, 60, 
    OPC_Scope, 115, 
     OPC_CheckChild0Type, 60, 
     OPC_RecordChild1,
     OPC_Scope, 10, 
      OPC_CheckChild2CondCode, ISD::SETEQ,
      OPC_CheckPatternPredicate0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_I32x4),
                    60, 2, 0, 1, 
     10, 
      OPC_CheckChild2CondCode, ISD::SETNE,
      OPC_CheckPatternPredicate0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_I32x4),
                    60, 2, 0, 1, 
     10, 
      OPC_CheckChild2CondCode, ISD::SETLT,
      OPC_CheckPatternPredicate0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_S_I32x4),
                    60, 2, 0, 1, 
     10, 
      OPC_CheckChild2CondCode, ISD::SETULT,
      OPC_CheckPatternPredicate0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_U_I32x4),
                    60, 2, 0, 1, 
     10, 
      OPC_CheckChild2CondCode, ISD::SETGT,
      OPC_CheckPatternPredicate0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_S_I32x4),
                    60, 2, 0, 1, 
     10, 
      OPC_CheckChild2CondCode, ISD::SETUGT,
      OPC_CheckPatternPredicate0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_U_I32x4),
                    60, 2, 0, 1, 
     10, 
      OPC_CheckChild2CondCode, ISD::SETLE,
      OPC_CheckPatternPredicate0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_S_I32x4),
                    60, 2, 0, 1, 
     10, 
      OPC_CheckChild2CondCode, ISD::SETULE,
      OPC_CheckPatternPredicate0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_U_I32x4),
                    60, 2, 0, 1, 
     10, 
      OPC_CheckChild2CondCode, ISD::SETGE,
      OPC_CheckPatternPredicate0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_S_I32x4),
                    60, 2, 0, 1, 
     10, 
      OPC_CheckChild2CondCode, ISD::SETUGE,
      OPC_CheckPatternPredicate0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_U_I32x4),
                    60, 2, 0, 1, 
     0, 
    3|128,1, 
     OPC_CheckChild0Type, 111, 
     OPC_RecordChild1,
     OPC_Scope, 10, 
      OPC_CheckChild2CondCode, ISD::SETOEQ,
      OPC_CheckPatternPredicate0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F32x4),
                    60, 2, 0, 1, 
     10, 
      OPC_CheckChild2CondCode, ISD::SETUNE,
      OPC_CheckPatternPredicate0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F32x4),
                    60, 2, 0, 1, 
     10, 
      OPC_CheckChild2CondCode, ISD::SETOLT,
      OPC_CheckPatternPredicate0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F32x4),
                    60, 2, 0, 1, 
     10, 
      OPC_CheckChild2CondCode, ISD::SETOGT,
      OPC_CheckPatternPredicate0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F32x4),
                    60, 2, 0, 1, 
     10, 
      OPC_CheckChild2CondCode, ISD::SETOLE,
      OPC_CheckPatternPredicate0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F32x4),
                    60, 2, 0, 1, 
     10, 
      OPC_CheckChild2CondCode, ISD::SETOGE,
      OPC_CheckPatternPredicate0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F32x4),
                    60, 2, 0, 1, 
     9, 
      OPC_CheckChild2CondCode, ISD::SETEQ,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F32x4),
                    60, 2, 0, 1, 
     9, 
      OPC_CheckChild2CondCode, ISD::SETNE,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F32x4),
                    60, 2, 0, 1, 
     9, 
      OPC_CheckChild2CondCode, ISD::SETLT,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F32x4),
                    60, 2, 0, 1, 
     9, 
      OPC_CheckChild2CondCode, ISD::SETGT,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F32x4),
                    60, 2, 0, 1, 
     9, 
      OPC_CheckChild2CondCode, ISD::SETLE,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F32x4),
                    60, 2, 0, 1, 
     9, 
      OPC_CheckChild2CondCode, ISD::SETGE,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F32x4),
                    60, 2, 0, 1, 
     0, 
    0, 
   80|128,1, 78, 
    OPC_Scope, 71, 
     OPC_CheckChild0Type, 78, 
     OPC_RecordChild1,
     OPC_Scope, 10, 
      OPC_CheckChild2CondCode, ISD::SETEQ,
      OPC_CheckPatternPredicate0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_I64x2),
                    78, 2, 0, 1, 
     10, 
      OPC_CheckChild2CondCode, ISD::SETNE,
      OPC_CheckPatternPredicate0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_I64x2),
                    78, 2, 0, 1, 
     10, 
      OPC_CheckChild2CondCode, ISD::SETLT,
      OPC_CheckPatternPredicate0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_S_I64x2),
                    78, 2, 0, 1, 
     10, 
      OPC_CheckChild2CondCode, ISD::SETGT,
      OPC_CheckPatternPredicate0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_S_I64x2),
                    78, 2, 0, 1, 
     10, 
      OPC_CheckChild2CondCode, ISD::SETLE,
      OPC_CheckPatternPredicate0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_S_I64x2),
                    78, 2, 0, 1, 
     10, 
      OPC_CheckChild2CondCode, ISD::SETGE,
      OPC_CheckPatternPredicate0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_S_I64x2),
                    78, 2, 0, 1, 
     0, 
    4|128,1, 
     OPC_CheckChild0Type, 1|128,1, 
     OPC_RecordChild1,
     OPC_Scope, 10, 
      OPC_CheckChild2CondCode, ISD::SETOEQ,
      OPC_CheckPatternPredicate0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F64x2),
                    78, 2, 0, 1, 
     10, 
      OPC_CheckChild2CondCode, ISD::SETUNE,
      OPC_CheckPatternPredicate0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F64x2),
                    78, 2, 0, 1, 
     10, 
      OPC_CheckChild2CondCode, ISD::SETOLT,
      OPC_CheckPatternPredicate0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F64x2),
                    78, 2, 0, 1, 
     10, 
      OPC_CheckChild2CondCode, ISD::SETOGT,
      OPC_CheckPatternPredicate0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F64x2),
                    78, 2, 0, 1, 
     10, 
      OPC_CheckChild2CondCode, ISD::SETOLE,
      OPC_CheckPatternPredicate0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F64x2),
                    78, 2, 0, 1, 
     10, 
      OPC_CheckChild2CondCode, ISD::SETOGE,
      OPC_CheckPatternPredicate0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F64x2),
                    78, 2, 0, 1, 
     9, 
      OPC_CheckChild2CondCode, ISD::SETEQ,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F64x2),
                    78, 2, 0, 1, 
     9, 
      OPC_CheckChild2CondCode, ISD::SETNE,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F64x2),
                    78, 2, 0, 1, 
     9, 
      OPC_CheckChild2CondCode, ISD::SETLT,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F64x2),
                    78, 2, 0, 1, 
     9, 
      OPC_CheckChild2CondCode, ISD::SETGT,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F64x2),
                    78, 2, 0, 1, 
     9, 
      OPC_CheckChild2CondCode, ISD::SETLE,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F64x2),
                    78, 2, 0, 1, 
     9, 
      OPC_CheckChild2CondCode, ISD::SETGE,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F64x2),
                    78, 2, 0, 1, 
     0, 
    0, 
   0,
  0, 
 59|128,11, TARGET_VAL(ISD::LOAD),
  OPC_RecordMemRef,
  OPC_RecordNode,
  OPC_RecordChild1,
  OPC_Scope, 89|128,5, 
   OPC_CheckChild1TypeI32,
   OPC_CheckPredicate, 8,
   OPC_Scope, 37, 
    OPC_CheckPredicate6, 
    OPC_SwitchType , 15, 7, 
     OPC_CheckPatternPredicate1,
     OPC_CheckComplexPat0, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 3, 4, 2, 3, 
    15, 8, 
     OPC_CheckPatternPredicate1,
     OPC_CheckComplexPat0, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   8, 3, 4, 2, 3, 
    0,
   97, 
    OPC_CheckPredicate, 15,
    OPC_SwitchType , 36, 7, 
     OPC_Scope, 16, 
      OPC_CheckPredicate1, 
      OPC_CheckPatternPredicate1,
      OPC_CheckComplexPat0, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    7, 3, 4, 2, 3, 
     16, 
      OPC_CheckPredicate2, 
      OPC_CheckPatternPredicate1,
      OPC_CheckComplexPat0, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    7, 3, 4, 2, 3, 
     0, 
    53, 8, 
     OPC_Scope, 16, 
      OPC_CheckPredicate1, 
      OPC_CheckPatternPredicate1,
      OPC_CheckComplexPat0, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 3, 4, 2, 3, 
     16, 
      OPC_CheckPredicate2, 
      OPC_CheckPatternPredicate1,
      OPC_CheckComplexPat0, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 3, 4, 2, 3, 
     16, 
      OPC_CheckPredicate3, 
      OPC_CheckPatternPredicate1,
      OPC_CheckComplexPat0, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_S_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 3, 4, 2, 3, 
     0, 
    0,
   97, 
    OPC_CheckPredicate, 16,
    OPC_SwitchType , 36, 7, 
     OPC_Scope, 16, 
      OPC_CheckPredicate1, 
      OPC_CheckPatternPredicate1,
      OPC_CheckComplexPat0, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    7, 3, 4, 2, 3, 
     16, 
      OPC_CheckPredicate2, 
      OPC_CheckPatternPredicate1,
      OPC_CheckComplexPat0, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    7, 3, 4, 2, 3, 
     0, 
    53, 8, 
     OPC_Scope, 16, 
      OPC_CheckPredicate1, 
      OPC_CheckPatternPredicate1,
      OPC_CheckComplexPat0, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 3, 4, 2, 3, 
     16, 
      OPC_CheckPredicate2, 
      OPC_CheckPatternPredicate1,
      OPC_CheckComplexPat0, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 3, 4, 2, 3, 
     16, 
      OPC_CheckPredicate3, 
      OPC_CheckPatternPredicate1,
      OPC_CheckComplexPat0, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 3, 4, 2, 3, 
     0, 
    0,
   97, 
    OPC_CheckPredicate, 10,
    OPC_SwitchType , 36, 7, 
     OPC_Scope, 16, 
      OPC_CheckPredicate1, 
      OPC_CheckPatternPredicate1,
      OPC_CheckComplexPat0, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    7, 3, 4, 2, 3, 
     16, 
      OPC_CheckPredicate2, 
      OPC_CheckPatternPredicate1,
      OPC_CheckComplexPat0, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    7, 3, 4, 2, 3, 
     0, 
    53, 8, 
     OPC_Scope, 16, 
      OPC_CheckPredicate1, 
      OPC_CheckPatternPredicate1,
      OPC_CheckComplexPat0, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 3, 4, 2, 3, 
     16, 
      OPC_CheckPredicate2, 
      OPC_CheckPatternPredicate1,
      OPC_CheckComplexPat0, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 3, 4, 2, 3, 
     16, 
      OPC_CheckPredicate3, 
      OPC_CheckPatternPredicate1,
      OPC_CheckComplexPat0, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 3, 4, 2, 3, 
     0, 
    0,
   105, 
    OPC_CheckPredicate6, 
    OPC_SwitchType , 15, 12, 
     OPC_CheckPatternPredicate1,
     OPC_CheckComplexPat0, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   12, 3, 4, 2, 3, 
    15, 13, 
     OPC_CheckPatternPredicate1,
     OPC_CheckComplexPat0, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   13, 3, 4, 2, 3, 
    15, 39, 
     OPC_CheckPatternPredicate1,
     OPC_CheckComplexPat0, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   39, 3, 4, 2, 3, 
    15, 50, 
     OPC_CheckPatternPredicate1,
     OPC_CheckComplexPat0, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   50, 3, 4, 2, 3, 
    15, 60, 
     OPC_CheckPatternPredicate1,
     OPC_CheckComplexPat0, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   60, 3, 4, 2, 3, 
    15, 78, 
     OPC_CheckPatternPredicate1,
     OPC_CheckComplexPat0, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   78, 3, 4, 2, 3, 
    0,
   21, 
    OPC_CheckPredicate, 15,
    OPC_CheckPredicate, 21,
    OPC_CheckType, 50, 
    OPC_CheckPatternPredicate1,
    OPC_CheckComplexPat0, /*#*/1,
    OPC_EmitMergeInputChains1_0,
    OPC_EmitInteger32, 0, 
    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  50, 3, 4, 2, 3, 
   21, 
    OPC_CheckPredicate, 16,
    OPC_CheckPredicate, 21,
    OPC_CheckType, 50, 
    OPC_CheckPatternPredicate1,
    OPC_CheckComplexPat0, /*#*/1,
    OPC_EmitMergeInputChains1_0,
    OPC_EmitInteger32, 0, 
    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  50, 3, 4, 2, 3, 
   21, 
    OPC_CheckPredicate, 10,
    OPC_CheckPredicate, 21,
    OPC_CheckType, 50, 
    OPC_CheckPatternPredicate1,
    OPC_CheckComplexPat0, /*#*/1,
    OPC_EmitMergeInputChains1_0,
    OPC_EmitInteger32, 0, 
    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  50, 3, 4, 2, 3, 
   21, 
    OPC_CheckPredicate, 15,
    OPC_CheckPredicate, 22,
    OPC_CheckType, 60, 
    OPC_CheckPatternPredicate1,
    OPC_CheckComplexPat0, /*#*/1,
    OPC_EmitMergeInputChains1_0,
    OPC_EmitInteger32, 0, 
    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  60, 3, 4, 2, 3, 
   21, 
    OPC_CheckPredicate, 16,
    OPC_CheckPredicate, 22,
    OPC_CheckType, 60, 
    OPC_CheckPatternPredicate1,
    OPC_CheckComplexPat0, /*#*/1,
    OPC_EmitMergeInputChains1_0,
    OPC_EmitInteger32, 0, 
    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  60, 3, 4, 2, 3, 
   21, 
    OPC_CheckPredicate, 10,
    OPC_CheckPredicate, 22,
    OPC_CheckType, 60, 
    OPC_CheckPatternPredicate1,
    OPC_CheckComplexPat0, /*#*/1,
    OPC_EmitMergeInputChains1_0,
    OPC_EmitInteger32, 0, 
    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  60, 3, 4, 2, 3, 
   21, 
    OPC_CheckPredicate, 15,
    OPC_CheckPredicate, 23,
    OPC_CheckType, 78, 
    OPC_CheckPatternPredicate1,
    OPC_CheckComplexPat0, /*#*/1,
    OPC_EmitMergeInputChains1_0,
    OPC_EmitInteger32, 0, 
    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  78, 3, 4, 2, 3, 
   21, 
    OPC_CheckPredicate, 16,
    OPC_CheckPredicate, 23,
    OPC_CheckType, 78, 
    OPC_CheckPatternPredicate1,
    OPC_CheckComplexPat0, /*#*/1,
    OPC_EmitMergeInputChains1_0,
    OPC_EmitInteger32, 0, 
    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  78, 3, 4, 2, 3, 
   21, 
    OPC_CheckPredicate, 10,
    OPC_CheckPredicate, 23,
    OPC_CheckType, 78, 
    OPC_CheckPatternPredicate1,
    OPC_CheckComplexPat0, /*#*/1,
    OPC_EmitMergeInputChains1_0,
    OPC_EmitInteger32, 0, 
    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  78, 3, 4, 2, 3, 
   56, 
    OPC_CheckPredicate6, 
    OPC_SwitchType , 15, 111, 
     OPC_CheckPatternPredicate1,
     OPC_CheckComplexPat0, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   111, 3, 4, 2, 3, 
    16, 1|128,1, 
     OPC_CheckPatternPredicate1,
     OPC_CheckComplexPat0, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   1|128,1, 3, 4, 2, 3, 
    15, 92, 
     OPC_CheckPatternPredicate1,
     OPC_CheckComplexPat0, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   92, 3, 4, 2, 3, 
    0,
   30, 
    OPC_CheckPredicate, 10,
    OPC_CheckType, 1|128,1, 
    OPC_CheckPatternPredicate1,
    OPC_EmitMergeInputChains1_0,
    OPC_EmitInteger32, 0, 
    OPC_EmitInteger32, 0, 
    OPC_EmitNode1, TARGET_VAL(WebAssembly::LOAD_ZERO_64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  39, 3, 2, 3, 1, 
    OPC_EmitNode1None, TARGET_VAL(WebAssembly::promote_low_F64x2),
                  1|128,1, 1, 4, 
    OPC_CompleteMatch, 1, 5, 

   0, 
  89|128,5, 
   OPC_CheckChild1TypeI64,
   OPC_CheckPredicate, 8,
   OPC_Scope, 37, 
    OPC_CheckPredicate6, 
    OPC_SwitchType , 15, 7, 
     OPC_CheckPatternPredicate2,
     OPC_CheckComplexPat1, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 3, 4, 2, 3, 
    15, 8, 
     OPC_CheckPatternPredicate2,
     OPC_CheckComplexPat1, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   8, 3, 4, 2, 3, 
    0,
   97, 
    OPC_CheckPredicate, 15,
    OPC_SwitchType , 36, 7, 
     OPC_Scope, 16, 
      OPC_CheckPredicate1, 
      OPC_CheckPatternPredicate2,
      OPC_CheckComplexPat1, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    7, 3, 4, 2, 3, 
     16, 
      OPC_CheckPredicate2, 
      OPC_CheckPatternPredicate2,
      OPC_CheckComplexPat1, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    7, 3, 4, 2, 3, 
     0, 
    53, 8, 
     OPC_Scope, 16, 
      OPC_CheckPredicate1, 
      OPC_CheckPatternPredicate2,
      OPC_CheckComplexPat1, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 3, 4, 2, 3, 
     16, 
      OPC_CheckPredicate2, 
      OPC_CheckPatternPredicate2,
      OPC_CheckComplexPat1, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 3, 4, 2, 3, 
     16, 
      OPC_CheckPredicate3, 
      OPC_CheckPatternPredicate2,
      OPC_CheckComplexPat1, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_S_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 3, 4, 2, 3, 
     0, 
    0,
   97, 
    OPC_CheckPredicate, 16,
    OPC_SwitchType , 36, 7, 
     OPC_Scope, 16, 
      OPC_CheckPredicate1, 
      OPC_CheckPatternPredicate2,
      OPC_CheckComplexPat1, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    7, 3, 4, 2, 3, 
     16, 
      OPC_CheckPredicate2, 
      OPC_CheckPatternPredicate2,
      OPC_CheckComplexPat1, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    7, 3, 4, 2, 3, 
     0, 
    53, 8, 
     OPC_Scope, 16, 
      OPC_CheckPredicate1, 
      OPC_CheckPatternPredicate2,
      OPC_CheckComplexPat1, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 3, 4, 2, 3, 
     16, 
      OPC_CheckPredicate2, 
      OPC_CheckPatternPredicate2,
      OPC_CheckComplexPat1, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 3, 4, 2, 3, 
     16, 
      OPC_CheckPredicate3, 
      OPC_CheckPatternPredicate2,
      OPC_CheckComplexPat1, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 3, 4, 2, 3, 
     0, 
    0,
   97, 
    OPC_CheckPredicate, 10,
    OPC_SwitchType , 36, 7, 
     OPC_Scope, 16, 
      OPC_CheckPredicate1, 
      OPC_CheckPatternPredicate2,
      OPC_CheckComplexPat1, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    7, 3, 4, 2, 3, 
     16, 
      OPC_CheckPredicate2, 
      OPC_CheckPatternPredicate2,
      OPC_CheckComplexPat1, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    7, 3, 4, 2, 3, 
     0, 
    53, 8, 
     OPC_Scope, 16, 
      OPC_CheckPredicate1, 
      OPC_CheckPatternPredicate2,
      OPC_CheckComplexPat1, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 3, 4, 2, 3, 
     16, 
      OPC_CheckPredicate2, 
      OPC_CheckPatternPredicate2,
      OPC_CheckComplexPat1, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 3, 4, 2, 3, 
     16, 
      OPC_CheckPredicate3, 
      OPC_CheckPatternPredicate2,
      OPC_CheckComplexPat1, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    8, 3, 4, 2, 3, 
     0, 
    0,
   105, 
    OPC_CheckPredicate6, 
    OPC_SwitchType , 15, 12, 
     OPC_CheckPatternPredicate2,
     OPC_CheckComplexPat1, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   12, 3, 4, 2, 3, 
    15, 13, 
     OPC_CheckPatternPredicate2,
     OPC_CheckComplexPat1, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   13, 3, 4, 2, 3, 
    15, 39, 
     OPC_CheckPatternPredicate2,
     OPC_CheckComplexPat1, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   39, 3, 4, 2, 3, 
    15, 50, 
     OPC_CheckPatternPredicate2,
     OPC_CheckComplexPat1, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   50, 3, 4, 2, 3, 
    15, 60, 
     OPC_CheckPatternPredicate2,
     OPC_CheckComplexPat1, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   60, 3, 4, 2, 3, 
    15, 78, 
     OPC_CheckPatternPredicate2,
     OPC_CheckComplexPat1, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   78, 3, 4, 2, 3, 
    0,
   21, 
    OPC_CheckPredicate, 15,
    OPC_CheckPredicate, 21,
    OPC_CheckType, 50, 
    OPC_CheckPatternPredicate2,
    OPC_CheckComplexPat1, /*#*/1,
    OPC_EmitMergeInputChains1_0,
    OPC_EmitInteger32, 0, 
    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  50, 3, 4, 2, 3, 
   21, 
    OPC_CheckPredicate, 16,
    OPC_CheckPredicate, 21,
    OPC_CheckType, 50, 
    OPC_CheckPatternPredicate2,
    OPC_CheckComplexPat1, /*#*/1,
    OPC_EmitMergeInputChains1_0,
    OPC_EmitInteger32, 0, 
    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  50, 3, 4, 2, 3, 
   21, 
    OPC_CheckPredicate, 10,
    OPC_CheckPredicate, 21,
    OPC_CheckType, 50, 
    OPC_CheckPatternPredicate2,
    OPC_CheckComplexPat1, /*#*/1,
    OPC_EmitMergeInputChains1_0,
    OPC_EmitInteger32, 0, 
    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  50, 3, 4, 2, 3, 
   21, 
    OPC_CheckPredicate, 15,
    OPC_CheckPredicate, 22,
    OPC_CheckType, 60, 
    OPC_CheckPatternPredicate2,
    OPC_CheckComplexPat1, /*#*/1,
    OPC_EmitMergeInputChains1_0,
    OPC_EmitInteger32, 0, 
    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  60, 3, 4, 2, 3, 
   21, 
    OPC_CheckPredicate, 16,
    OPC_CheckPredicate, 22,
    OPC_CheckType, 60, 
    OPC_CheckPatternPredicate2,
    OPC_CheckComplexPat1, /*#*/1,
    OPC_EmitMergeInputChains1_0,
    OPC_EmitInteger32, 0, 
    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  60, 3, 4, 2, 3, 
   21, 
    OPC_CheckPredicate, 10,
    OPC_CheckPredicate, 22,
    OPC_CheckType, 60, 
    OPC_CheckPatternPredicate2,
    OPC_CheckComplexPat1, /*#*/1,
    OPC_EmitMergeInputChains1_0,
    OPC_EmitInteger32, 0, 
    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  60, 3, 4, 2, 3, 
   21, 
    OPC_CheckPredicate, 15,
    OPC_CheckPredicate, 23,
    OPC_CheckType, 78, 
    OPC_CheckPatternPredicate2,
    OPC_CheckComplexPat1, /*#*/1,
    OPC_EmitMergeInputChains1_0,
    OPC_EmitInteger32, 0, 
    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  78, 3, 4, 2, 3, 
   21, 
    OPC_CheckPredicate, 16,
    OPC_CheckPredicate, 23,
    OPC_CheckType, 78, 
    OPC_CheckPatternPredicate2,
    OPC_CheckComplexPat1, /*#*/1,
    OPC_EmitMergeInputChains1_0,
    OPC_EmitInteger32, 0, 
    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  78, 3, 4, 2, 3, 
   21, 
    OPC_CheckPredicate, 10,
    OPC_CheckPredicate, 23,
    OPC_CheckType, 78, 
    OPC_CheckPatternPredicate2,
    OPC_CheckComplexPat1, /*#*/1,
    OPC_EmitMergeInputChains1_0,
    OPC_EmitInteger32, 0, 
    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  78, 3, 4, 2, 3, 
   56, 
    OPC_CheckPredicate6, 
    OPC_SwitchType , 15, 111, 
     OPC_CheckPatternPredicate2,
     OPC_CheckComplexPat1, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   111, 3, 4, 2, 3, 
    16, 1|128,1, 
     OPC_CheckPatternPredicate2,
     OPC_CheckComplexPat1, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   1|128,1, 3, 4, 2, 3, 
    15, 92, 
     OPC_CheckPatternPredicate2,
     OPC_CheckComplexPat1, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   92, 3, 4, 2, 3, 
    0,
   30, 
    OPC_CheckPredicate, 10,
    OPC_CheckType, 1|128,1, 
    OPC_CheckPatternPredicate2,
    OPC_EmitMergeInputChains1_0,
    OPC_EmitInteger32, 0, 
    OPC_EmitInteger64, 0, 
    OPC_EmitNode1, TARGET_VAL(WebAssembly::LOAD_ZERO_64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  39, 3, 2, 3, 1, 
    OPC_EmitNode1None, TARGET_VAL(WebAssembly::promote_low_F64x2),
                  1|128,1, 1, 4, 
    OPC_CompleteMatch, 1, 5, 

   0, 
  0, 
 31|128,1, TARGET_VAL(ISD::ATOMIC_LOAD),
  OPC_RecordMemRef,
  OPC_RecordNode,
  OPC_RecordChild1,
  OPC_Scope, 76, 
   OPC_CheckChild1TypeI32,
   OPC_SwitchType , 53, 7, 
    OPC_Scope, 16, 
     OPC_CheckPredicate3, 
     OPC_CheckPatternPredicate1,
     OPC_CheckComplexPat0, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 3, 4, 2, 3, 
    16, 
     OPC_CheckPredicate1, 
     OPC_CheckPatternPredicate1,
     OPC_CheckComplexPat0, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 3, 4, 2, 3, 
    16, 
     OPC_CheckPredicate2, 
     OPC_CheckPatternPredicate1,
     OPC_CheckComplexPat0, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 3, 4, 2, 3, 
    0, 
   16, 8, 
    OPC_CheckPredicate7, 
    OPC_CheckPatternPredicate1,
    OPC_CheckComplexPat0, /*#*/1,
    OPC_EmitMergeInputChains1_0,
    OPC_EmitInteger32, 0, 
    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  8, 3, 4, 2, 3, 
   0,
  76, 
   OPC_CheckChild1TypeI64,
   OPC_SwitchType , 53, 7, 
    OPC_Scope, 16, 
     OPC_CheckPredicate3, 
     OPC_CheckPatternPredicate2,
     OPC_CheckComplexPat1, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 3, 4, 2, 3, 
    16, 
     OPC_CheckPredicate1, 
     OPC_CheckPatternPredicate2,
     OPC_CheckComplexPat1, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 3, 4, 2, 3, 
    16, 
     OPC_CheckPredicate2, 
     OPC_CheckPatternPredicate2,
     OPC_CheckComplexPat1, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 3, 4, 2, 3, 
    0, 
   16, 8, 
    OPC_CheckPredicate7, 
    OPC_CheckPatternPredicate2,
    OPC_CheckComplexPat1, /*#*/1,
    OPC_EmitMergeInputChains1_0,
    OPC_EmitInteger32, 0, 
    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  8, 3, 4, 2, 3, 
   0,
  0, 
 113|128,1, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),
  OPC_RecordMemRef,
  OPC_RecordNode,
  OPC_RecordChild1,
  OPC_Scope, 117, 
   OPC_CheckChild1TypeI32,
   OPC_RecordChild2,
   OPC_SwitchType , 92, 7, 
    OPC_Scope, 17, 
     OPC_CheckPredicate3, 
     OPC_CheckPatternPredicate3,
     OPC_CheckComplexPat0, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 4, 5, 3, 4, 2, 
    17, 
     OPC_CheckPredicate1, 
     OPC_CheckPatternPredicate3,
     OPC_CheckComplexPat0, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 4, 5, 3, 4, 2, 
    17, 
     OPC_CheckPredicate2, 
     OPC_CheckPatternPredicate3,
     OPC_CheckComplexPat0, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 4, 5, 3, 4, 2, 
    17, 
     OPC_CheckPredicate1, 
     OPC_CheckPatternPredicate3,
     OPC_CheckComplexPat0, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 4, 5, 3, 4, 2, 
    17, 
     OPC_CheckPredicate2, 
     OPC_CheckPatternPredicate3,
     OPC_CheckComplexPat0, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 4, 5, 3, 4, 2, 
    0, 
   17, 8, 
    OPC_CheckPredicate7, 
    OPC_CheckPatternPredicate3,
    OPC_CheckComplexPat0, /*#*/1,
    OPC_EmitMergeInputChains1_0,
    OPC_EmitInteger32, 0, 
    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  8, 4, 5, 3, 4, 2, 
   0,
  117, 
   OPC_CheckChild1TypeI64,
   OPC_RecordChild2,
   OPC_SwitchType , 92, 7, 
    OPC_Scope, 17, 
     OPC_CheckPredicate3, 
     OPC_CheckPatternPredicate4,
     OPC_CheckComplexPat1, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 4, 5, 3, 4, 2, 
    17, 
     OPC_CheckPredicate1, 
     OPC_CheckPatternPredicate4,
     OPC_CheckComplexPat1, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 4, 5, 3, 4, 2, 
    17, 
     OPC_CheckPredicate2, 
     OPC_CheckPatternPredicate4,
     OPC_CheckComplexPat1, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 4, 5, 3, 4, 2, 
    17, 
     OPC_CheckPredicate1, 
     OPC_CheckPatternPredicate4,
     OPC_CheckComplexPat1, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 4, 5, 3, 4, 2, 
    17, 
     OPC_CheckPredicate2, 
     OPC_CheckPatternPredicate4,
     OPC_CheckComplexPat1, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 4, 5, 3, 4, 2, 
    0, 
   17, 8, 
    OPC_CheckPredicate7, 
    OPC_CheckPatternPredicate4,
    OPC_CheckComplexPat1, /*#*/1,
    OPC_EmitMergeInputChains1_0,
    OPC_EmitInteger32, 0, 
    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  8, 4, 5, 3, 4, 2, 
   0,
  0, 
 113|128,1, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),
  OPC_RecordMemRef,
  OPC_RecordNode,
  OPC_RecordChild1,
  OPC_Scope, 117, 
   OPC_CheckChild1TypeI32,
   OPC_RecordChild2,
   OPC_SwitchType , 92, 7, 
    OPC_Scope, 17, 
     OPC_CheckPredicate3, 
     OPC_CheckPatternPredicate3,
     OPC_CheckComplexPat0, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 4, 5, 3, 4, 2, 
    17, 
     OPC_CheckPredicate1, 
     OPC_CheckPatternPredicate3,
     OPC_CheckComplexPat0, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 4, 5, 3, 4, 2, 
    17, 
     OPC_CheckPredicate2, 
     OPC_CheckPatternPredicate3,
     OPC_CheckComplexPat0, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 4, 5, 3, 4, 2, 
    17, 
     OPC_CheckPredicate1, 
     OPC_CheckPatternPredicate3,
     OPC_CheckComplexPat0, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 4, 5, 3, 4, 2, 
    17, 
     OPC_CheckPredicate2, 
     OPC_CheckPatternPredicate3,
     OPC_CheckComplexPat0, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 4, 5, 3, 4, 2, 
    0, 
   17, 8, 
    OPC_CheckPredicate7, 
    OPC_CheckPatternPredicate3,
    OPC_CheckComplexPat0, /*#*/1,
    OPC_EmitMergeInputChains1_0,
    OPC_EmitInteger32, 0, 
    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  8, 4, 5, 3, 4, 2, 
   0,
  117, 
   OPC_CheckChild1TypeI64,
   OPC_RecordChild2,
   OPC_SwitchType , 92, 7, 
    OPC_Scope, 17, 
     OPC_CheckPredicate3, 
     OPC_CheckPatternPredicate4,
     OPC_CheckComplexPat1, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 4, 5, 3, 4, 2, 
    17, 
     OPC_CheckPredicate1, 
     OPC_CheckPatternPredicate4,
     OPC_CheckComplexPat1, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 4, 5, 3, 4, 2, 
    17, 
     OPC_CheckPredicate2, 
     OPC_CheckPatternPredicate4,
     OPC_CheckComplexPat1, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 4, 5, 3, 4, 2, 
    17, 
     OPC_CheckPredicate1, 
     OPC_CheckPatternPredicate4,
     OPC_CheckComplexPat1, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 4, 5, 3, 4, 2, 
    17, 
     OPC_CheckPredicate2, 
     OPC_CheckPatternPredicate4,
     OPC_CheckComplexPat1, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 4, 5, 3, 4, 2, 
    0, 
   17, 8, 
    OPC_CheckPredicate7, 
    OPC_CheckPatternPredicate4,
    OPC_CheckComplexPat1, /*#*/1,
    OPC_EmitMergeInputChains1_0,
    OPC_EmitInteger32, 0, 
    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  8, 4, 5, 3, 4, 2, 
   0,
  0, 
 113|128,1, TARGET_VAL(ISD::ATOMIC_LOAD_AND),
  OPC_RecordMemRef,
  OPC_RecordNode,
  OPC_RecordChild1,
  OPC_Scope, 117, 
   OPC_CheckChild1TypeI32,
   OPC_RecordChild2,
   OPC_SwitchType , 92, 7, 
    OPC_Scope, 17, 
     OPC_CheckPredicate3, 
     OPC_CheckPatternPredicate3,
     OPC_CheckComplexPat0, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 4, 5, 3, 4, 2, 
    17, 
     OPC_CheckPredicate1, 
     OPC_CheckPatternPredicate3,
     OPC_CheckComplexPat0, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 4, 5, 3, 4, 2, 
    17, 
     OPC_CheckPredicate2, 
     OPC_CheckPatternPredicate3,
     OPC_CheckComplexPat0, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 4, 5, 3, 4, 2, 
    17, 
     OPC_CheckPredicate1, 
     OPC_CheckPatternPredicate3,
     OPC_CheckComplexPat0, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 4, 5, 3, 4, 2, 
    17, 
     OPC_CheckPredicate2, 
     OPC_CheckPatternPredicate3,
     OPC_CheckComplexPat0, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 4, 5, 3, 4, 2, 
    0, 
   17, 8, 
    OPC_CheckPredicate7, 
    OPC_CheckPatternPredicate3,
    OPC_CheckComplexPat0, /*#*/1,
    OPC_EmitMergeInputChains1_0,
    OPC_EmitInteger32, 0, 
    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  8, 4, 5, 3, 4, 2, 
   0,
  117, 
   OPC_CheckChild1TypeI64,
   OPC_RecordChild2,
   OPC_SwitchType , 92, 7, 
    OPC_Scope, 17, 
     OPC_CheckPredicate3, 
     OPC_CheckPatternPredicate4,
     OPC_CheckComplexPat1, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 4, 5, 3, 4, 2, 
    17, 
     OPC_CheckPredicate1, 
     OPC_CheckPatternPredicate4,
     OPC_CheckComplexPat1, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 4, 5, 3, 4, 2, 
    17, 
     OPC_CheckPredicate2, 
     OPC_CheckPatternPredicate4,
     OPC_CheckComplexPat1, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 4, 5, 3, 4, 2, 
    17, 
     OPC_CheckPredicate1, 
     OPC_CheckPatternPredicate4,
     OPC_CheckComplexPat1, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 4, 5, 3, 4, 2, 
    17, 
     OPC_CheckPredicate2, 
     OPC_CheckPatternPredicate4,
     OPC_CheckComplexPat1, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 4, 5, 3, 4, 2, 
    0, 
   17, 8, 
    OPC_CheckPredicate7, 
    OPC_CheckPatternPredicate4,
    OPC_CheckComplexPat1, /*#*/1,
    OPC_EmitMergeInputChains1_0,
    OPC_EmitInteger32, 0, 
    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  8, 4, 5, 3, 4, 2, 
   0,
  0, 
 113|128,1, TARGET_VAL(ISD::ATOMIC_LOAD_OR),
  OPC_RecordMemRef,
  OPC_RecordNode,
  OPC_RecordChild1,
  OPC_Scope, 117, 
   OPC_CheckChild1TypeI32,
   OPC_RecordChild2,
   OPC_SwitchType , 92, 7, 
    OPC_Scope, 17, 
     OPC_CheckPredicate3, 
     OPC_CheckPatternPredicate3,
     OPC_CheckComplexPat0, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 4, 5, 3, 4, 2, 
    17, 
     OPC_CheckPredicate1, 
     OPC_CheckPatternPredicate3,
     OPC_CheckComplexPat0, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 4, 5, 3, 4, 2, 
    17, 
     OPC_CheckPredicate2, 
     OPC_CheckPatternPredicate3,
     OPC_CheckComplexPat0, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 4, 5, 3, 4, 2, 
    17, 
     OPC_CheckPredicate1, 
     OPC_CheckPatternPredicate3,
     OPC_CheckComplexPat0, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 4, 5, 3, 4, 2, 
    17, 
     OPC_CheckPredicate2, 
     OPC_CheckPatternPredicate3,
     OPC_CheckComplexPat0, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 4, 5, 3, 4, 2, 
    0, 
   17, 8, 
    OPC_CheckPredicate7, 
    OPC_CheckPatternPredicate3,
    OPC_CheckComplexPat0, /*#*/1,
    OPC_EmitMergeInputChains1_0,
    OPC_EmitInteger32, 0, 
    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  8, 4, 5, 3, 4, 2, 
   0,
  117, 
   OPC_CheckChild1TypeI64,
   OPC_RecordChild2,
   OPC_SwitchType , 92, 7, 
    OPC_Scope, 17, 
     OPC_CheckPredicate3, 
     OPC_CheckPatternPredicate4,
     OPC_CheckComplexPat1, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 4, 5, 3, 4, 2, 
    17, 
     OPC_CheckPredicate1, 
     OPC_CheckPatternPredicate4,
     OPC_CheckComplexPat1, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 4, 5, 3, 4, 2, 
    17, 
     OPC_CheckPredicate2, 
     OPC_CheckPatternPredicate4,
     OPC_CheckComplexPat1, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 4, 5, 3, 4, 2, 
    17, 
     OPC_CheckPredicate1, 
     OPC_CheckPatternPredicate4,
     OPC_CheckComplexPat1, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 4, 5, 3, 4, 2, 
    17, 
     OPC_CheckPredicate2, 
     OPC_CheckPatternPredicate4,
     OPC_CheckComplexPat1, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 4, 5, 3, 4, 2, 
    0, 
   17, 8, 
    OPC_CheckPredicate7, 
    OPC_CheckPatternPredicate4,
    OPC_CheckComplexPat1, /*#*/1,
    OPC_EmitMergeInputChains1_0,
    OPC_EmitInteger32, 0, 
    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  8, 4, 5, 3, 4, 2, 
   0,
  0, 
 113|128,1, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),
  OPC_RecordMemRef,
  OPC_RecordNode,
  OPC_RecordChild1,
  OPC_Scope, 117, 
   OPC_CheckChild1TypeI32,
   OPC_RecordChild2,
   OPC_SwitchType , 92, 7, 
    OPC_Scope, 17, 
     OPC_CheckPredicate3, 
     OPC_CheckPatternPredicate3,
     OPC_CheckComplexPat0, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 4, 5, 3, 4, 2, 
    17, 
     OPC_CheckPredicate1, 
     OPC_CheckPatternPredicate3,
     OPC_CheckComplexPat0, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 4, 5, 3, 4, 2, 
    17, 
     OPC_CheckPredicate2, 
     OPC_CheckPatternPredicate3,
     OPC_CheckComplexPat0, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 4, 5, 3, 4, 2, 
    17, 
     OPC_CheckPredicate1, 
     OPC_CheckPatternPredicate3,
     OPC_CheckComplexPat0, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 4, 5, 3, 4, 2, 
    17, 
     OPC_CheckPredicate2, 
     OPC_CheckPatternPredicate3,
     OPC_CheckComplexPat0, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 4, 5, 3, 4, 2, 
    0, 
   17, 8, 
    OPC_CheckPredicate7, 
    OPC_CheckPatternPredicate3,
    OPC_CheckComplexPat0, /*#*/1,
    OPC_EmitMergeInputChains1_0,
    OPC_EmitInteger32, 0, 
    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  8, 4, 5, 3, 4, 2, 
   0,
  117, 
   OPC_CheckChild1TypeI64,
   OPC_RecordChild2,
   OPC_SwitchType , 92, 7, 
    OPC_Scope, 17, 
     OPC_CheckPredicate3, 
     OPC_CheckPatternPredicate4,
     OPC_CheckComplexPat1, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 4, 5, 3, 4, 2, 
    17, 
     OPC_CheckPredicate1, 
     OPC_CheckPatternPredicate4,
     OPC_CheckComplexPat1, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 4, 5, 3, 4, 2, 
    17, 
     OPC_CheckPredicate2, 
     OPC_CheckPatternPredicate4,
     OPC_CheckComplexPat1, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 4, 5, 3, 4, 2, 
    17, 
     OPC_CheckPredicate1, 
     OPC_CheckPatternPredicate4,
     OPC_CheckComplexPat1, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 4, 5, 3, 4, 2, 
    17, 
     OPC_CheckPredicate2, 
     OPC_CheckPatternPredicate4,
     OPC_CheckComplexPat1, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 4, 5, 3, 4, 2, 
    0, 
   17, 8, 
    OPC_CheckPredicate7, 
    OPC_CheckPatternPredicate4,
    OPC_CheckComplexPat1, /*#*/1,
    OPC_EmitMergeInputChains1_0,
    OPC_EmitInteger32, 0, 
    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  8, 4, 5, 3, 4, 2, 
   0,
  0, 
 113|128,1, TARGET_VAL(ISD::ATOMIC_SWAP),
  OPC_RecordMemRef,
  OPC_RecordNode,
  OPC_RecordChild1,
  OPC_Scope, 117, 
   OPC_CheckChild1TypeI32,
   OPC_RecordChild2,
   OPC_SwitchType , 92, 7, 
    OPC_Scope, 17, 
     OPC_CheckPredicate3, 
     OPC_CheckPatternPredicate3,
     OPC_CheckComplexPat0, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 4, 5, 3, 4, 2, 
    17, 
     OPC_CheckPredicate1, 
     OPC_CheckPatternPredicate3,
     OPC_CheckComplexPat0, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 4, 5, 3, 4, 2, 
    17, 
     OPC_CheckPredicate2, 
     OPC_CheckPatternPredicate3,
     OPC_CheckComplexPat0, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 4, 5, 3, 4, 2, 
    17, 
     OPC_CheckPredicate1, 
     OPC_CheckPatternPredicate3,
     OPC_CheckComplexPat0, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 4, 5, 3, 4, 2, 
    17, 
     OPC_CheckPredicate2, 
     OPC_CheckPatternPredicate3,
     OPC_CheckComplexPat0, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 4, 5, 3, 4, 2, 
    0, 
   17, 8, 
    OPC_CheckPredicate7, 
    OPC_CheckPatternPredicate3,
    OPC_CheckComplexPat0, /*#*/1,
    OPC_EmitMergeInputChains1_0,
    OPC_EmitInteger32, 0, 
    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  8, 4, 5, 3, 4, 2, 
   0,
  117, 
   OPC_CheckChild1TypeI64,
   OPC_RecordChild2,
   OPC_SwitchType , 92, 7, 
    OPC_Scope, 17, 
     OPC_CheckPredicate3, 
     OPC_CheckPatternPredicate4,
     OPC_CheckComplexPat1, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 4, 5, 3, 4, 2, 
    17, 
     OPC_CheckPredicate1, 
     OPC_CheckPatternPredicate4,
     OPC_CheckComplexPat1, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 4, 5, 3, 4, 2, 
    17, 
     OPC_CheckPredicate2, 
     OPC_CheckPatternPredicate4,
     OPC_CheckComplexPat1, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 4, 5, 3, 4, 2, 
    17, 
     OPC_CheckPredicate1, 
     OPC_CheckPatternPredicate4,
     OPC_CheckComplexPat1, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 4, 5, 3, 4, 2, 
    17, 
     OPC_CheckPredicate2, 
     OPC_CheckPatternPredicate4,
     OPC_CheckComplexPat1, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 4, 5, 3, 4, 2, 
    0, 
   17, 8, 
    OPC_CheckPredicate7, 
    OPC_CheckPatternPredicate4,
    OPC_CheckComplexPat1, /*#*/1,
    OPC_EmitMergeInputChains1_0,
    OPC_EmitInteger32, 0, 
    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  8, 4, 5, 3, 4, 2, 
   0,
  0, 
 127|128,1, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),
  OPC_RecordMemRef,
  OPC_RecordNode,
  OPC_RecordChild1,
  OPC_Scope, 124, 
   OPC_CheckChild1TypeI32,
   OPC_RecordChild2,
   OPC_RecordChild3,
   OPC_SwitchType , 97, 7, 
    OPC_Scope, 18, 
     OPC_CheckPredicate3, 
     OPC_CheckPatternPredicate3,
     OPC_CheckComplexPat0, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 5, 6, 4, 5, 2, 3, 
    18, 
     OPC_CheckPredicate1, 
     OPC_CheckPatternPredicate3,
     OPC_CheckComplexPat0, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 5, 6, 4, 5, 2, 3, 
    18, 
     OPC_CheckPredicate2, 
     OPC_CheckPatternPredicate3,
     OPC_CheckComplexPat0, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 5, 6, 4, 5, 2, 3, 
    18, 
     OPC_CheckPredicate1, 
     OPC_CheckPatternPredicate3,
     OPC_CheckComplexPat0, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 5, 6, 4, 5, 2, 3, 
    18, 
     OPC_CheckPredicate2, 
     OPC_CheckPatternPredicate3,
     OPC_CheckComplexPat0, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 5, 6, 4, 5, 2, 3, 
    0, 
   18, 8, 
    OPC_CheckPredicate7, 
    OPC_CheckPatternPredicate3,
    OPC_CheckComplexPat0, /*#*/1,
    OPC_EmitMergeInputChains1_0,
    OPC_EmitInteger32, 0, 
    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  8, 5, 6, 4, 5, 2, 3, 
   0,
  124, 
   OPC_CheckChild1TypeI64,
   OPC_RecordChild2,
   OPC_RecordChild3,
   OPC_SwitchType , 97, 7, 
    OPC_Scope, 18, 
     OPC_CheckPredicate3, 
     OPC_CheckPatternPredicate4,
     OPC_CheckComplexPat1, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 5, 6, 4, 5, 2, 3, 
    18, 
     OPC_CheckPredicate1, 
     OPC_CheckPatternPredicate4,
     OPC_CheckComplexPat1, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 5, 6, 4, 5, 2, 3, 
    18, 
     OPC_CheckPredicate2, 
     OPC_CheckPatternPredicate4,
     OPC_CheckComplexPat1, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 5, 6, 4, 5, 2, 3, 
    18, 
     OPC_CheckPredicate1, 
     OPC_CheckPatternPredicate4,
     OPC_CheckComplexPat1, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 5, 6, 4, 5, 2, 3, 
    18, 
     OPC_CheckPredicate2, 
     OPC_CheckPatternPredicate4,
     OPC_CheckComplexPat1, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   7, 5, 6, 4, 5, 2, 3, 
    0, 
   18, 8, 
    OPC_CheckPredicate7, 
    OPC_CheckPatternPredicate4,
    OPC_CheckComplexPat1, /*#*/1,
    OPC_EmitMergeInputChains1_0,
    OPC_EmitInteger32, 0, 
    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  8, 5, 6, 4, 5, 2, 3, 
   0,
  0, 
 89, TARGET_VAL(ISD::BRCOND),
  OPC_RecordNode,
  OPC_Scope, 69, 
   OPC_MoveChild1,
   OPC_SwitchOpcode , 21, TARGET_VAL(ISD::XOR),
    OPC_RecordChild0,
    OPC_MoveChild0,
    OPC_CheckPredicate, 26,
    OPC_MoveParent,
    OPC_CheckChild1Integer, 2, 
    OPC_CheckTypeI32,
    OPC_MoveSibling2,
    OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
    OPC_RecordNode,
    OPC_MoveParent,
    OPC_EmitMergeInputChains1_0,
    OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::BR_UNLESS),
                  2, 2, 1, 
   39, TARGET_VAL(ISD::SETCC),
    OPC_RecordChild0,
    OPC_CheckChild0TypeI32,
    OPC_CheckChild1Integer, 0, 
    OPC_CheckTypeI32,
    OPC_Scope, 15, 
     OPC_CheckChild2CondCode, ISD::SETNE,
     OPC_MoveSibling2,
     OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
     OPC_RecordNode,
     OPC_MoveParent,
     OPC_EmitMergeInputChains1_0,
     OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::BR_IF),
                   2, 2, 1, 
    15, 
     OPC_CheckChild2CondCode, ISD::SETEQ,
     OPC_MoveSibling2,
     OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
     OPC_RecordNode,
     OPC_MoveParent,
     OPC_EmitMergeInputChains1_0,
     OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::BR_UNLESS),
                   2, 2, 1, 
    0, 
   0,
  15, 
   OPC_RecordChild1,
   OPC_CheckChild1TypeI32,
   OPC_RecordChild2,
   OPC_MoveChild2,
   OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
   OPC_MoveParent,
   OPC_EmitMergeInputChains1_0,
   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::BR_IF),
                 2, 2, 1, 
  0, 
 59, TARGET_VAL(ISD::SHL),
  OPC_RecordChild0,
  OPC_Scope, 31, 
   OPC_MoveChild1,
   OPC_SwitchType , 12, 7, 
    OPC_CheckAndImm, 31, 
    OPC_RecordChild0,
    OPC_MoveParent,
    OPC_CheckTypeI32,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I32),
                  7, 2, 0, 1, 
   12, 8, 
    OPC_CheckAndImm, 63, 
    OPC_RecordChild0,
    OPC_MoveParent,
    OPC_CheckTypeI64,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I64),
                  8, 2, 0, 1, 
   0,
  23, 
   OPC_RecordChild1,
   OPC_SwitchType , 8, 7, 
    OPC_CheckChild1TypeI32,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I32),
                  7, 2, 0, 1, 
   8, 8, 
    OPC_CheckChild1TypeI64,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I64),
                  8, 2, 0, 1, 
   0,
  0, 
 59, TARGET_VAL(ISD::SRA),
  OPC_RecordChild0,
  OPC_Scope, 31, 
   OPC_MoveChild1,
   OPC_SwitchType , 12, 7, 
    OPC_CheckAndImm, 31, 
    OPC_RecordChild0,
    OPC_MoveParent,
    OPC_CheckTypeI32,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I32),
                  7, 2, 0, 1, 
   12, 8, 
    OPC_CheckAndImm, 63, 
    OPC_RecordChild0,
    OPC_MoveParent,
    OPC_CheckTypeI64,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I64),
                  8, 2, 0, 1, 
   0,
  23, 
   OPC_RecordChild1,
   OPC_SwitchType , 8, 7, 
    OPC_CheckChild1TypeI32,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I32),
                  7, 2, 0, 1, 
   8, 8, 
    OPC_CheckChild1TypeI64,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I64),
                  8, 2, 0, 1, 
   0,
  0, 
 59, TARGET_VAL(ISD::SRL),
  OPC_RecordChild0,
  OPC_Scope, 31, 
   OPC_MoveChild1,
   OPC_SwitchType , 12, 7, 
    OPC_CheckAndImm, 31, 
    OPC_RecordChild0,
    OPC_MoveParent,
    OPC_CheckTypeI32,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I32),
                  7, 2, 0, 1, 
   12, 8, 
    OPC_CheckAndImm, 63, 
    OPC_RecordChild0,
    OPC_MoveParent,
    OPC_CheckTypeI64,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I64),
                  8, 2, 0, 1, 
   0,
  23, 
   OPC_RecordChild1,
   OPC_SwitchType , 8, 7, 
    OPC_CheckChild1TypeI32,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I32),
                  7, 2, 0, 1, 
   8, 8, 
    OPC_CheckChild1TypeI64,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I64),
                  8, 2, 0, 1, 
   0,
  0, 
 59, TARGET_VAL(ISD::ROTL),
  OPC_RecordChild0,
  OPC_Scope, 31, 
   OPC_MoveChild1,
   OPC_SwitchType , 12, 7, 
    OPC_CheckAndImm, 31, 
    OPC_RecordChild0,
    OPC_MoveParent,
    OPC_CheckTypeI32,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTL_I32),
                  7, 2, 0, 1, 
   12, 8, 
    OPC_CheckAndImm, 63, 
    OPC_RecordChild0,
    OPC_MoveParent,
    OPC_CheckTypeI64,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTL_I64),
                  8, 2, 0, 1, 
   0,
  23, 
   OPC_RecordChild1,
   OPC_SwitchType , 8, 7, 
    OPC_CheckChild1TypeI32,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTL_I32),
                  7, 2, 0, 1, 
   8, 8, 
    OPC_CheckChild1TypeI64,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTL_I64),
                  8, 2, 0, 1, 
   0,
  0, 
 59, TARGET_VAL(ISD::ROTR),
  OPC_RecordChild0,
  OPC_Scope, 31, 
   OPC_MoveChild1,
   OPC_SwitchType , 12, 7, 
    OPC_CheckAndImm, 31, 
    OPC_RecordChild0,
    OPC_MoveParent,
    OPC_CheckTypeI32,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTR_I32),
                  7, 2, 0, 1, 
   12, 8, 
    OPC_CheckAndImm, 63, 
    OPC_RecordChild0,
    OPC_MoveParent,
    OPC_CheckTypeI64,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTR_I64),
                  8, 2, 0, 1, 
   0,
  23, 
   OPC_RecordChild1,
   OPC_SwitchType , 8, 7, 
    OPC_CheckChild1TypeI32,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTR_I32),
                  7, 2, 0, 1, 
   8, 8, 
    OPC_CheckChild1TypeI64,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTR_I64),
                  8, 2, 0, 1, 
   0,
  0, 
 48|128,4, TARGET_VAL(ISD::SELECT),
  OPC_Scope, 11|128,1, 
   OPC_MoveChild0,
   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
   OPC_RecordChild0,
   OPC_CheckChild0TypeI32,
   OPC_CheckChild1Integer, 0, 
   OPC_CheckTypeI32,
   OPC_Scope, 63, 
    OPC_CheckChild2CondCode, ISD::SETNE,
    OPC_MoveParent,
    OPC_RecordChild1,
    OPC_RecordChild2,
    OPC_SwitchType , 8, 7, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_I32),
                   7, 3, 1, 2, 0, 
    8, 8, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_I64),
                   8, 3, 1, 2, 0, 
    9, 99|128,1, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_FUNCREF),
                   99|128,1, 3, 1, 2, 0, 
    9, 100|128,1, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_EXTERNREF),
                   100|128,1, 3, 1, 2, 0, 
    9, 101|128,1, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_EXNREF),
                   101|128,1, 3, 1, 2, 0, 
    0,
   63, 
    OPC_CheckChild2CondCode, ISD::SETEQ,
    OPC_MoveParent,
    OPC_RecordChild1,
    OPC_RecordChild2,
    OPC_SwitchType , 8, 7, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_I32),
                   7, 3, 2, 1, 0, 
    8, 8, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_I64),
                   8, 3, 2, 1, 0, 
    9, 99|128,1, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_FUNCREF),
                   99|128,1, 3, 2, 1, 0, 
    9, 100|128,1, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_EXTERNREF),
                   100|128,1, 3, 2, 1, 0, 
    9, 101|128,1, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_EXNREF),
                   101|128,1, 3, 2, 1, 0, 
    0,
   0, 
  65, 
   OPC_RecordChild0,
   OPC_CheckChild0TypeI32,
   OPC_RecordChild1,
   OPC_RecordChild2,
   OPC_SwitchType , 8, 7, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_I32),
                  7, 3, 1, 2, 0, 
   8, 8, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_I64),
                  8, 3, 1, 2, 0, 
   10, 99|128,1, 
    OPC_CheckPatternPredicate6,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_FUNCREF),
                  99|128,1, 3, 1, 2, 0, 
   10, 100|128,1, 
    OPC_CheckPatternPredicate6,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_EXTERNREF),
                  100|128,1, 3, 1, 2, 0, 
   10, 101|128,1, 
    OPC_CheckPatternPredicate6,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_EXNREF),
                  101|128,1, 3, 1, 2, 0, 
   0,
  67, 
   OPC_MoveChild0,
   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
   OPC_RecordChild0,
   OPC_CheckChild0TypeI32,
   OPC_CheckChild1Integer, 0, 
   OPC_CheckTypeI32,
   OPC_Scope, 27, 
    OPC_CheckChild2CondCode, ISD::SETNE,
    OPC_MoveParent,
    OPC_RecordChild1,
    OPC_RecordChild2,
    OPC_SwitchType , 8, 12, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_F32),
                   12, 3, 1, 2, 0, 
    8, 13, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_F64),
                   13, 3, 1, 2, 0, 
    0,
   27, 
    OPC_CheckChild2CondCode, ISD::SETEQ,
    OPC_MoveParent,
    OPC_RecordChild1,
    OPC_RecordChild2,
    OPC_SwitchType , 8, 12, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_F32),
                   12, 3, 2, 1, 0, 
    8, 13, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_F64),
                   13, 3, 2, 1, 0, 
    0,
   0, 
  26, 
   OPC_RecordChild0,
   OPC_CheckChild0TypeI32,
   OPC_RecordChild1,
   OPC_RecordChild2,
   OPC_SwitchType , 8, 12, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_F32),
                  12, 3, 1, 2, 0, 
   8, 13, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_F64),
                  13, 3, 1, 2, 0, 
   0,
  107, 
   OPC_MoveChild0,
   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
   OPC_RecordChild0,
   OPC_CheckChild0TypeI32,
   OPC_CheckChild1Integer, 0, 
   OPC_CheckTypeI32,
   OPC_Scope, 47, 
    OPC_CheckChild2CondCode, ISD::SETNE,
    OPC_MoveParent,
    OPC_RecordChild1,
    OPC_RecordChild2,
    OPC_SwitchType , 8, 39, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   39, 3, 1, 2, 0, 
    8, 50, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   50, 3, 1, 2, 0, 
    8, 60, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   60, 3, 1, 2, 0, 
    8, 78, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   78, 3, 1, 2, 0, 
    0,
   47, 
    OPC_CheckChild2CondCode, ISD::SETEQ,
    OPC_MoveParent,
    OPC_RecordChild1,
    OPC_RecordChild2,
    OPC_SwitchType , 8, 39, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   39, 3, 2, 1, 0, 
    8, 50, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   50, 3, 2, 1, 0, 
    8, 60, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   60, 3, 2, 1, 0, 
    8, 78, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   78, 3, 2, 1, 0, 
    0,
   0, 
  46, 
   OPC_RecordChild0,
   OPC_CheckChild0TypeI32,
   OPC_RecordChild1,
   OPC_RecordChild2,
   OPC_SwitchType , 8, 39, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                  39, 3, 1, 2, 0, 
   8, 50, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                  50, 3, 1, 2, 0, 
   8, 60, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                  60, 3, 1, 2, 0, 
   8, 78, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                  78, 3, 1, 2, 0, 
   0,
  71, 
   OPC_MoveChild0,
   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
   OPC_RecordChild0,
   OPC_CheckChild0TypeI32,
   OPC_CheckChild1Integer, 0, 
   OPC_CheckTypeI32,
   OPC_Scope, 29, 
    OPC_CheckChild2CondCode, ISD::SETNE,
    OPC_MoveParent,
    OPC_RecordChild1,
    OPC_RecordChild2,
    OPC_SwitchType , 8, 111, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   111, 3, 1, 2, 0, 
    9, 1|128,1, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   1|128,1, 3, 1, 2, 0, 
    0,
   29, 
    OPC_CheckChild2CondCode, ISD::SETEQ,
    OPC_MoveParent,
    OPC_RecordChild1,
    OPC_RecordChild2,
    OPC_SwitchType , 8, 111, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   111, 3, 2, 1, 0, 
    9, 1|128,1, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   1|128,1, 3, 2, 1, 0, 
    0,
   0, 
  28, 
   OPC_RecordChild0,
   OPC_CheckChild0TypeI32,
   OPC_RecordChild1,
   OPC_RecordChild2,
   OPC_SwitchType , 8, 111, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                  111, 3, 1, 2, 0, 
   9, 1|128,1, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                  1|128,1, 3, 1, 2, 0, 
   0,
  0, 
 1|128,1, TARGET_VAL(ISD::SIGN_EXTEND_INREG),
  OPC_Scope, 57, 
   OPC_MoveChild0,
   OPC_CheckOpcode, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),
   OPC_RecordChild0,
   OPC_Scope, 24, 
    OPC_CheckChild0Type, 39, 
    OPC_RecordChild1,
    OPC_MoveChild1,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_CheckPredicate, 18,
    OPC_CheckTypeI32,
    OPC_MoveParent,
    OPC_MoveSibling1,
    OPC_CheckValueType, 5, 
    OPC_MoveParent,
    OPC_CheckTypeI32,
    OPC_EmitConvertToTarget1,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I8x16_s),
                  7, 2, 0, 2, 
   24, 
    OPC_CheckChild0Type, 50, 
    OPC_RecordChild1,
    OPC_MoveChild1,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_CheckPredicate, 13,
    OPC_CheckTypeI32,
    OPC_MoveParent,
    OPC_MoveSibling1,
    OPC_CheckValueType, 6, 
    OPC_MoveParent,
    OPC_CheckTypeI32,
    OPC_EmitConvertToTarget1,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I16x8_s),
                  7, 2, 0, 2, 
   0, 
  68, 
   OPC_RecordChild0,
   OPC_MoveChild1,
   OPC_Scope, 25, 
    OPC_CheckValueType, 5, 
    OPC_MoveParent,
    OPC_SwitchType , 8, 7, 
     OPC_CheckPatternPredicate, 11,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_EXTEND8_S_I32),
                   7, 1, 0, 
    8, 8, 
     OPC_CheckPatternPredicate, 11,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_EXTEND8_S_I64),
                   8, 1, 0, 
    0,
   25, 
    OPC_CheckValueType, 6, 
    OPC_MoveParent,
    OPC_SwitchType , 8, 7, 
     OPC_CheckPatternPredicate, 11,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_EXTEND16_S_I32),
                   7, 1, 0, 
    8, 8, 
     OPC_CheckPatternPredicate, 11,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_EXTEND16_S_I64),
                   8, 1, 0, 
    0,
   11, 
    OPC_CheckValueType, 7, 
    OPC_MoveParent,
    OPC_CheckPatternPredicate, 11,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_EXTEND32_S_I64),
                  8, 1, 0, 
   0, 
  0, 
 46|128,1, TARGET_VAL(WebAssemblyISD::GLOBAL_GET),
  OPC_RecordMemRef,
  OPC_RecordNode,
  OPC_MoveChild1,
  OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
  OPC_RecordChild0,
  OPC_MoveChild0,
  OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
  OPC_MoveParent,
  OPC_MoveParent,
  OPC_SwitchType , 8, 7, 
   OPC_EmitMergeInputChains1_0,
   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_I32), 0|OPFL_Chain|OPFL_MemRefs,
                 7, 1, 1, 
  8, 8, 
   OPC_EmitMergeInputChains1_0,
   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_I64), 0|OPFL_Chain|OPFL_MemRefs,
                 8, 1, 1, 
  10, 99|128,1, 
   OPC_CheckPatternPredicate6,
   OPC_EmitMergeInputChains1_0,
   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_FUNCREF), 0|OPFL_Chain|OPFL_MemRefs,
                 99|128,1, 1, 1, 
  10, 100|128,1, 
   OPC_CheckPatternPredicate6,
   OPC_EmitMergeInputChains1_0,
   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_EXTERNREF), 0|OPFL_Chain|OPFL_MemRefs,
                 100|128,1, 1, 1, 
  11, 101|128,1, 
   OPC_CheckPatternPredicate, 8,
   OPC_EmitMergeInputChains1_0,
   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_EXNREF), 0|OPFL_Chain|OPFL_MemRefs,
                 101|128,1, 1, 1, 
  8, 12, 
   OPC_EmitMergeInputChains1_0,
   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_F32), 0|OPFL_Chain|OPFL_MemRefs,
                 12, 1, 1, 
  8, 13, 
   OPC_EmitMergeInputChains1_0,
   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_F64), 0|OPFL_Chain|OPFL_MemRefs,
                 13, 1, 1, 
  9, 78, 
   OPC_CheckPatternPredicate0,
   OPC_EmitMergeInputChains1_0,
   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 78, 1, 1, 
  9, 60, 
   OPC_CheckPatternPredicate0,
   OPC_EmitMergeInputChains1_0,
   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 60, 1, 1, 
  9, 39, 
   OPC_CheckPatternPredicate0,
   OPC_EmitMergeInputChains1_0,
   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 39, 1, 1, 
  9, 50, 
   OPC_CheckPatternPredicate0,
   OPC_EmitMergeInputChains1_0,
   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 50, 1, 1, 
  9, 92, 
   OPC_CheckPatternPredicate0,
   OPC_EmitMergeInputChains1_0,
   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 92, 1, 1, 
  9, 111, 
   OPC_CheckPatternPredicate0,
   OPC_EmitMergeInputChains1_0,
   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 111, 1, 1, 
  10, 1|128,1, 
   OPC_CheckPatternPredicate0,
   OPC_EmitMergeInputChains1_0,
   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 1|128,1, 1, 1, 
  0,
 70|128,2, TARGET_VAL(WebAssemblyISD::GLOBAL_SET),
  OPC_RecordMemRef,
  OPC_RecordNode,
  OPC_RecordChild1,
  OPC_Scope, 20, 
   OPC_CheckChild1TypeI32,
   OPC_MoveChild2,
   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
   OPC_RecordChild0,
   OPC_MoveChild0,
   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
   OPC_MoveParent,
   OPC_MoveParent,
   OPC_EmitMergeInputChains1_0,
   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_I32), 0|OPFL_Chain|OPFL_MemRefs,
                 2, 2, 1, 
  20, 
   OPC_CheckChild1TypeI64,
   OPC_MoveChild2,
   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
   OPC_RecordChild0,
   OPC_MoveChild0,
   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
   OPC_MoveParent,
   OPC_MoveParent,
   OPC_EmitMergeInputChains1_0,
   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_I64), 0|OPFL_Chain|OPFL_MemRefs,
                 2, 2, 1, 
  21, 
   OPC_CheckChild1Type, 12, 
   OPC_MoveChild2,
   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
   OPC_RecordChild0,
   OPC_MoveChild0,
   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
   OPC_MoveParent,
   OPC_MoveParent,
   OPC_EmitMergeInputChains1_0,
   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_F32), 0|OPFL_Chain|OPFL_MemRefs,
                 2, 2, 1, 
  21, 
   OPC_CheckChild1Type, 13, 
   OPC_MoveChild2,
   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
   OPC_RecordChild0,
   OPC_MoveChild0,
   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
   OPC_MoveParent,
   OPC_MoveParent,
   OPC_EmitMergeInputChains1_0,
   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_F64), 0|OPFL_Chain|OPFL_MemRefs,
                 2, 2, 1, 
  22, 
   OPC_CheckChild1Type, 92, 
   OPC_MoveChild2,
   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
   OPC_RecordChild0,
   OPC_MoveChild0,
   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
   OPC_MoveParent,
   OPC_MoveParent,
   OPC_CheckPatternPredicate0,
   OPC_EmitMergeInputChains1_0,
   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2, 2, 1, 
  22, 
   OPC_CheckChild1Type, 111, 
   OPC_MoveChild2,
   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
   OPC_RecordChild0,
   OPC_MoveChild0,
   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
   OPC_MoveParent,
   OPC_MoveParent,
   OPC_CheckPatternPredicate0,
   OPC_EmitMergeInputChains1_0,
   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2, 2, 1, 
  23, 
   OPC_CheckChild1Type, 1|128,1, 
   OPC_MoveChild2,
   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
   OPC_RecordChild0,
   OPC_MoveChild0,
   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
   OPC_MoveParent,
   OPC_MoveParent,
   OPC_CheckPatternPredicate0,
   OPC_EmitMergeInputChains1_0,
   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2, 2, 1, 
  22, 
   OPC_CheckChild1Type, 78, 
   OPC_MoveChild2,
   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
   OPC_RecordChild0,
   OPC_MoveChild0,
   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
   OPC_MoveParent,
   OPC_MoveParent,
   OPC_CheckPatternPredicate0,
   OPC_EmitMergeInputChains1_0,
   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2, 2, 1, 
  22, 
   OPC_CheckChild1Type, 60, 
   OPC_MoveChild2,
   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
   OPC_RecordChild0,
   OPC_MoveChild0,
   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
   OPC_MoveParent,
   OPC_MoveParent,
   OPC_CheckPatternPredicate0,
   OPC_EmitMergeInputChains1_0,
   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2, 2, 1, 
  22, 
   OPC_CheckChild1Type, 39, 
   OPC_MoveChild2,
   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
   OPC_RecordChild0,
   OPC_MoveChild0,
   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
   OPC_MoveParent,
   OPC_MoveParent,
   OPC_CheckPatternPredicate0,
   OPC_EmitMergeInputChains1_0,
   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2, 2, 1, 
  22, 
   OPC_CheckChild1Type, 50, 
   OPC_MoveChild2,
   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
   OPC_RecordChild0,
   OPC_MoveChild0,
   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
   OPC_MoveParent,
   OPC_MoveParent,
   OPC_CheckPatternPredicate0,
   OPC_EmitMergeInputChains1_0,
   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2, 2, 1, 
  23, 
   OPC_CheckChild1Type, 99|128,1, 
   OPC_MoveChild2,
   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
   OPC_RecordChild0,
   OPC_MoveChild0,
   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
   OPC_MoveParent,
   OPC_MoveParent,
   OPC_CheckPatternPredicate6,
   OPC_EmitMergeInputChains1_0,
   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_FUNCREF), 0|OPFL_Chain|OPFL_MemRefs,
                 2, 2, 1, 
  23, 
   OPC_CheckChild1Type, 100|128,1, 
   OPC_MoveChild2,
   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
   OPC_RecordChild0,
   OPC_MoveChild0,
   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
   OPC_MoveParent,
   OPC_MoveParent,
   OPC_CheckPatternPredicate6,
   OPC_EmitMergeInputChains1_0,
   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_EXTERNREF), 0|OPFL_Chain|OPFL_MemRefs,
                 2, 2, 1, 
  24, 
   OPC_CheckChild1Type, 101|128,1, 
   OPC_MoveChild2,
   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
   OPC_RecordChild0,
   OPC_MoveChild0,
   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
   OPC_MoveParent,
   OPC_MoveParent,
   OPC_CheckPatternPredicate, 8,
   OPC_EmitMergeInputChains1_0,
   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_EXNREF), 0|OPFL_Chain|OPFL_MemRefs,
                 2, 2, 1, 
  0, 
 21, TARGET_VAL(ISD::CALLSEQ_START),
  OPC_RecordNode,
  OPC_RecordChild1,
  OPC_MoveChild1,
  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
  OPC_MoveSibling2,
  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
  OPC_RecordNode,
  OPC_MoveParent,
  OPC_EmitMergeInputChains1_0,
  OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADJCALLSTACKDOWN), 0|OPFL_Chain|OPFL_GlueOutput,
                7, 2, 1, 2, 
 22, TARGET_VAL(ISD::CALLSEQ_END),
  OPC_RecordNode,
  OPC_CaptureGlueInput,
  OPC_RecordChild1,
  OPC_MoveChild1,
  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
  OPC_MoveSibling2,
  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
  OPC_RecordNode,
  OPC_MoveParent,
  OPC_EmitMergeInputChains1_0,
  OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADJCALLSTACKUP), 0|OPFL_Chain|OPFL_GlueInput|OPFL_GlueOutput,
                7, 2, 1, 2, 
 60, TARGET_VAL(WebAssemblyISD::TABLE_GET),
  OPC_RecordMemRef,
  OPC_RecordNode,
  OPC_MoveChild1,
  OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
  OPC_RecordChild0,
  OPC_MoveChild0,
  OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
  OPC_MoveParent,
  OPC_MoveParent,
  OPC_RecordChild2,
  OPC_CheckChild2TypeI32,
  OPC_SwitchType , 11, 99|128,1, 
   OPC_CheckPatternPredicate6,
   OPC_EmitMergeInputChains1_0,
   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::TABLE_GET_FUNCREF), 0|OPFL_Chain|OPFL_MemRefs,
                 99|128,1, 2, 1, 2, 
  11, 100|128,1, 
   OPC_CheckPatternPredicate6,
   OPC_EmitMergeInputChains1_0,
   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::TABLE_GET_EXTERNREF), 0|OPFL_Chain|OPFL_MemRefs,
                 100|128,1, 2, 1, 2, 
  12, 101|128,1, 
   OPC_CheckPatternPredicate, 8,
   OPC_EmitMergeInputChains1_0,
   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::TABLE_GET_EXNREF), 0|OPFL_Chain|OPFL_MemRefs,
                 101|128,1, 2, 1, 2, 
  0,
 87, TARGET_VAL(WebAssemblyISD::TABLE_SET),
  OPC_RecordMemRef,
  OPC_RecordNode,
  OPC_Scope, 59, 
   OPC_MoveChild1,
   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
   OPC_RecordChild0,
   OPC_MoveChild0,
   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
   OPC_MoveParent,
   OPC_MoveParent,
   OPC_RecordChild2,
   OPC_CheckChild2TypeI32,
   OPC_RecordChild3,
   OPC_Scope, 13, 
    OPC_CheckChild3Type, 99|128,1, 
    OPC_CheckPatternPredicate6,
    OPC_EmitMergeInputChains1_0,
    OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::TABLE_SET_FUNCREF), 0|OPFL_Chain|OPFL_MemRefs,
                  3, 1, 2, 3, 
   13, 
    OPC_CheckChild3Type, 100|128,1, 
    OPC_CheckPatternPredicate6,
    OPC_EmitMergeInputChains1_0,
    OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::TABLE_SET_EXTERNREF), 0|OPFL_Chain|OPFL_MemRefs,
                  3, 1, 2, 3, 
   14, 
    OPC_CheckChild3Type, 101|128,1, 
    OPC_CheckPatternPredicate, 8,
    OPC_EmitMergeInputChains1_0,
    OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::TABLE_SET_EXNREF), 0|OPFL_Chain|OPFL_MemRefs,
                  3, 1, 2, 3, 
   0, 
  22, 
   OPC_RecordChild1,
   OPC_MoveChild1,
   OPC_CheckOpcode, TARGET_VAL(ISD::MCSymbol),
   OPC_MoveParent,
   OPC_RecordChild2,
   OPC_CheckChild2TypeI32,
   OPC_RecordChild3,
   OPC_CheckChild3Type, 99|128,1, 
   OPC_CheckPatternPredicate6,
   OPC_EmitMergeInputChains1_0,
   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::TABLE_SET_FUNCREF), 0|OPFL_Chain|OPFL_MemRefs,
                 3, 1, 2, 3, 
  0, 
 57, TARGET_VAL(WebAssemblyISD::MEMCPY),
  OPC_RecordNode,
  OPC_RecordChild1,
  OPC_MoveChild1,
  OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
  OPC_CheckTypeI32,
  OPC_MoveSibling2,
  OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
  OPC_RecordNode,
  OPC_CheckTypeI32,
  OPC_MoveParent,
  OPC_RecordChild3,
  OPC_Scope, 19, 
   OPC_CheckChild3TypeI32,
   OPC_RecordChild4,
   OPC_CheckChild4TypeI32,
   OPC_RecordChild5,
   OPC_CheckChild5TypeI32,
   OPC_CheckPatternPredicate, 12,
   OPC_EmitMergeInputChains1_0,
   OPC_EmitConvertToTarget1,
   OPC_EmitConvertToTarget2,
   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::MEMCPY_A32),
                 5, 6, 7, 3, 4, 5, 
  19, 
   OPC_CheckChild3TypeI64,
   OPC_RecordChild4,
   OPC_CheckChild4TypeI64,
   OPC_RecordChild5,
   OPC_CheckChild5TypeI64,
   OPC_CheckPatternPredicate, 12,
   OPC_EmitMergeInputChains1_0,
   OPC_EmitConvertToTarget1,
   OPC_EmitConvertToTarget2,
   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::MEMCPY_A64),
                 5, 6, 7, 3, 4, 5, 
  0, 
 119|128,9, TARGET_VAL(ISD::INTRINSIC_WO_CHAIN),
  OPC_Scope, 49, 
   OPC_CheckChild0Integer, 52|128,74|128,1, 
   OPC_RecordChild1,
   OPC_Scope, 20, 
    OPC_CheckChild1Type, 12, 
    OPC_SwitchType , 6, 7, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_S_F32),
                   7, 1, 0, 
    6, 8, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_S_F32),
                   8, 1, 0, 
    0,
   20, 
    OPC_CheckChild1Type, 13, 
    OPC_SwitchType , 6, 7, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_S_F64),
                   7, 1, 0, 
    6, 8, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_S_F64),
                   8, 1, 0, 
    0,
   0, 
  49, 
   OPC_CheckChild0Integer, 54|128,74|128,1, 
   OPC_RecordChild1,
   OPC_Scope, 20, 
    OPC_CheckChild1Type, 12, 
    OPC_SwitchType , 6, 7, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_U_F32),
                   7, 1, 0, 
    6, 8, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_U_F32),
                   8, 1, 0, 
    0,
   20, 
    OPC_CheckChild1Type, 13, 
    OPC_SwitchType , 6, 7, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_U_F64),
                   7, 1, 0, 
    6, 8, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_U_F64),
                   8, 1, 0, 
    0,
   0, 
  43, 
   OPC_CheckChild0Integer, 40|128,73|128,1, 
   OPC_RecordChild1,
   OPC_Scope, 8, 
    OPC_CheckChild1Type, 39, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                  7, 1, 0, 
   8, 
    OPC_CheckChild1Type, 50, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                  7, 1, 0, 
   8, 
    OPC_CheckChild1Type, 60, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                  7, 1, 0, 
   8, 
    OPC_CheckChild1Type, 78, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                  7, 1, 0, 
   0, 
  47, 
   OPC_CheckChild0Integer, 38|128,73|128,1, 
   OPC_RecordChild1,
   OPC_Scope, 9, 
    OPC_CheckChild1Type, 39, 
    OPC_CheckPatternPredicate0,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I8x16),
                  7, 1, 0, 
   9, 
    OPC_CheckChild1Type, 50, 
    OPC_CheckPatternPredicate0,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I16x8),
                  7, 1, 0, 
   9, 
    OPC_CheckChild1Type, 60, 
    OPC_CheckPatternPredicate0,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I32x4),
                  7, 1, 0, 
   9, 
    OPC_CheckChild1Type, 78, 
    OPC_CheckPatternPredicate0,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I64x2),
                  7, 1, 0, 
   0, 
  47, 
   OPC_CheckChild0Integer, 44|128,73|128,1, 
   OPC_RecordChild1,
   OPC_Scope, 9, 
    OPC_CheckChild1Type, 39, 
    OPC_CheckPatternPredicate0,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITMASK_I8x16),
                  7, 1, 0, 
   9, 
    OPC_CheckChild1Type, 50, 
    OPC_CheckPatternPredicate0,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITMASK_I16x8),
                  7, 1, 0, 
   9, 
    OPC_CheckChild1Type, 60, 
    OPC_CheckPatternPredicate0,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITMASK_I32x4),
                  7, 1, 0, 
   9, 
    OPC_CheckChild1Type, 78, 
    OPC_CheckPatternPredicate0,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITMASK_I64x2),
                  7, 1, 0, 
   0, 
  11, 
   OPC_CheckChild0Integer, 98|128,73|128,1, 
   OPC_CheckPatternPredicate6,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REF_NULL_FUNCREF),
                 99|128,1, 0, 
  12, 
   OPC_CheckChild0Integer, 92|128,73|128,1, 
   OPC_RecordChild1,
   OPC_CheckPatternPredicate6,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REF_IS_NULL_FUNCREF),
                 7, 1, 0, 
  11, 
   OPC_CheckChild0Integer, 96|128,73|128,1, 
   OPC_CheckPatternPredicate6,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REF_NULL_EXTERNREF),
                 100|128,1, 0, 
  12, 
   OPC_CheckChild0Integer, 90|128,73|128,1, 
   OPC_RecordChild1,
   OPC_CheckPatternPredicate6,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REF_IS_NULL_EXTERNREF),
                 7, 1, 0, 
  11, 
   OPC_CheckChild0Integer, 94|128,73|128,1, 
   OPC_CheckPatternPredicate6,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REF_NULL_EXNREF),
                 101|128,1, 0, 
  12, 
   OPC_CheckChild0Integer, 88|128,73|128,1, 
   OPC_RecordChild1,
   OPC_CheckPatternPredicate6,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REF_IS_NULL_EXNREF),
                 7, 1, 0, 
  23, 
   OPC_CheckChild0Integer, 56|128,73|128,1, 
   OPC_RecordChild1,
   OPC_RecordChild2,
   OPC_MoveChild2,
   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
   OPC_CheckPredicate, 13,
   OPC_MoveParent,
   OPC_CheckPatternPredicate, 16,
   OPC_EmitConvertToTarget1,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_F16x8),
                 12, 2, 0, 2, 
  13, 
   OPC_CheckChild0Integer, 10|128,74|128,1, 
   OPC_RecordChild1,
   OPC_RecordChild2,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SWIZZLE),
                 39, 2, 0, 1, 
  120, 
   OPC_CheckChild0Integer, 46|128,73|128,1, 
   OPC_RecordChild1,
   OPC_SwitchType , 16, 39, 
    OPC_CheckChild1Type, 39, 
    OPC_RecordChild2,
    OPC_CheckChild2Type, 39, 
    OPC_RecordChild3,
    OPC_CheckChild3Type, 39, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  39, 3, 0, 1, 2, 
   16, 50, 
    OPC_CheckChild1Type, 50, 
    OPC_RecordChild2,
    OPC_CheckChild2Type, 50, 
    OPC_RecordChild3,
    OPC_CheckChild3Type, 50, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  50, 3, 0, 1, 2, 
   16, 60, 
    OPC_CheckChild1Type, 60, 
    OPC_RecordChild2,
    OPC_CheckChild2Type, 60, 
    OPC_RecordChild3,
    OPC_CheckChild3Type, 60, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  60, 3, 0, 1, 2, 
   16, 78, 
    OPC_CheckChild1Type, 78, 
    OPC_RecordChild2,
    OPC_CheckChild2Type, 78, 
    OPC_RecordChild3,
    OPC_CheckChild3Type, 78, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  78, 3, 0, 1, 2, 
   16, 111, 
    OPC_CheckChild1Type, 111, 
    OPC_RecordChild2,
    OPC_CheckChild2Type, 111, 
    OPC_RecordChild3,
    OPC_CheckChild3Type, 111, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  111, 3, 0, 1, 2, 
   20, 1|128,1, 
    OPC_CheckChild1Type, 1|128,1, 
    OPC_RecordChild2,
    OPC_CheckChild2Type, 1|128,1, 
    OPC_RecordChild3,
    OPC_CheckChild3Type, 1|128,1, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  1|128,1, 3, 0, 1, 2, 
   0,
  37, 
   OPC_CheckChild0Integer, 42|128,73|128,1, 
   OPC_RecordChild1,
   OPC_SwitchType , 13, 39, 
    OPC_CheckChild1Type, 39, 
    OPC_RecordChild2,
    OPC_CheckChild2Type, 39, 
    OPC_CheckPatternPredicate0,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AVGR_U_I8x16),
                  39, 2, 0, 1, 
   13, 50, 
    OPC_CheckChild1Type, 50, 
    OPC_RecordChild2,
    OPC_CheckChild2Type, 50, 
    OPC_CheckPatternPredicate0,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AVGR_U_I16x8),
                  50, 2, 0, 1, 
   0,
  14, 
   OPC_CheckChild0Integer, 50|128,73|128,1, 
   OPC_RecordChild1,
   OPC_RecordChild2,
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DOT),
                 60, 2, 0, 1, 
  37, 
   OPC_CheckChild0Integer, 78|128,73|128,1, 
   OPC_RecordChild1,
   OPC_SwitchType , 13, 39, 
    OPC_CheckChild1Type, 50, 
    OPC_RecordChild2,
    OPC_CheckChild2Type, 50, 
    OPC_CheckPatternPredicate0,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NARROW_S_I8x16),
                  39, 2, 0, 1, 
   13, 50, 
    OPC_CheckChild1Type, 60, 
    OPC_RecordChild2,
    OPC_CheckChild2Type, 60, 
    OPC_CheckPatternPredicate0,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NARROW_S_I16x8),
                  50, 2, 0, 1, 
   0,
  37, 
   OPC_CheckChild0Integer, 80|128,73|128,1, 
   OPC_RecordChild1,
   OPC_SwitchType , 13, 39, 
    OPC_CheckChild1Type, 50, 
    OPC_RecordChild2,
    OPC_CheckChild2Type, 50, 
    OPC_CheckPatternPredicate0,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NARROW_U_I8x16),
                  39, 2, 0, 1, 
   13, 50, 
    OPC_CheckChild1Type, 60, 
    OPC_RecordChild2,
    OPC_CheckChild2Type, 60, 
    OPC_CheckPatternPredicate0,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NARROW_U_I16x8),
                  50, 2, 0, 1, 
   0,
  29, 
   OPC_CheckChild0Integer, 52|128,73|128,1, 
   OPC_RecordChild1,
   OPC_SwitchType , 9, 50, 
    OPC_CheckChild1Type, 39, 
    OPC_CheckPatternPredicate0,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_extadd_pairwise_signed_I16x8),
                  50, 1, 0, 
   9, 60, 
    OPC_CheckChild1Type, 50, 
    OPC_CheckPatternPredicate0,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_extadd_pairwise_signed_I32x4),
                  60, 1, 0, 
   0,
  29, 
   OPC_CheckChild0Integer, 54|128,73|128,1, 
   OPC_RecordChild1,
   OPC_SwitchType , 9, 50, 
    OPC_CheckChild1Type, 39, 
    OPC_CheckPatternPredicate0,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_extadd_pairwise_unsigned_I16x8),
                  50, 1, 0, 
   9, 60, 
    OPC_CheckChild1Type, 50, 
    OPC_CheckPatternPredicate0,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_extadd_pairwise_unsigned_I32x4),
                  60, 1, 0, 
   0,
  14, 
   OPC_CheckChild0Integer, 86|128,73|128,1, 
   OPC_RecordChild1,
   OPC_RecordChild2,
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::Q15MULR_SAT_S_I16x8),
                 50, 2, 0, 1, 
  14, 
   OPC_CheckChild0Integer, 118|128,73|128,1, 
   OPC_RecordChild1,
   OPC_RecordChild2,
   OPC_CheckPatternPredicate7,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::RELAXED_SWIZZLE),
                 39, 2, 0, 1, 
  12, 
   OPC_CheckChild0Integer, 120|128,73|128,1, 
   OPC_RecordChild1,
   OPC_CheckPatternPredicate7,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_relaxed_trunc_signed_I32x4),
                 60, 1, 0, 
  12, 
   OPC_CheckChild0Integer, 124|128,73|128,1, 
   OPC_RecordChild1,
   OPC_CheckPatternPredicate7,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_relaxed_trunc_unsigned_I32x4),
                 60, 1, 0, 
  12, 
   OPC_CheckChild0Integer, 122|128,73|128,1, 
   OPC_RecordChild1,
   OPC_CheckPatternPredicate7,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_relaxed_trunc_signed_zero_I32x4),
                 60, 1, 0, 
  12, 
   OPC_CheckChild0Integer, 126|128,73|128,1, 
   OPC_RecordChild1,
   OPC_CheckPatternPredicate7,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_relaxed_trunc_unsigned_zero_I32x4),
                 60, 1, 0, 
  83, 
   OPC_CheckChild0Integer, 106|128,73|128,1, 
   OPC_RecordChild1,
   OPC_SwitchType , 17, 39, 
    OPC_CheckChild1Type, 39, 
    OPC_RecordChild2,
    OPC_CheckChild2Type, 39, 
    OPC_RecordChild3,
    OPC_CheckChild3Type, 39, 
    OPC_CheckPatternPredicate7,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LANESELECT_I8x16),
                  39, 3, 0, 1, 2, 
   17, 50, 
    OPC_CheckChild1Type, 50, 
    OPC_RecordChild2,
    OPC_CheckChild2Type, 50, 
    OPC_RecordChild3,
    OPC_CheckChild3Type, 50, 
    OPC_CheckPatternPredicate7,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LANESELECT_I16x8),
                  50, 3, 0, 1, 2, 
   17, 60, 
    OPC_CheckChild1Type, 60, 
    OPC_RecordChild2,
    OPC_CheckChild2Type, 60, 
    OPC_RecordChild3,
    OPC_CheckChild3Type, 60, 
    OPC_CheckPatternPredicate7,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LANESELECT_I32x4),
                  60, 3, 0, 1, 2, 
   17, 78, 
    OPC_CheckChild1Type, 78, 
    OPC_RecordChild2,
    OPC_CheckChild2Type, 78, 
    OPC_RecordChild3,
    OPC_CheckChild3Type, 78, 
    OPC_CheckPatternPredicate7,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LANESELECT_I64x2),
                  78, 3, 0, 1, 2, 
   0,
  14, 
   OPC_CheckChild0Integer, 116|128,73|128,1, 
   OPC_RecordChild1,
   OPC_RecordChild2,
   OPC_CheckPatternPredicate7,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::RELAXED_Q15MULR_S_I16x8),
                 50, 2, 0, 1, 
  14, 
   OPC_CheckChild0Integer, 104|128,73|128,1, 
   OPC_RecordChild1,
   OPC_RecordChild2,
   OPC_CheckPatternPredicate7,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::RELAXED_DOT),
                 50, 2, 0, 1, 
  16, 
   OPC_CheckChild0Integer, 102|128,73|128,1, 
   OPC_RecordChild1,
   OPC_RecordChild2,
   OPC_RecordChild3,
   OPC_CheckPatternPredicate7,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::RELAXED_DOT_ADD),
                 60, 3, 0, 1, 2, 
  25, 
   OPC_CheckChild0Integer, 0|128,74|128,1, 
   OPC_RecordChild1,
   OPC_RecordChild2,
   OPC_MoveChild2,
   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
   OPC_CheckPredicate, 13,
   OPC_MoveParent,
   OPC_RecordChild3,
   OPC_CheckPatternPredicate, 16,
   OPC_EmitConvertToTarget1,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_F16x8),
                 92, 3, 0, 3, 2, 
  13, 
   OPC_CheckChild0Integer, 6|128,74|128,1, 
   OPC_RecordChild1,
   OPC_CheckPatternPredicate, 16,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_F16x8),
                 92, 1, 0, 
  53, 
   OPC_CheckChild0Integer, 84|128,73|128,1, 
   OPC_RecordChild1,
   OPC_SwitchType , 12, 111, 
    OPC_CheckChild1Type, 111, 
    OPC_RecordChild2,
    OPC_CheckChild2Type, 111, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                  111, 2, 0, 1, 
   15, 1|128,1, 
    OPC_CheckChild1Type, 1|128,1, 
    OPC_RecordChild2,
    OPC_CheckChild2Type, 1|128,1, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                  1|128,1, 2, 0, 1, 
   12, 92, 
    OPC_CheckChild1Type, 92, 
    OPC_RecordChild2,
    OPC_CheckChild2Type, 92, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                  92, 2, 0, 1, 
   0,
  53, 
   OPC_CheckChild0Integer, 82|128,73|128,1, 
   OPC_RecordChild1,
   OPC_SwitchType , 12, 111, 
    OPC_CheckChild1Type, 111, 
    OPC_RecordChild2,
    OPC_CheckChild2Type, 111, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                  111, 2, 0, 1, 
   15, 1|128,1, 
    OPC_CheckChild1Type, 1|128,1, 
    OPC_RecordChild2,
    OPC_CheckChild2Type, 1|128,1, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                  1|128,1, 2, 0, 1, 
   12, 92, 
    OPC_CheckChild1Type, 92, 
    OPC_RecordChild2,
    OPC_CheckChild2Type, 92, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                  92, 2, 0, 1, 
   0,
  71, 
   OPC_CheckChild0Integer, 108|128,73|128,1, 
   OPC_RecordChild1,
   OPC_SwitchType , 18, 111, 
    OPC_CheckChild1Type, 111, 
    OPC_RecordChild2,
    OPC_CheckChild2Type, 111, 
    OPC_RecordChild3,
    OPC_CheckChild3Type, 111, 
    OPC_CheckPatternPredicate, 13,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MADD_F32x4),
                  111, 3, 0, 1, 2, 
   22, 1|128,1, 
    OPC_CheckChild1Type, 1|128,1, 
    OPC_RecordChild2,
    OPC_CheckChild2Type, 1|128,1, 
    OPC_RecordChild3,
    OPC_CheckChild3Type, 1|128,1, 
    OPC_CheckPatternPredicate, 13,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MADD_F64x2),
                  1|128,1, 3, 0, 1, 2, 
   17, 92, 
    OPC_CheckChild1Type, 92, 
    OPC_RecordChild2,
    OPC_CheckChild2Type, 92, 
    OPC_RecordChild3,
    OPC_CheckChild3Type, 92, 
    OPC_CheckPatternPredicate5,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MADD_F16x8),
                  92, 3, 0, 1, 2, 
   0,
  71, 
   OPC_CheckChild0Integer, 114|128,73|128,1, 
   OPC_RecordChild1,
   OPC_SwitchType , 18, 111, 
    OPC_CheckChild1Type, 111, 
    OPC_RecordChild2,
    OPC_CheckChild2Type, 111, 
    OPC_RecordChild3,
    OPC_CheckChild3Type, 111, 
    OPC_CheckPatternPredicate, 13,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NMADD_F32x4),
                  111, 3, 0, 1, 2, 
   22, 1|128,1, 
    OPC_CheckChild1Type, 1|128,1, 
    OPC_RecordChild2,
    OPC_CheckChild2Type, 1|128,1, 
    OPC_RecordChild3,
    OPC_CheckChild3Type, 1|128,1, 
    OPC_CheckPatternPredicate, 13,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NMADD_F64x2),
                  1|128,1, 3, 0, 1, 2, 
   17, 92, 
    OPC_CheckChild1Type, 92, 
    OPC_RecordChild2,
    OPC_CheckChild2Type, 92, 
    OPC_RecordChild3,
    OPC_CheckChild3Type, 92, 
    OPC_CheckPatternPredicate5,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NMADD_F16x8),
                  92, 3, 0, 1, 2, 
   0,
  41, 
   OPC_CheckChild0Integer, 112|128,73|128,1, 
   OPC_RecordChild1,
   OPC_SwitchType , 13, 111, 
    OPC_CheckChild1Type, 111, 
    OPC_RecordChild2,
    OPC_CheckChild2Type, 111, 
    OPC_CheckPatternPredicate7,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SIMD_RELAXED_FMIN_F32x4),
                  111, 2, 0, 1, 
   16, 1|128,1, 
    OPC_CheckChild1Type, 1|128,1, 
    OPC_RecordChild2,
    OPC_CheckChild2Type, 1|128,1, 
    OPC_CheckPatternPredicate7,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SIMD_RELAXED_FMIN_F64x2),
                  1|128,1, 2, 0, 1, 
   0,
  41, 
   OPC_CheckChild0Integer, 110|128,73|128,1, 
   OPC_RecordChild1,
   OPC_SwitchType , 13, 111, 
    OPC_CheckChild1Type, 111, 
    OPC_RecordChild2,
    OPC_CheckChild2Type, 111, 
    OPC_CheckPatternPredicate7,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SIMD_RELAXED_FMAX_F32x4),
                  111, 2, 0, 1, 
   16, 1|128,1, 
    OPC_CheckChild1Type, 1|128,1, 
    OPC_RecordChild2,
    OPC_CheckChild2Type, 1|128,1, 
    OPC_CheckPatternPredicate7,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SIMD_RELAXED_FMAX_F64x2),
                  1|128,1, 2, 0, 1, 
   0,
  16, 
   OPC_CheckChild0Integer, 100|128,73|128,1, 
   OPC_RecordChild1,
   OPC_RecordChild2,
   OPC_RecordChild3,
   OPC_CheckPatternPredicate7,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::RELAXED_DOT_BFLOAT),
                 111, 3, 0, 1, 2, 
  0, 
 4|128,1, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),
  OPC_RecordChild0,
  OPC_Scope, 20, 
   OPC_CheckChild0Type, 39, 
   OPC_RecordChild1,
   OPC_MoveChild1,
   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
   OPC_CheckPredicate, 18,
   OPC_CheckTypeI32,
   OPC_MoveParent,
   OPC_CheckTypeI32,
   OPC_EmitConvertToTarget1,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I8x16_u),
                 7, 2, 0, 2, 
  20, 
   OPC_CheckChild0Type, 50, 
   OPC_RecordChild1,
   OPC_MoveChild1,
   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
   OPC_CheckPredicate, 13,
   OPC_CheckTypeI32,
   OPC_MoveParent,
   OPC_CheckTypeI32,
   OPC_EmitConvertToTarget1,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I16x8_u),
                 7, 2, 0, 2, 
  20, 
   OPC_CheckChild0Type, 60, 
   OPC_RecordChild1,
   OPC_MoveChild1,
   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
   OPC_CheckPredicate, 11,
   OPC_CheckTypeI32,
   OPC_MoveParent,
   OPC_CheckTypeI32,
   OPC_EmitConvertToTarget1,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I32x4),
                 7, 2, 0, 2, 
  20, 
   OPC_CheckChild0Type, 78, 
   OPC_RecordChild1,
   OPC_MoveChild1,
   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
   OPC_CheckPredicate, 12,
   OPC_CheckTypeI32,
   OPC_MoveParent,
   OPC_CheckTypeI64,
   OPC_EmitConvertToTarget1,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I64x2),
                 8, 2, 0, 2, 
  21, 
   OPC_CheckChild0Type, 111, 
   OPC_RecordChild1,
   OPC_MoveChild1,
   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
   OPC_CheckPredicate, 11,
   OPC_CheckTypeI32,
   OPC_MoveParent,
   OPC_CheckType, 12, 
   OPC_EmitConvertToTarget1,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_F32x4),
                 12, 2, 0, 2, 
  22, 
   OPC_CheckChild0Type, 1|128,1, 
   OPC_RecordChild1,
   OPC_MoveChild1,
   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
   OPC_CheckPredicate, 12,
   OPC_CheckTypeI32,
   OPC_MoveParent,
   OPC_CheckType, 13, 
   OPC_EmitConvertToTarget1,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_F64x2),
                 13, 2, 0, 2, 
  0, 
 0|128,1, TARGET_VAL(WebAssemblyISD::ARGUMENT),
  OPC_RecordChild0,
  OPC_MoveChild0,
  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
  OPC_MoveParent,
  OPC_SwitchType , 6, 7, 
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_i32),
                 7, 1, 0, 
  6, 8, 
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_i64),
                 8, 1, 0, 
  7, 99|128,1, 
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_funcref),
                 99|128,1, 1, 0, 
  7, 100|128,1, 
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_externref),
                 100|128,1, 1, 0, 
  7, 101|128,1, 
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_exnref),
                 101|128,1, 1, 0, 
  6, 12, 
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_f32),
                 12, 1, 0, 
  6, 13, 
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_f64),
                 13, 1, 0, 
  6, 39, 
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v16i8),
                 39, 1, 0, 
  6, 50, 
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v8i16),
                 50, 1, 0, 
  6, 60, 
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v4i32),
                 60, 1, 0, 
  6, 78, 
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v2i64),
                 78, 1, 0, 
  6, 111, 
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v4f32),
                 111, 1, 0, 
  7, 1|128,1, 
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v2f64),
                 1|128,1, 1, 0, 
  6, 92, 
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v8f16),
                 92, 1, 0, 
  0,
 26|128,1, TARGET_VAL(WebAssemblyISD::LOCAL_GET),
  OPC_RecordNode,
  OPC_RecordChild1,
  OPC_MoveChild1,
  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
  OPC_MoveParent,
  OPC_SwitchType , 7, 7, 
   OPC_EmitMergeInputChains1_0,
   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_I32),
                 7, 1, 1, 
  7, 8, 
   OPC_EmitMergeInputChains1_0,
   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_I64),
                 8, 1, 1, 
  9, 99|128,1, 
   OPC_CheckPatternPredicate6,
   OPC_EmitMergeInputChains1_0,
   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_FUNCREF),
                 99|128,1, 1, 1, 
  9, 100|128,1, 
   OPC_CheckPatternPredicate6,
   OPC_EmitMergeInputChains1_0,
   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_EXTERNREF),
                 100|128,1, 1, 1, 
  10, 101|128,1, 
   OPC_CheckPatternPredicate, 8,
   OPC_EmitMergeInputChains1_0,
   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_EXNREF),
                 101|128,1, 1, 1, 
  7, 12, 
   OPC_EmitMergeInputChains1_0,
   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_F32),
                 12, 1, 1, 
  7, 13, 
   OPC_EmitMergeInputChains1_0,
   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_F64),
                 13, 1, 1, 
  8, 78, 
   OPC_CheckPatternPredicate0,
   OPC_EmitMergeInputChains1_0,
   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 78, 1, 1, 
  8, 60, 
   OPC_CheckPatternPredicate0,
   OPC_EmitMergeInputChains1_0,
   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 60, 1, 1, 
  8, 39, 
   OPC_CheckPatternPredicate0,
   OPC_EmitMergeInputChains1_0,
   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 39, 1, 1, 
  8, 50, 
   OPC_CheckPatternPredicate0,
   OPC_EmitMergeInputChains1_0,
   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 50, 1, 1, 
  8, 92, 
   OPC_CheckPatternPredicate0,
   OPC_EmitMergeInputChains1_0,
   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 92, 1, 1, 
  8, 111, 
   OPC_CheckPatternPredicate0,
   OPC_EmitMergeInputChains1_0,
   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 111, 1, 1, 
  9, 1|128,1, 
   OPC_CheckPatternPredicate0,
   OPC_EmitMergeInputChains1_0,
   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 1|128,1, 1, 1, 
  0,
 35|128,1, TARGET_VAL(WebAssemblyISD::LOCAL_SET),
  OPC_RecordNode,
  OPC_RecordChild1,
  OPC_MoveChild1,
  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
  OPC_MoveParent,
  OPC_RecordChild2,
  OPC_Scope, 8, 
   OPC_CheckChild2TypeI32,
   OPC_EmitMergeInputChains1_0,
   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_I32),
                 2, 1, 2, 
  8, 
   OPC_CheckChild2TypeI64,
   OPC_EmitMergeInputChains1_0,
   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_I64),
                 2, 1, 2, 
  9, 
   OPC_CheckChild2Type, 12, 
   OPC_EmitMergeInputChains1_0,
   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_F32),
                 2, 1, 2, 
  9, 
   OPC_CheckChild2Type, 13, 
   OPC_EmitMergeInputChains1_0,
   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_F64),
                 2, 1, 2, 
  10, 
   OPC_CheckChild2Type, 92, 
   OPC_CheckPatternPredicate0,
   OPC_EmitMergeInputChains1_0,
   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2, 1, 2, 
  10, 
   OPC_CheckChild2Type, 111, 
   OPC_CheckPatternPredicate0,
   OPC_EmitMergeInputChains1_0,
   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2, 1, 2, 
  11, 
   OPC_CheckChild2Type, 1|128,1, 
   OPC_CheckPatternPredicate0,
   OPC_EmitMergeInputChains1_0,
   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2, 1, 2, 
  10, 
   OPC_CheckChild2Type, 78, 
   OPC_CheckPatternPredicate0,
   OPC_EmitMergeInputChains1_0,
   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2, 1, 2, 
  10, 
   OPC_CheckChild2Type, 60, 
   OPC_CheckPatternPredicate0,
   OPC_EmitMergeInputChains1_0,
   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2, 1, 2, 
  10, 
   OPC_CheckChild2Type, 39, 
   OPC_CheckPatternPredicate0,
   OPC_EmitMergeInputChains1_0,
   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2, 1, 2, 
  10, 
   OPC_CheckChild2Type, 50, 
   OPC_CheckPatternPredicate0,
   OPC_EmitMergeInputChains1_0,
   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2, 1, 2, 
  11, 
   OPC_CheckChild2Type, 99|128,1, 
   OPC_CheckPatternPredicate6,
   OPC_EmitMergeInputChains1_0,
   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_FUNCREF),
                 2, 1, 2, 
  11, 
   OPC_CheckChild2Type, 100|128,1, 
   OPC_CheckPatternPredicate6,
   OPC_EmitMergeInputChains1_0,
   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_EXTERNREF),
                 2, 1, 2, 
  12, 
   OPC_CheckChild2Type, 101|128,1, 
   OPC_CheckPatternPredicate, 8,
   OPC_EmitMergeInputChains1_0,
   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_EXNREF),
                 2, 1, 2, 
  0, 
 0|128,1, TARGET_VAL(WebAssemblyISD::Wrapper),
  OPC_RecordChild0,
  OPC_MoveChild0,
  OPC_SwitchOpcode , 47, TARGET_VAL(ISD::TargetGlobalAddress),
   OPC_MoveParent,
   OPC_SwitchType , 20, 7, 
    OPC_Scope, 8, 
     OPC_CheckPatternPredicate, 17,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I32),
                   7, 1, 0, 
    8, 
     OPC_CheckPatternPredicate, 14,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GLOBAL_GET_I32),
                   7, 1, 0, 
    0, 
   20, 8, 
    OPC_Scope, 8, 
     OPC_CheckPatternPredicate, 18,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I64),
                   8, 1, 0, 
    8, 
     OPC_CheckPatternPredicate, 15,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GLOBAL_GET_I64),
                   8, 1, 0, 
    0, 
   0,
  21, TARGET_VAL(ISD::TargetGlobalTLSAddress),
   OPC_MoveParent,
   OPC_SwitchType , 7, 7, 
    OPC_CheckPatternPredicate1,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GLOBAL_GET_I32),
                  7, 1, 0, 
   7, 8, 
    OPC_CheckPatternPredicate2,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GLOBAL_GET_I64),
                  8, 1, 0, 
   0,
  47, TARGET_VAL(ISD::TargetExternalSymbol),
   OPC_MoveParent,
   OPC_SwitchType , 20, 7, 
    OPC_Scope, 8, 
     OPC_CheckPatternPredicate, 14,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GLOBAL_GET_I32),
                   7, 1, 0, 
    8, 
     OPC_CheckPatternPredicate, 17,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I32),
                   7, 1, 0, 
    0, 
   20, 8, 
    OPC_Scope, 8, 
     OPC_CheckPatternPredicate, 15,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GLOBAL_GET_I64),
                   8, 1, 0, 
    8, 
     OPC_CheckPatternPredicate, 18,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I64),
                   8, 1, 0, 
    0, 
   0,
  0,
 80, TARGET_VAL(WebAssemblyISD::WrapperREL),
  OPC_RecordChild0,
  OPC_MoveChild0,
  OPC_SwitchOpcode , 23, TARGET_VAL(ISD::TargetGlobalAddress),
   OPC_MoveParent,
   OPC_SwitchType , 8, 7, 
    OPC_CheckPatternPredicate, 14,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I32),
                  7, 1, 0, 
   8, 8, 
    OPC_CheckPatternPredicate, 15,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I64),
                  8, 1, 0, 
   0,
  21, TARGET_VAL(ISD::TargetGlobalTLSAddress),
   OPC_MoveParent,
   OPC_SwitchType , 7, 7, 
    OPC_CheckPatternPredicate1,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I32),
                  7, 1, 0, 
   7, 8, 
    OPC_CheckPatternPredicate2,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I64),
                  8, 1, 0, 
   0,
  23, TARGET_VAL(ISD::TargetExternalSymbol),
   OPC_MoveParent,
   OPC_SwitchType , 8, 7, 
    OPC_CheckPatternPredicate, 14,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I32),
                  7, 1, 0, 
   8, 8, 
    OPC_CheckPatternPredicate, 15,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I64),
                  8, 1, 0, 
   0,
  0,
 47, TARGET_VAL(WebAssemblyISD::MEMSET),
  OPC_RecordNode,
  OPC_RecordChild1,
  OPC_MoveChild1,
  OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
  OPC_CheckTypeI32,
  OPC_MoveParent,
  OPC_RecordChild2,
  OPC_Scope, 17, 
   OPC_CheckChild2TypeI32,
   OPC_RecordChild3,
   OPC_CheckChild3TypeI32,
   OPC_RecordChild4,
   OPC_CheckChild4TypeI32,
   OPC_CheckPatternPredicate, 12,
   OPC_EmitMergeInputChains1_0,
   OPC_EmitConvertToTarget1,
   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::MEMSET_A32),
                 4, 5, 2, 3, 4, 
  17, 
   OPC_CheckChild2TypeI64,
   OPC_RecordChild3,
   OPC_CheckChild3TypeI32,
   OPC_RecordChild4,
   OPC_CheckChild4TypeI64,
   OPC_CheckPatternPredicate, 12,
   OPC_EmitMergeInputChains1_0,
   OPC_EmitConvertToTarget1,
   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::MEMSET_A64),
                 4, 5, 2, 3, 4, 
  0, 
 21, TARGET_VAL(ISD::Constant),
  OPC_RecordNode,
  OPC_SwitchType , 7, 7, 
   OPC_EmitConvertToTarget0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I32),
                 7, 1, 1, 
  7, 8, 
   OPC_EmitConvertToTarget0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I64),
                 8, 1, 1, 
  0,
 13, TARGET_VAL(ISD::BR),
  OPC_RecordNode,
  OPC_RecordChild1,
  OPC_MoveChild1,
  OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
  OPC_MoveParent,
  OPC_EmitMergeInputChains1_0,
  OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::BR),
                1, 1, 
 22, TARGET_VAL(WebAssemblyISD::BR_TABLE),
  OPC_RecordNode,
  OPC_RecordChild1,
  OPC_Scope, 8, 
   OPC_CheckChild1TypeI32,
   OPC_EmitMergeInputChains1_0,
   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::BR_TABLE_I32), 0|OPFL_Chain|OPFL_Variadic1,
                 1, 1, 
  8, 
   OPC_CheckChild1TypeI64,
   OPC_EmitMergeInputChains1_0,
   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::BR_TABLE_I64), 0|OPFL_Chain|OPFL_Variadic1,
                 1, 1, 
  0, 
 7, TARGET_VAL(WebAssemblyISD::RETURN),
  OPC_RecordNode,
  OPC_EmitMergeInputChains1_0,
  OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::RETURN), 0|OPFL_Chain|OPFL_Variadic0,
                0, 
 6, TARGET_VAL(ISD::TRAP),
  OPC_RecordNode,
  OPC_EmitMergeInputChains1_0,
  OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::UNREACHABLE),
                0, 
 6, TARGET_VAL(ISD::DEBUGTRAP),
  OPC_RecordNode,
  OPC_EmitMergeInputChains1_0,
  OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::DEBUG_UNREACHABLE),
                0, 
 15, TARGET_VAL(ISD::CLEANUPRET),
  OPC_RecordNode,
  OPC_RecordChild1,
  OPC_MoveChild1,
  OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
  OPC_MoveParent,
  OPC_CheckPatternPredicate, 19,
  OPC_EmitMergeInputChains1_0,
  OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::CLEANUPRET),
                1, 1, 
 21, TARGET_VAL(ISD::CATCHRET),
  OPC_RecordNode,
  OPC_RecordChild1,
  OPC_MoveChild1,
  OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
  OPC_MoveSibling2,
  OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
  OPC_RecordNode,
  OPC_MoveParent,
  OPC_CheckPatternPredicate, 19,
  OPC_EmitMergeInputChains1_0,
  OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::CATCHRET),
                2, 1, 2, 
 62, TARGET_VAL(ISD::ADD),
  OPC_RecordChild0,
  OPC_RecordChild1,
  OPC_SwitchType , 7, 7, 
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_I32),
                 7, 2, 0, 1, 
  7, 8, 
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_I64),
                 8, 2, 0, 1, 
  8, 39, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_I8x16),
                 39, 2, 0, 1, 
  8, 50, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_I16x8),
                 50, 2, 0, 1, 
  8, 60, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_I32x4),
                 60, 2, 0, 1, 
  8, 78, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_I64x2),
                 78, 2, 0, 1, 
  0,
 113, TARGET_VAL(ISD::SUB),
  OPC_Scope, 22, 
   OPC_RecordChild0,
   OPC_RecordChild1,
   OPC_SwitchType , 7, 7, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_I32),
                  7, 2, 0, 1, 
   7, 8, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_I64),
                  8, 2, 0, 1, 
   0,
  42, 
   OPC_MoveChild0,
   OPC_CheckImmAllZerosV,
   OPC_MoveParent,
   OPC_RecordChild1,
   OPC_SwitchType , 7, 39, 
    OPC_CheckPatternPredicate0,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_I8x16),
                  39, 1, 0, 
   7, 50, 
    OPC_CheckPatternPredicate0,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_I16x8),
                  50, 1, 0, 
   7, 60, 
    OPC_CheckPatternPredicate0,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_I32x4),
                  60, 1, 0, 
   7, 78, 
    OPC_CheckPatternPredicate0,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_I64x2),
                  78, 1, 0, 
   0,
  44, 
   OPC_RecordChild0,
   OPC_RecordChild1,
   OPC_SwitchType , 8, 39, 
    OPC_CheckPatternPredicate0,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_I8x16),
                  39, 2, 0, 1, 
   8, 50, 
    OPC_CheckPatternPredicate0,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_I16x8),
                  50, 2, 0, 1, 
   8, 60, 
    OPC_CheckPatternPredicate0,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_I32x4),
                  60, 2, 0, 1, 
   8, 78, 
    OPC_CheckPatternPredicate0,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_I64x2),
                  78, 2, 0, 1, 
   0,
  0, 
 85|128,2, TARGET_VAL(ISD::MUL),
  OPC_Scope, 22, 
   OPC_RecordChild0,
   OPC_RecordChild1,
   OPC_SwitchType , 7, 7, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_I32),
                  7, 2, 0, 1, 
   7, 8, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_I64),
                  8, 2, 0, 1, 
   0,
  23|128,2, 
   OPC_MoveChild0,
   OPC_SwitchOpcode , 66, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_S),
    OPC_RecordChild0,
    OPC_Scope, 20, 
     OPC_CheckChild0Type, 39, 
     OPC_MoveSibling1,
     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_S),
     OPC_RecordChild0,
     OPC_CheckChild0Type, 39, 
     OPC_MoveParent,
     OPC_CheckType, 50, 
     OPC_CheckPatternPredicate0,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_LOW_S_I16x8),
                   50, 2, 0, 1, 
    20, 
     OPC_CheckChild0Type, 50, 
     OPC_MoveSibling1,
     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_S),
     OPC_RecordChild0,
     OPC_CheckChild0Type, 50, 
     OPC_MoveParent,
     OPC_CheckType, 60, 
     OPC_CheckPatternPredicate0,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_LOW_S_I32x4),
                   60, 2, 0, 1, 
    20, 
     OPC_CheckChild0Type, 60, 
     OPC_MoveSibling1,
     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_S),
     OPC_RecordChild0,
     OPC_CheckChild0Type, 60, 
     OPC_MoveParent,
     OPC_CheckType, 78, 
     OPC_CheckPatternPredicate0,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_LOW_S_I64x2),
                   78, 2, 0, 1, 
    0, 
   66, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_S),
    OPC_RecordChild0,
    OPC_Scope, 20, 
     OPC_CheckChild0Type, 39, 
     OPC_MoveSibling1,
     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_S),
     OPC_RecordChild0,
     OPC_CheckChild0Type, 39, 
     OPC_MoveParent,
     OPC_CheckType, 50, 
     OPC_CheckPatternPredicate0,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_HIGH_S_I16x8),
                   50, 2, 0, 1, 
    20, 
     OPC_CheckChild0Type, 50, 
     OPC_MoveSibling1,
     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_S),
     OPC_RecordChild0,
     OPC_CheckChild0Type, 50, 
     OPC_MoveParent,
     OPC_CheckType, 60, 
     OPC_CheckPatternPredicate0,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_HIGH_S_I32x4),
                   60, 2, 0, 1, 
    20, 
     OPC_CheckChild0Type, 60, 
     OPC_MoveSibling1,
     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_S),
     OPC_RecordChild0,
     OPC_CheckChild0Type, 60, 
     OPC_MoveParent,
     OPC_CheckType, 78, 
     OPC_CheckPatternPredicate0,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_HIGH_S_I64x2),
                   78, 2, 0, 1, 
    0, 
   66, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_U),
    OPC_RecordChild0,
    OPC_Scope, 20, 
     OPC_CheckChild0Type, 39, 
     OPC_MoveSibling1,
     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_U),
     OPC_RecordChild0,
     OPC_CheckChild0Type, 39, 
     OPC_MoveParent,
     OPC_CheckType, 50, 
     OPC_CheckPatternPredicate0,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_LOW_U_I16x8),
                   50, 2, 0, 1, 
    20, 
     OPC_CheckChild0Type, 50, 
     OPC_MoveSibling1,
     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_U),
     OPC_RecordChild0,
     OPC_CheckChild0Type, 50, 
     OPC_MoveParent,
     OPC_CheckType, 60, 
     OPC_CheckPatternPredicate0,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_LOW_U_I32x4),
                   60, 2, 0, 1, 
    20, 
     OPC_CheckChild0Type, 60, 
     OPC_MoveSibling1,
     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_U),
     OPC_RecordChild0,
     OPC_CheckChild0Type, 60, 
     OPC_MoveParent,
     OPC_CheckType, 78, 
     OPC_CheckPatternPredicate0,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_LOW_U_I64x2),
                   78, 2, 0, 1, 
    0, 
   66, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_U),
    OPC_RecordChild0,
    OPC_Scope, 20, 
     OPC_CheckChild0Type, 39, 
     OPC_MoveSibling1,
     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_U),
     OPC_RecordChild0,
     OPC_CheckChild0Type, 39, 
     OPC_MoveParent,
     OPC_CheckType, 50, 
     OPC_CheckPatternPredicate0,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_HIGH_U_I16x8),
                   50, 2, 0, 1, 
    20, 
     OPC_CheckChild0Type, 50, 
     OPC_MoveSibling1,
     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_U),
     OPC_RecordChild0,
     OPC_CheckChild0Type, 50, 
     OPC_MoveParent,
     OPC_CheckType, 60, 
     OPC_CheckPatternPredicate0,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_HIGH_U_I32x4),
                   60, 2, 0, 1, 
    20, 
     OPC_CheckChild0Type, 60, 
     OPC_MoveSibling1,
     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_U),
     OPC_RecordChild0,
     OPC_CheckChild0Type, 60, 
     OPC_MoveParent,
     OPC_CheckType, 78, 
     OPC_CheckPatternPredicate0,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_HIGH_U_I64x2),
                   78, 2, 0, 1, 
    0, 
   0,
  34, 
   OPC_RecordChild0,
   OPC_RecordChild1,
   OPC_SwitchType , 8, 50, 
    OPC_CheckPatternPredicate0,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_I16x8),
                  50, 2, 0, 1, 
   8, 60, 
    OPC_CheckPatternPredicate0,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_I32x4),
                  60, 2, 0, 1, 
   8, 78, 
    OPC_CheckPatternPredicate0,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_I64x2),
                  78, 2, 0, 1, 
   0,
  0, 
 22, TARGET_VAL(ISD::SDIV),
  OPC_RecordChild0,
  OPC_RecordChild1,
  OPC_SwitchType , 7, 7, 
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_S_I32),
                 7, 2, 0, 1, 
  7, 8, 
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_S_I64),
                 8, 2, 0, 1, 
  0,
 22, TARGET_VAL(ISD::UDIV),
  OPC_RecordChild0,
  OPC_RecordChild1,
  OPC_SwitchType , 7, 7, 
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_U_I32),
                 7, 2, 0, 1, 
  7, 8, 
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_U_I64),
                 8, 2, 0, 1, 
  0,
 22, TARGET_VAL(ISD::SREM),
  OPC_RecordChild0,
  OPC_RecordChild1,
  OPC_SwitchType , 7, 7, 
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REM_S_I32),
                 7, 2, 0, 1, 
  7, 8, 
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REM_S_I64),
                 8, 2, 0, 1, 
  0,
 22, TARGET_VAL(ISD::UREM),
  OPC_RecordChild0,
  OPC_RecordChild1,
  OPC_SwitchType , 7, 7, 
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REM_U_I32),
                 7, 2, 0, 1, 
  7, 8, 
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REM_U_I64),
                 8, 2, 0, 1, 
  0,
 56|128,6, TARGET_VAL(ISD::OR),
  OPC_Scope, 22, 
   OPC_RecordChild0,
   OPC_RecordChild1,
   OPC_SwitchType , 7, 7, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::OR_I32),
                  7, 2, 0, 1, 
   7, 8, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::OR_I64),
                  8, 2, 0, 1, 
   0,
  116|128,5, 
   OPC_MoveChild0,
   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
   OPC_Scope, 4|128,1, 
    OPC_RecordChild0,
    OPC_RecordChild1,
    OPC_MoveSibling1,
    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
    OPC_Scope, 54, 
     OPC_MoveChild0,
     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
     OPC_CheckChild0Same, 0,
     OPC_MoveChild1,
     OPC_CheckImmAllOnesV,
     OPC_MoveParent,
     OPC_MoveParent,
     OPC_RecordChild1,
     OPC_MoveParent,
     OPC_SwitchType , 8, 39, 
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    39, 3, 1, 2, 0, 
     8, 50, 
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    50, 3, 1, 2, 0, 
     8, 60, 
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    60, 3, 1, 2, 0, 
     8, 78, 
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    78, 3, 1, 2, 0, 
     0,
    22, 
     OPC_RecordChild0,
     OPC_MoveChild1,
     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
     OPC_CheckChild0Same, 0,
     OPC_MoveChild1,
     OPC_CheckImmAllOnesV,
     OPC_MoveParent,
     OPC_MoveParent,
     OPC_MoveParent,
     OPC_CheckType, 39, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   39, 3, 1, 2, 0, 
    22, 
     OPC_MoveChild0,
     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
     OPC_CheckChild0Same, 1,
     OPC_MoveChild1,
     OPC_CheckImmAllOnesV,
     OPC_MoveParent,
     OPC_MoveParent,
     OPC_RecordChild1,
     OPC_MoveParent,
     OPC_CheckType, 39, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   39, 3, 0, 2, 1, 
    22, 
     OPC_RecordChild0,
     OPC_MoveChild1,
     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
     OPC_CheckChild0Same, 1,
     OPC_MoveChild1,
     OPC_CheckImmAllOnesV,
     OPC_MoveParent,
     OPC_MoveParent,
     OPC_MoveParent,
     OPC_CheckType, 39, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   39, 3, 0, 2, 1, 
    0, 
   46, 
    OPC_MoveChild0,
    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
    OPC_RecordChild0,
    OPC_MoveChild1,
    OPC_CheckImmAllOnesV,
    OPC_MoveParent,
    OPC_MoveParent,
    OPC_RecordChild1,
    OPC_MoveSibling1,
    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
    OPC_Scope, 14, 
     OPC_CheckChild0Same, 0,
     OPC_RecordChild1,
     OPC_MoveParent,
     OPC_CheckType, 39, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   39, 3, 2, 1, 0, 
    14, 
     OPC_RecordChild0,
     OPC_CheckChild1Same, 0,
     OPC_MoveParent,
     OPC_CheckType, 39, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   39, 3, 2, 1, 0, 
    0, 
   126, 
    OPC_RecordChild0,
    OPC_Scope, 45, 
     OPC_MoveChild1,
     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
     OPC_RecordChild0,
     OPC_MoveChild1,
     OPC_CheckImmAllOnesV,
     OPC_MoveParent,
     OPC_MoveParent,
     OPC_MoveSibling1,
     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
     OPC_Scope, 14, 
      OPC_CheckChild0Same, 1,
      OPC_RecordChild1,
      OPC_MoveParent,
      OPC_CheckType, 39, 
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    39, 3, 2, 0, 1, 
     14, 
      OPC_RecordChild0,
      OPC_CheckChild1Same, 1,
      OPC_MoveParent,
      OPC_CheckType, 39, 
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    39, 3, 2, 0, 1, 
     0, 
    76, 
     OPC_RecordChild1,
     OPC_MoveSibling1,
     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
     OPC_Scope, 22, 
      OPC_RecordChild0,
      OPC_MoveChild1,
      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
      OPC_CheckChild0Same, 0,
      OPC_MoveChild1,
      OPC_CheckImmAllOnesV,
      OPC_MoveParent,
      OPC_MoveParent,
      OPC_MoveParent,
      OPC_CheckType, 50, 
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    50, 3, 1, 2, 0, 
     22, 
      OPC_MoveChild0,
      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
      OPC_CheckChild0Same, 1,
      OPC_MoveChild1,
      OPC_CheckImmAllOnesV,
      OPC_MoveParent,
      OPC_MoveParent,
      OPC_RecordChild1,
      OPC_MoveParent,
      OPC_CheckType, 50, 
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    50, 3, 0, 2, 1, 
     22, 
      OPC_RecordChild0,
      OPC_MoveChild1,
      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
      OPC_CheckChild0Same, 1,
      OPC_MoveChild1,
      OPC_CheckImmAllOnesV,
      OPC_MoveParent,
      OPC_MoveParent,
      OPC_MoveParent,
      OPC_CheckType, 50, 
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    50, 3, 0, 2, 1, 
     0, 
    0, 
   46, 
    OPC_MoveChild0,
    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
    OPC_RecordChild0,
    OPC_MoveChild1,
    OPC_CheckImmAllOnesV,
    OPC_MoveParent,
    OPC_MoveParent,
    OPC_RecordChild1,
    OPC_MoveSibling1,
    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
    OPC_Scope, 14, 
     OPC_CheckChild0Same, 0,
     OPC_RecordChild1,
     OPC_MoveParent,
     OPC_CheckType, 50, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   50, 3, 2, 1, 0, 
    14, 
     OPC_RecordChild0,
     OPC_CheckChild1Same, 0,
     OPC_MoveParent,
     OPC_CheckType, 50, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   50, 3, 2, 1, 0, 
    0, 
   126, 
    OPC_RecordChild0,
    OPC_Scope, 45, 
     OPC_MoveChild1,
     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
     OPC_RecordChild0,
     OPC_MoveChild1,
     OPC_CheckImmAllOnesV,
     OPC_MoveParent,
     OPC_MoveParent,
     OPC_MoveSibling1,
     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
     OPC_Scope, 14, 
      OPC_CheckChild0Same, 1,
      OPC_RecordChild1,
      OPC_MoveParent,
      OPC_CheckType, 50, 
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    50, 3, 2, 0, 1, 
     14, 
      OPC_RecordChild0,
      OPC_CheckChild1Same, 1,
      OPC_MoveParent,
      OPC_CheckType, 50, 
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    50, 3, 2, 0, 1, 
     0, 
    76, 
     OPC_RecordChild1,
     OPC_MoveSibling1,
     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
     OPC_Scope, 22, 
      OPC_RecordChild0,
      OPC_MoveChild1,
      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
      OPC_CheckChild0Same, 0,
      OPC_MoveChild1,
      OPC_CheckImmAllOnesV,
      OPC_MoveParent,
      OPC_MoveParent,
      OPC_MoveParent,
      OPC_CheckType, 60, 
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    60, 3, 1, 2, 0, 
     22, 
      OPC_MoveChild0,
      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
      OPC_CheckChild0Same, 1,
      OPC_MoveChild1,
      OPC_CheckImmAllOnesV,
      OPC_MoveParent,
      OPC_MoveParent,
      OPC_RecordChild1,
      OPC_MoveParent,
      OPC_CheckType, 60, 
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    60, 3, 0, 2, 1, 
     22, 
      OPC_RecordChild0,
      OPC_MoveChild1,
      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
      OPC_CheckChild0Same, 1,
      OPC_MoveChild1,
      OPC_CheckImmAllOnesV,
      OPC_MoveParent,
      OPC_MoveParent,
      OPC_MoveParent,
      OPC_CheckType, 60, 
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    60, 3, 0, 2, 1, 
     0, 
    0, 
   46, 
    OPC_MoveChild0,
    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
    OPC_RecordChild0,
    OPC_MoveChild1,
    OPC_CheckImmAllOnesV,
    OPC_MoveParent,
    OPC_MoveParent,
    OPC_RecordChild1,
    OPC_MoveSibling1,
    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
    OPC_Scope, 14, 
     OPC_CheckChild0Same, 0,
     OPC_RecordChild1,
     OPC_MoveParent,
     OPC_CheckType, 60, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   60, 3, 2, 1, 0, 
    14, 
     OPC_RecordChild0,
     OPC_CheckChild1Same, 0,
     OPC_MoveParent,
     OPC_CheckType, 60, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   60, 3, 2, 1, 0, 
    0, 
   126, 
    OPC_RecordChild0,
    OPC_Scope, 45, 
     OPC_MoveChild1,
     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
     OPC_RecordChild0,
     OPC_MoveChild1,
     OPC_CheckImmAllOnesV,
     OPC_MoveParent,
     OPC_MoveParent,
     OPC_MoveSibling1,
     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
     OPC_Scope, 14, 
      OPC_CheckChild0Same, 1,
      OPC_RecordChild1,
      OPC_MoveParent,
      OPC_CheckType, 60, 
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    60, 3, 2, 0, 1, 
     14, 
      OPC_RecordChild0,
      OPC_CheckChild1Same, 1,
      OPC_MoveParent,
      OPC_CheckType, 60, 
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    60, 3, 2, 0, 1, 
     0, 
    76, 
     OPC_RecordChild1,
     OPC_MoveSibling1,
     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
     OPC_Scope, 22, 
      OPC_RecordChild0,
      OPC_MoveChild1,
      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
      OPC_CheckChild0Same, 0,
      OPC_MoveChild1,
      OPC_CheckImmAllOnesV,
      OPC_MoveParent,
      OPC_MoveParent,
      OPC_MoveParent,
      OPC_CheckType, 78, 
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    78, 3, 1, 2, 0, 
     22, 
      OPC_MoveChild0,
      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
      OPC_CheckChild0Same, 1,
      OPC_MoveChild1,
      OPC_CheckImmAllOnesV,
      OPC_MoveParent,
      OPC_MoveParent,
      OPC_RecordChild1,
      OPC_MoveParent,
      OPC_CheckType, 78, 
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    78, 3, 0, 2, 1, 
     22, 
      OPC_RecordChild0,
      OPC_MoveChild1,
      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
      OPC_CheckChild0Same, 1,
      OPC_MoveChild1,
      OPC_CheckImmAllOnesV,
      OPC_MoveParent,
      OPC_MoveParent,
      OPC_MoveParent,
      OPC_CheckType, 78, 
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    78, 3, 0, 2, 1, 
     0, 
    0, 
   46, 
    OPC_MoveChild0,
    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
    OPC_RecordChild0,
    OPC_MoveChild1,
    OPC_CheckImmAllOnesV,
    OPC_MoveParent,
    OPC_MoveParent,
    OPC_RecordChild1,
    OPC_MoveSibling1,
    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
    OPC_Scope, 14, 
     OPC_CheckChild0Same, 0,
     OPC_RecordChild1,
     OPC_MoveParent,
     OPC_CheckType, 78, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   78, 3, 2, 1, 0, 
    14, 
     OPC_RecordChild0,
     OPC_CheckChild1Same, 0,
     OPC_MoveParent,
     OPC_CheckType, 78, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   78, 3, 2, 1, 0, 
    0, 
   46, 
    OPC_RecordChild0,
    OPC_MoveChild1,
    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
    OPC_RecordChild0,
    OPC_MoveChild1,
    OPC_CheckImmAllOnesV,
    OPC_MoveParent,
    OPC_MoveParent,
    OPC_MoveSibling1,
    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
    OPC_Scope, 14, 
     OPC_CheckChild0Same, 1,
     OPC_RecordChild1,
     OPC_MoveParent,
     OPC_CheckType, 78, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   78, 3, 2, 0, 1, 
    14, 
     OPC_RecordChild0,
     OPC_CheckChild1Same, 1,
     OPC_MoveParent,
     OPC_CheckType, 78, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   78, 3, 2, 0, 1, 
    0, 
   0, 
  40, 
   OPC_RecordChild0,
   OPC_RecordChild1,
   OPC_SwitchType , 7, 39, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::OR),
                  39, 2, 0, 1, 
   7, 50, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::OR),
                  50, 2, 0, 1, 
   7, 60, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::OR),
                  60, 2, 0, 1, 
   7, 78, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::OR),
                  78, 2, 0, 1, 
   0,
  0, 
 121|128,11, TARGET_VAL(ISD::XOR),
  OPC_Scope, 22, 
   OPC_RecordChild0,
   OPC_RecordChild1,
   OPC_SwitchType , 7, 7, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::XOR_I32),
                  7, 2, 0, 1, 
   7, 8, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::XOR_I64),
                  8, 2, 0, 1, 
   0,
  121, 
   OPC_MoveChild0,
   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
   OPC_MoveChild0,
   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
   OPC_RecordChild0,
   OPC_Scope, 71, 
    OPC_RecordChild1,
    OPC_MoveSibling1,
    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
    OPC_RecordChild0,
    OPC_MoveChild1,
    OPC_CheckImmAllOnesV,
    OPC_MoveParent,
    OPC_MoveParent,
    OPC_MoveParent,
    OPC_Scope, 44, 
     OPC_CheckChild1Same, 1,
     OPC_SwitchType , 8, 39, 
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    39, 3, 1, 0, 2, 
     8, 50, 
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    50, 3, 1, 0, 2, 
     8, 60, 
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    60, 3, 1, 0, 2, 
     8, 78, 
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    78, 3, 1, 0, 2, 
     0,
    12, 
     OPC_CheckChild1Same, 0,
     OPC_CheckType, 39, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   39, 3, 0, 1, 2, 
    0, 
   37, 
    OPC_MoveChild1,
    OPC_CheckImmAllOnesV,
    OPC_MoveParent,
    OPC_MoveSibling1,
    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
    OPC_RecordChild0,
    OPC_RecordChild1,
    OPC_MoveParent,
    OPC_MoveParent,
    OPC_CheckType, 39, 
    OPC_Scope, 10, 
     OPC_CheckChild1Same, 2,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   39, 3, 2, 1, 0, 
    10, 
     OPC_CheckChild1Same, 1,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   39, 3, 1, 2, 0, 
    0, 
   0, 
  102, 
   OPC_RecordChild0,
   OPC_MoveChild1,
   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
   OPC_MoveChild0,
   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
   OPC_Scope, 23, 
    OPC_RecordChild0,
    OPC_CheckChild1Same, 0,
    OPC_MoveSibling1,
    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
    OPC_RecordChild0,
    OPC_MoveChild1,
    OPC_CheckImmAllOnesV,
    OPC_MoveParent,
    OPC_MoveParent,
    OPC_MoveParent,
    OPC_CheckType, 39, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  39, 3, 0, 1, 2, 
   23, 
    OPC_CheckChild0Same, 0,
    OPC_RecordChild1,
    OPC_MoveSibling1,
    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
    OPC_RecordChild0,
    OPC_MoveChild1,
    OPC_CheckImmAllOnesV,
    OPC_MoveParent,
    OPC_MoveParent,
    OPC_MoveParent,
    OPC_CheckType, 39, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  39, 3, 0, 1, 2, 
   42, 
    OPC_RecordChild0,
    OPC_MoveChild1,
    OPC_CheckImmAllOnesV,
    OPC_MoveParent,
    OPC_MoveSibling1,
    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
    OPC_Scope, 15, 
     OPC_RecordChild0,
     OPC_CheckChild1Same, 0,
     OPC_MoveParent,
     OPC_MoveParent,
     OPC_CheckType, 39, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   39, 3, 0, 2, 1, 
    15, 
     OPC_CheckChild0Same, 0,
     OPC_RecordChild1,
     OPC_MoveParent,
     OPC_MoveParent,
     OPC_CheckType, 39, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   39, 3, 0, 2, 1, 
    0, 
   0, 
  73, 
   OPC_MoveChild0,
   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
   OPC_MoveChild0,
   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
   OPC_RecordChild0,
   OPC_Scope, 23, 
    OPC_RecordChild1,
    OPC_MoveSibling1,
    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
    OPC_RecordChild0,
    OPC_MoveChild1,
    OPC_CheckImmAllOnesV,
    OPC_MoveParent,
    OPC_MoveParent,
    OPC_MoveParent,
    OPC_CheckChild1Same, 0,
    OPC_CheckType, 50, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  50, 3, 0, 1, 2, 
   37, 
    OPC_MoveChild1,
    OPC_CheckImmAllOnesV,
    OPC_MoveParent,
    OPC_MoveSibling1,
    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
    OPC_RecordChild0,
    OPC_RecordChild1,
    OPC_MoveParent,
    OPC_MoveParent,
    OPC_CheckType, 50, 
    OPC_Scope, 10, 
     OPC_CheckChild1Same, 2,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   50, 3, 2, 1, 0, 
    10, 
     OPC_CheckChild1Same, 1,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   50, 3, 1, 2, 0, 
    0, 
   0, 
  102, 
   OPC_RecordChild0,
   OPC_MoveChild1,
   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
   OPC_MoveChild0,
   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
   OPC_Scope, 23, 
    OPC_RecordChild0,
    OPC_CheckChild1Same, 0,
    OPC_MoveSibling1,
    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
    OPC_RecordChild0,
    OPC_MoveChild1,
    OPC_CheckImmAllOnesV,
    OPC_MoveParent,
    OPC_MoveParent,
    OPC_MoveParent,
    OPC_CheckType, 50, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  50, 3, 0, 1, 2, 
   23, 
    OPC_CheckChild0Same, 0,
    OPC_RecordChild1,
    OPC_MoveSibling1,
    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
    OPC_RecordChild0,
    OPC_MoveChild1,
    OPC_CheckImmAllOnesV,
    OPC_MoveParent,
    OPC_MoveParent,
    OPC_MoveParent,
    OPC_CheckType, 50, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  50, 3, 0, 1, 2, 
   42, 
    OPC_RecordChild0,
    OPC_MoveChild1,
    OPC_CheckImmAllOnesV,
    OPC_MoveParent,
    OPC_MoveSibling1,
    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
    OPC_Scope, 15, 
     OPC_RecordChild0,
     OPC_CheckChild1Same, 0,
     OPC_MoveParent,
     OPC_MoveParent,
     OPC_CheckType, 50, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   50, 3, 0, 2, 1, 
    15, 
     OPC_CheckChild0Same, 0,
     OPC_RecordChild1,
     OPC_MoveParent,
     OPC_MoveParent,
     OPC_CheckType, 50, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   50, 3, 0, 2, 1, 
    0, 
   0, 
  73, 
   OPC_MoveChild0,
   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
   OPC_MoveChild0,
   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
   OPC_RecordChild0,
   OPC_Scope, 23, 
    OPC_RecordChild1,
    OPC_MoveSibling1,
    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
    OPC_RecordChild0,
    OPC_MoveChild1,
    OPC_CheckImmAllOnesV,
    OPC_MoveParent,
    OPC_MoveParent,
    OPC_MoveParent,
    OPC_CheckChild1Same, 0,
    OPC_CheckType, 60, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  60, 3, 0, 1, 2, 
   37, 
    OPC_MoveChild1,
    OPC_CheckImmAllOnesV,
    OPC_MoveParent,
    OPC_MoveSibling1,
    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
    OPC_RecordChild0,
    OPC_RecordChild1,
    OPC_MoveParent,
    OPC_MoveParent,
    OPC_CheckType, 60, 
    OPC_Scope, 10, 
     OPC_CheckChild1Same, 2,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   60, 3, 2, 1, 0, 
    10, 
     OPC_CheckChild1Same, 1,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   60, 3, 1, 2, 0, 
    0, 
   0, 
  102, 
   OPC_RecordChild0,
   OPC_MoveChild1,
   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
   OPC_MoveChild0,
   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
   OPC_Scope, 23, 
    OPC_RecordChild0,
    OPC_CheckChild1Same, 0,
    OPC_MoveSibling1,
    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
    OPC_RecordChild0,
    OPC_MoveChild1,
    OPC_CheckImmAllOnesV,
    OPC_MoveParent,
    OPC_MoveParent,
    OPC_MoveParent,
    OPC_CheckType, 60, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  60, 3, 0, 1, 2, 
   23, 
    OPC_CheckChild0Same, 0,
    OPC_RecordChild1,
    OPC_MoveSibling1,
    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
    OPC_RecordChild0,
    OPC_MoveChild1,
    OPC_CheckImmAllOnesV,
    OPC_MoveParent,
    OPC_MoveParent,
    OPC_MoveParent,
    OPC_CheckType, 60, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  60, 3, 0, 1, 2, 
   42, 
    OPC_RecordChild0,
    OPC_MoveChild1,
    OPC_CheckImmAllOnesV,
    OPC_MoveParent,
    OPC_MoveSibling1,
    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
    OPC_Scope, 15, 
     OPC_RecordChild0,
     OPC_CheckChild1Same, 0,
     OPC_MoveParent,
     OPC_MoveParent,
     OPC_CheckType, 60, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   60, 3, 0, 2, 1, 
    15, 
     OPC_CheckChild0Same, 0,
     OPC_RecordChild1,
     OPC_MoveParent,
     OPC_MoveParent,
     OPC_CheckType, 60, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   60, 3, 0, 2, 1, 
    0, 
   0, 
  73, 
   OPC_MoveChild0,
   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
   OPC_MoveChild0,
   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
   OPC_RecordChild0,
   OPC_Scope, 23, 
    OPC_RecordChild1,
    OPC_MoveSibling1,
    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
    OPC_RecordChild0,
    OPC_MoveChild1,
    OPC_CheckImmAllOnesV,
    OPC_MoveParent,
    OPC_MoveParent,
    OPC_MoveParent,
    OPC_CheckChild1Same, 0,
    OPC_CheckType, 78, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  78, 3, 0, 1, 2, 
   37, 
    OPC_MoveChild1,
    OPC_CheckImmAllOnesV,
    OPC_MoveParent,
    OPC_MoveSibling1,
    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
    OPC_RecordChild0,
    OPC_RecordChild1,
    OPC_MoveParent,
    OPC_MoveParent,
    OPC_CheckType, 78, 
    OPC_Scope, 10, 
     OPC_CheckChild1Same, 2,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   78, 3, 2, 1, 0, 
    10, 
     OPC_CheckChild1Same, 1,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   78, 3, 1, 2, 0, 
    0, 
   0, 
  102, 
   OPC_RecordChild0,
   OPC_MoveChild1,
   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
   OPC_MoveChild0,
   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
   OPC_Scope, 23, 
    OPC_RecordChild0,
    OPC_CheckChild1Same, 0,
    OPC_MoveSibling1,
    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
    OPC_RecordChild0,
    OPC_MoveChild1,
    OPC_CheckImmAllOnesV,
    OPC_MoveParent,
    OPC_MoveParent,
    OPC_MoveParent,
    OPC_CheckType, 78, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  78, 3, 0, 1, 2, 
   23, 
    OPC_CheckChild0Same, 0,
    OPC_RecordChild1,
    OPC_MoveSibling1,
    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
    OPC_RecordChild0,
    OPC_MoveChild1,
    OPC_CheckImmAllOnesV,
    OPC_MoveParent,
    OPC_MoveParent,
    OPC_MoveParent,
    OPC_CheckType, 78, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  78, 3, 0, 1, 2, 
   42, 
    OPC_RecordChild0,
    OPC_MoveChild1,
    OPC_CheckImmAllOnesV,
    OPC_MoveParent,
    OPC_MoveSibling1,
    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
    OPC_Scope, 15, 
     OPC_RecordChild0,
     OPC_CheckChild1Same, 0,
     OPC_MoveParent,
     OPC_MoveParent,
     OPC_CheckType, 78, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   78, 3, 0, 2, 1, 
    15, 
     OPC_CheckChild0Same, 0,
     OPC_RecordChild1,
     OPC_MoveParent,
     OPC_MoveParent,
     OPC_CheckType, 78, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   78, 3, 0, 2, 1, 
    0, 
   0, 
  112, 
   OPC_MoveChild0,
   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
   OPC_Scope, 69, 
    OPC_MoveChild0,
    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
    OPC_RecordChild0,
    OPC_RecordChild1,
    OPC_MoveParent,
    OPC_RecordChild1,
    OPC_MoveParent,
    OPC_Scope, 44, 
     OPC_CheckChild1Same, 1,
     OPC_SwitchType , 8, 39, 
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    39, 3, 0, 1, 2, 
     8, 50, 
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    50, 3, 0, 1, 2, 
     8, 60, 
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    60, 3, 0, 1, 2, 
     8, 78, 
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    78, 3, 0, 1, 2, 
     0,
    12, 
     OPC_CheckChild1Same, 0,
     OPC_CheckType, 39, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   39, 3, 1, 0, 2, 
    0, 
   35, 
    OPC_RecordChild0,
    OPC_MoveChild1,
    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
    OPC_RecordChild0,
    OPC_RecordChild1,
    OPC_MoveParent,
    OPC_MoveParent,
    OPC_CheckType, 39, 
    OPC_Scope, 10, 
     OPC_CheckChild1Same, 2,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   39, 3, 1, 2, 0, 
    10, 
     OPC_CheckChild1Same, 1,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   39, 3, 2, 1, 0, 
    0, 
   0, 
  88, 
   OPC_RecordChild0,
   OPC_MoveChild1,
   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
   OPC_Scope, 40, 
    OPC_MoveChild0,
    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
    OPC_Scope, 16, 
     OPC_RecordChild0,
     OPC_CheckChild1Same, 0,
     OPC_MoveParent,
     OPC_RecordChild1,
     OPC_MoveParent,
     OPC_CheckType, 39, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   39, 3, 1, 0, 2, 
    16, 
     OPC_CheckChild0Same, 0,
     OPC_RecordChild1,
     OPC_MoveParent,
     OPC_RecordChild1,
     OPC_MoveParent,
     OPC_CheckType, 39, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   39, 3, 1, 0, 2, 
    0, 
   39, 
    OPC_RecordChild0,
    OPC_MoveChild1,
    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
    OPC_Scope, 15, 
     OPC_RecordChild0,
     OPC_CheckChild1Same, 0,
     OPC_MoveParent,
     OPC_MoveParent,
     OPC_CheckType, 39, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   39, 3, 2, 0, 1, 
    15, 
     OPC_CheckChild0Same, 0,
     OPC_RecordChild1,
     OPC_MoveParent,
     OPC_MoveParent,
     OPC_CheckType, 39, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   39, 3, 2, 0, 1, 
    0, 
   0, 
  64, 
   OPC_MoveChild0,
   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
   OPC_Scope, 21, 
    OPC_MoveChild0,
    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
    OPC_RecordChild0,
    OPC_RecordChild1,
    OPC_MoveParent,
    OPC_RecordChild1,
    OPC_MoveParent,
    OPC_CheckChild1Same, 0,
    OPC_CheckType, 50, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  50, 3, 1, 0, 2, 
   35, 
    OPC_RecordChild0,
    OPC_MoveChild1,
    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
    OPC_RecordChild0,
    OPC_RecordChild1,
    OPC_MoveParent,
    OPC_MoveParent,
    OPC_CheckType, 50, 
    OPC_Scope, 10, 
     OPC_CheckChild1Same, 2,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   50, 3, 1, 2, 0, 
    10, 
     OPC_CheckChild1Same, 1,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   50, 3, 2, 1, 0, 
    0, 
   0, 
  88, 
   OPC_RecordChild0,
   OPC_MoveChild1,
   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
   OPC_Scope, 40, 
    OPC_MoveChild0,
    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
    OPC_Scope, 16, 
     OPC_RecordChild0,
     OPC_CheckChild1Same, 0,
     OPC_MoveParent,
     OPC_RecordChild1,
     OPC_MoveParent,
     OPC_CheckType, 50, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   50, 3, 1, 0, 2, 
    16, 
     OPC_CheckChild0Same, 0,
     OPC_RecordChild1,
     OPC_MoveParent,
     OPC_RecordChild1,
     OPC_MoveParent,
     OPC_CheckType, 50, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   50, 3, 1, 0, 2, 
    0, 
   39, 
    OPC_RecordChild0,
    OPC_MoveChild1,
    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
    OPC_Scope, 15, 
     OPC_RecordChild0,
     OPC_CheckChild1Same, 0,
     OPC_MoveParent,
     OPC_MoveParent,
     OPC_CheckType, 50, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   50, 3, 2, 0, 1, 
    15, 
     OPC_CheckChild0Same, 0,
     OPC_RecordChild1,
     OPC_MoveParent,
     OPC_MoveParent,
     OPC_CheckType, 50, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   50, 3, 2, 0, 1, 
    0, 
   0, 
  64, 
   OPC_MoveChild0,
   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
   OPC_Scope, 21, 
    OPC_MoveChild0,
    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
    OPC_RecordChild0,
    OPC_RecordChild1,
    OPC_MoveParent,
    OPC_RecordChild1,
    OPC_MoveParent,
    OPC_CheckChild1Same, 0,
    OPC_CheckType, 60, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  60, 3, 1, 0, 2, 
   35, 
    OPC_RecordChild0,
    OPC_MoveChild1,
    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
    OPC_RecordChild0,
    OPC_RecordChild1,
    OPC_MoveParent,
    OPC_MoveParent,
    OPC_CheckType, 60, 
    OPC_Scope, 10, 
     OPC_CheckChild1Same, 2,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   60, 3, 1, 2, 0, 
    10, 
     OPC_CheckChild1Same, 1,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   60, 3, 2, 1, 0, 
    0, 
   0, 
  88, 
   OPC_RecordChild0,
   OPC_MoveChild1,
   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
   OPC_Scope, 40, 
    OPC_MoveChild0,
    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
    OPC_Scope, 16, 
     OPC_RecordChild0,
     OPC_CheckChild1Same, 0,
     OPC_MoveParent,
     OPC_RecordChild1,
     OPC_MoveParent,
     OPC_CheckType, 60, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   60, 3, 1, 0, 2, 
    16, 
     OPC_CheckChild0Same, 0,
     OPC_RecordChild1,
     OPC_MoveParent,
     OPC_RecordChild1,
     OPC_MoveParent,
     OPC_CheckType, 60, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   60, 3, 1, 0, 2, 
    0, 
   39, 
    OPC_RecordChild0,
    OPC_MoveChild1,
    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
    OPC_Scope, 15, 
     OPC_RecordChild0,
     OPC_CheckChild1Same, 0,
     OPC_MoveParent,
     OPC_MoveParent,
     OPC_CheckType, 60, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   60, 3, 2, 0, 1, 
    15, 
     OPC_CheckChild0Same, 0,
     OPC_RecordChild1,
     OPC_MoveParent,
     OPC_MoveParent,
     OPC_CheckType, 60, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   60, 3, 2, 0, 1, 
    0, 
   0, 
  64, 
   OPC_MoveChild0,
   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
   OPC_Scope, 21, 
    OPC_MoveChild0,
    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
    OPC_RecordChild0,
    OPC_RecordChild1,
    OPC_MoveParent,
    OPC_RecordChild1,
    OPC_MoveParent,
    OPC_CheckChild1Same, 0,
    OPC_CheckType, 78, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  78, 3, 1, 0, 2, 
   35, 
    OPC_RecordChild0,
    OPC_MoveChild1,
    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
    OPC_RecordChild0,
    OPC_RecordChild1,
    OPC_MoveParent,
    OPC_MoveParent,
    OPC_CheckType, 78, 
    OPC_Scope, 10, 
     OPC_CheckChild1Same, 2,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   78, 3, 1, 2, 0, 
    10, 
     OPC_CheckChild1Same, 1,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   78, 3, 2, 1, 0, 
    0, 
   0, 
  43|128,1, 
   OPC_RecordChild0,
   OPC_Scope, 127, 
    OPC_MoveChild1,
    OPC_Scope, 86, 
     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
     OPC_Scope, 40, 
      OPC_MoveChild0,
      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
      OPC_Scope, 16, 
       OPC_RecordChild0,
       OPC_CheckChild1Same, 0,
       OPC_MoveParent,
       OPC_RecordChild1,
       OPC_MoveParent,
       OPC_CheckType, 78, 
       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                     78, 3, 1, 0, 2, 
      16, 
       OPC_CheckChild0Same, 0,
       OPC_RecordChild1,
       OPC_MoveParent,
       OPC_RecordChild1,
       OPC_MoveParent,
       OPC_CheckType, 78, 
       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                     78, 3, 1, 0, 2, 
      0, 
     39, 
      OPC_RecordChild0,
      OPC_MoveChild1,
      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
      OPC_Scope, 15, 
       OPC_RecordChild0,
       OPC_CheckChild1Same, 0,
       OPC_MoveParent,
       OPC_MoveParent,
       OPC_CheckType, 78, 
       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                     78, 3, 2, 0, 1, 
      15, 
       OPC_CheckChild0Same, 0,
       OPC_RecordChild1,
       OPC_MoveParent,
       OPC_MoveParent,
       OPC_CheckType, 78, 
       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                     78, 3, 2, 0, 1, 
      0, 
     0, 
    36, 
     OPC_CheckImmAllOnesV,
     OPC_MoveParent,
     OPC_SwitchType , 6, 39, 
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NOT),
                    39, 1, 0, 
     6, 50, 
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NOT),
                    50, 1, 0, 
     6, 60, 
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NOT),
                    60, 1, 0, 
     6, 78, 
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NOT),
                    78, 1, 0, 
     0,
    0, 
   39, 
    OPC_RecordChild1,
    OPC_SwitchType , 7, 39, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::XOR),
                   39, 2, 0, 1, 
    7, 50, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::XOR),
                   50, 2, 0, 1, 
    7, 60, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::XOR),
                   60, 2, 0, 1, 
    7, 78, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::XOR),
                   78, 2, 0, 1, 
    0,
   0, 
  0, 
 21, TARGET_VAL(ISD::CTLZ),
  OPC_RecordChild0,
  OPC_SwitchType , 7, 7, 
   OPC_CheckChild0TypeI32,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CLZ_I32),
                 7, 1, 0, 
  7, 8, 
   OPC_CheckChild0TypeI64,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CLZ_I64),
                 8, 1, 0, 
  0,
 21, TARGET_VAL(ISD::CTTZ),
  OPC_RecordChild0,
  OPC_SwitchType , 7, 7, 
   OPC_CheckChild0TypeI32,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CTZ_I32),
                 7, 1, 0, 
  7, 8, 
   OPC_CheckChild0TypeI64,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CTZ_I64),
                 8, 1, 0, 
  0,
 32, TARGET_VAL(ISD::CTPOP),
  OPC_RecordChild0,
  OPC_SwitchType , 7, 7, 
   OPC_CheckChild0TypeI32,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::POPCNT_I32),
                 7, 1, 0, 
  7, 8, 
   OPC_CheckChild0TypeI64,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::POPCNT_I64),
                 8, 1, 0, 
  9, 39, 
   OPC_CheckChild0Type, 39, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::POPCNT_I8x16),
                 39, 1, 0, 
  0,
 22, TARGET_VAL(WebAssemblyISD::I64_ADD128),
  OPC_RecordChild0,
  OPC_CheckChild0TypeI64,
  OPC_RecordChild1,
  OPC_CheckChild1TypeI64,
  OPC_RecordChild2,
  OPC_CheckChild2TypeI64,
  OPC_RecordChild3,
  OPC_CheckChild3TypeI64,
  OPC_CheckTypeI64,
  OPC_CheckTypeRes, 1, 8, 
  OPC_MorphNodeTo2None, TARGET_VAL(WebAssembly::I64_ADD128),
                8, 8, 4, 0, 1, 2, 3, 
 22, TARGET_VAL(WebAssemblyISD::I64_SUB128),
  OPC_RecordChild0,
  OPC_CheckChild0TypeI64,
  OPC_RecordChild1,
  OPC_CheckChild1TypeI64,
  OPC_RecordChild2,
  OPC_CheckChild2TypeI64,
  OPC_RecordChild3,
  OPC_CheckChild3TypeI64,
  OPC_CheckTypeI64,
  OPC_CheckTypeRes, 1, 8, 
  OPC_MorphNodeTo2None, TARGET_VAL(WebAssembly::I64_SUB128),
                8, 8, 4, 0, 1, 2, 3, 
 16, TARGET_VAL(WebAssemblyISD::I64_MUL_WIDE_S),
  OPC_RecordChild0,
  OPC_CheckChild0TypeI64,
  OPC_RecordChild1,
  OPC_CheckChild1TypeI64,
  OPC_CheckTypeI64,
  OPC_CheckTypeRes, 1, 8, 
  OPC_MorphNodeTo2None, TARGET_VAL(WebAssembly::I64_MUL_WIDE_S),
                8, 8, 2, 0, 1, 
 16, TARGET_VAL(WebAssemblyISD::I64_MUL_WIDE_U),
  OPC_RecordChild0,
  OPC_CheckChild0TypeI64,
  OPC_RecordChild1,
  OPC_CheckChild1TypeI64,
  OPC_CheckTypeI64,
  OPC_CheckTypeRes, 1, 8, 
  OPC_MorphNodeTo2None, TARGET_VAL(WebAssembly::I64_MUL_WIDE_U),
                8, 8, 2, 0, 1, 
 7, TARGET_VAL(ISD::TRUNCATE),
  OPC_RecordChild0,
  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_WRAP_I64),
                7, 1, 0, 
 7, TARGET_VAL(ISD::SIGN_EXTEND),
  OPC_RecordChild0,
  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_EXTEND_S_I32),
                8, 1, 0, 
 121, TARGET_VAL(ISD::FP_TO_SINT),
  OPC_RecordChild0,
  OPC_Scope, 48, 
   OPC_CheckChild0Type, 12, 
   OPC_SwitchType , 20, 7, 
    OPC_Scope, 8, 
     OPC_CheckPatternPredicate, 9,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_S_SAT_F32),
                   7, 1, 0, 
    8, 
     OPC_CheckPatternPredicate, 10,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_SINT_I32_F32),
                   7, 1, 0, 
    0, 
   20, 8, 
    OPC_Scope, 8, 
     OPC_CheckPatternPredicate, 9,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_S_SAT_F32),
                   8, 1, 0, 
    8, 
     OPC_CheckPatternPredicate, 10,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_SINT_I64_F32),
                   8, 1, 0, 
    0, 
   0,
  48, 
   OPC_CheckChild0Type, 13, 
   OPC_SwitchType , 20, 7, 
    OPC_Scope, 8, 
     OPC_CheckPatternPredicate, 9,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_S_SAT_F64),
                   7, 1, 0, 
    8, 
     OPC_CheckPatternPredicate, 10,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_SINT_I32_F64),
                   7, 1, 0, 
    0, 
   20, 8, 
    OPC_Scope, 8, 
     OPC_CheckPatternPredicate, 9,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_S_SAT_F64),
                   8, 1, 0, 
    8, 
     OPC_CheckPatternPredicate, 10,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_SINT_I64_F64),
                   8, 1, 0, 
    0, 
   0,
  9, 
   OPC_CheckType, 60, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::fp_to_sint_I32x4),
                 60, 1, 0, 
  9, 
   OPC_CheckType, 50, 
   OPC_CheckPatternPredicate5,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::fp_to_sint_I16x8),
                 50, 1, 0, 
  0, 
 121, TARGET_VAL(ISD::FP_TO_UINT),
  OPC_RecordChild0,
  OPC_Scope, 48, 
   OPC_CheckChild0Type, 12, 
   OPC_SwitchType , 20, 7, 
    OPC_Scope, 8, 
     OPC_CheckPatternPredicate, 9,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_U_SAT_F32),
                   7, 1, 0, 
    8, 
     OPC_CheckPatternPredicate, 10,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_UINT_I32_F32),
                   7, 1, 0, 
    0, 
   20, 8, 
    OPC_Scope, 8, 
     OPC_CheckPatternPredicate, 9,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_U_SAT_F32),
                   8, 1, 0, 
    8, 
     OPC_CheckPatternPredicate, 10,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_UINT_I64_F32),
                   8, 1, 0, 
    0, 
   0,
  48, 
   OPC_CheckChild0Type, 13, 
   OPC_SwitchType , 20, 7, 
    OPC_Scope, 8, 
     OPC_CheckPatternPredicate, 9,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_U_SAT_F64),
                   7, 1, 0, 
    8, 
     OPC_CheckPatternPredicate, 10,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_UINT_I32_F64),
                   7, 1, 0, 
    0, 
   20, 8, 
    OPC_Scope, 8, 
     OPC_CheckPatternPredicate, 9,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_U_SAT_F64),
                   8, 1, 0, 
    8, 
     OPC_CheckPatternPredicate, 10,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_UINT_I64_F64),
                   8, 1, 0, 
    0, 
   0,
  9, 
   OPC_CheckType, 60, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::fp_to_uint_I32x4),
                 60, 1, 0, 
  9, 
   OPC_CheckType, 50, 
   OPC_CheckPatternPredicate5,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::fp_to_uint_I16x8),
                 50, 1, 0, 
  0, 
 87, TARGET_VAL(ISD::FP_TO_SINT_SAT),
  OPC_RecordChild0,
  OPC_Scope, 27, 
   OPC_CheckChild0Type, 12, 
   OPC_MoveChild1,
   OPC_Scope, 10, 
    OPC_CheckValueType, 7, 
    OPC_MoveParent,
    OPC_CheckTypeI32,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_S_SAT_F32),
                  7, 1, 0, 
   10, 
    OPC_CheckValueType, 8, 
    OPC_MoveParent,
    OPC_CheckTypeI64,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_S_SAT_F32),
                  8, 1, 0, 
   0, 
  27, 
   OPC_CheckChild0Type, 13, 
   OPC_MoveChild1,
   OPC_Scope, 10, 
    OPC_CheckValueType, 7, 
    OPC_MoveParent,
    OPC_CheckTypeI32,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_S_SAT_F64),
                  7, 1, 0, 
   10, 
    OPC_CheckValueType, 8, 
    OPC_MoveParent,
    OPC_CheckTypeI64,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_S_SAT_F64),
                  8, 1, 0, 
   0, 
  27, 
   OPC_MoveChild1,
   OPC_Scope, 11, 
    OPC_CheckValueType, 7, 
    OPC_MoveParent,
    OPC_CheckType, 60, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::fp_to_sint_I32x4),
                  60, 1, 0, 
   11, 
    OPC_CheckValueType, 6, 
    OPC_MoveParent,
    OPC_CheckType, 50, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::fp_to_sint_I16x8),
                  50, 1, 0, 
   0, 
  0, 
 87, TARGET_VAL(ISD::FP_TO_UINT_SAT),
  OPC_RecordChild0,
  OPC_Scope, 27, 
   OPC_CheckChild0Type, 12, 
   OPC_MoveChild1,
   OPC_Scope, 10, 
    OPC_CheckValueType, 7, 
    OPC_MoveParent,
    OPC_CheckTypeI32,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_U_SAT_F32),
                  7, 1, 0, 
   10, 
    OPC_CheckValueType, 8, 
    OPC_MoveParent,
    OPC_CheckTypeI64,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_U_SAT_F32),
                  8, 1, 0, 
   0, 
  27, 
   OPC_CheckChild0Type, 13, 
   OPC_MoveChild1,
   OPC_Scope, 10, 
    OPC_CheckValueType, 7, 
    OPC_MoveParent,
    OPC_CheckTypeI32,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_U_SAT_F64),
                  7, 1, 0, 
   10, 
    OPC_CheckValueType, 8, 
    OPC_MoveParent,
    OPC_CheckTypeI64,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_U_SAT_F64),
                  8, 1, 0, 
   0, 
  27, 
   OPC_MoveChild1,
   OPC_Scope, 11, 
    OPC_CheckValueType, 7, 
    OPC_MoveParent,
    OPC_CheckType, 60, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::fp_to_uint_I32x4),
                  60, 1, 0, 
   11, 
    OPC_CheckValueType, 6, 
    OPC_MoveParent,
    OPC_CheckType, 50, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::fp_to_uint_I16x8),
                  50, 1, 0, 
   0, 
  0, 
 39|128,2, TARGET_VAL(ISD::BITCAST),
  OPC_RecordChild0,
  OPC_Scope, 9, 
   OPC_CheckChild0Type, 12, 
   OPC_CheckTypeI32,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_REINTERPRET_F32),
                 7, 1, 0, 
  9, 
   OPC_CheckChild0Type, 13, 
   OPC_CheckTypeI64,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_REINTERPRET_F64),
                 8, 1, 0, 
  9, 
   OPC_CheckChild0TypeI32,
   OPC_CheckType, 12, 
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F32_REINTERPRET_I32),
                 12, 1, 0, 
  9, 
   OPC_CheckChild0TypeI64,
   OPC_CheckType, 13, 
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F64_REINTERPRET_I64),
                 13, 1, 0, 
  35, 
   OPC_CheckChild0Type, 50, 
   OPC_SwitchType , 3, 39, 
    OPC_CompleteMatch, 1, 0, 

   3, 60, 
    OPC_CompleteMatch, 1, 0, 

   3, 78, 
    OPC_CompleteMatch, 1, 0, 

   3, 111, 
    OPC_CompleteMatch, 1, 0, 

   3, 1|128,1, 
    OPC_CompleteMatch, 1, 0, 

   3, 92, 
    OPC_CompleteMatch, 1, 0, 

   0,
  35, 
   OPC_CheckChild0Type, 60, 
   OPC_SwitchType , 3, 39, 
    OPC_CompleteMatch, 1, 0, 

   3, 50, 
    OPC_CompleteMatch, 1, 0, 

   3, 78, 
    OPC_CompleteMatch, 1, 0, 

   3, 111, 
    OPC_CompleteMatch, 1, 0, 

   3, 1|128,1, 
    OPC_CompleteMatch, 1, 0, 

   3, 92, 
    OPC_CompleteMatch, 1, 0, 

   0,
  35, 
   OPC_CheckChild0Type, 78, 
   OPC_SwitchType , 3, 39, 
    OPC_CompleteMatch, 1, 0, 

   3, 50, 
    OPC_CompleteMatch, 1, 0, 

   3, 60, 
    OPC_CompleteMatch, 1, 0, 

   3, 111, 
    OPC_CompleteMatch, 1, 0, 

   3, 1|128,1, 
    OPC_CompleteMatch, 1, 0, 

   3, 92, 
    OPC_CompleteMatch, 1, 0, 

   0,
  35, 
   OPC_CheckChild0Type, 111, 
   OPC_SwitchType , 3, 39, 
    OPC_CompleteMatch, 1, 0, 

   3, 50, 
    OPC_CompleteMatch, 1, 0, 

   3, 60, 
    OPC_CompleteMatch, 1, 0, 

   3, 78, 
    OPC_CompleteMatch, 1, 0, 

   3, 1|128,1, 
    OPC_CompleteMatch, 1, 0, 

   3, 92, 
    OPC_CompleteMatch, 1, 0, 

   0,
  35, 
   OPC_CheckChild0Type, 1|128,1, 
   OPC_SwitchType , 3, 39, 
    OPC_CompleteMatch, 1, 0, 

   3, 50, 
    OPC_CompleteMatch, 1, 0, 

   3, 60, 
    OPC_CompleteMatch, 1, 0, 

   3, 78, 
    OPC_CompleteMatch, 1, 0, 

   3, 111, 
    OPC_CompleteMatch, 1, 0, 

   3, 92, 
    OPC_CompleteMatch, 1, 0, 

   0,
  35, 
   OPC_CheckChild0Type, 92, 
   OPC_SwitchType , 3, 39, 
    OPC_CompleteMatch, 1, 0, 

   3, 50, 
    OPC_CompleteMatch, 1, 0, 

   3, 60, 
    OPC_CompleteMatch, 1, 0, 

   3, 78, 
    OPC_CompleteMatch, 1, 0, 

   3, 111, 
    OPC_CompleteMatch, 1, 0, 

   3, 1|128,1, 
    OPC_CompleteMatch, 1, 0, 

   0,
  35, 
   OPC_CheckChild0Type, 39, 
   OPC_SwitchType , 3, 50, 
    OPC_CompleteMatch, 1, 0, 

   3, 60, 
    OPC_CompleteMatch, 1, 0, 

   3, 78, 
    OPC_CompleteMatch, 1, 0, 

   3, 111, 
    OPC_CompleteMatch, 1, 0, 

   3, 1|128,1, 
    OPC_CompleteMatch, 1, 0, 

   3, 92, 
    OPC_CompleteMatch, 1, 0, 

   0,
  0, 
 21, TARGET_VAL(ISD::ConstantFP),
  OPC_RecordNode,
  OPC_SwitchType , 7, 12, 
   OPC_EmitConvertToTarget0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_F32),
                 12, 1, 1, 
  7, 13, 
   OPC_EmitConvertToTarget0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_F64),
                 13, 1, 1, 
  0,
 63, TARGET_VAL(ISD::SINT_TO_FP),
  OPC_RecordChild0,
  OPC_Scope, 19, 
   OPC_CheckChild0TypeI32,
   OPC_SwitchType , 6, 12, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F32_CONVERT_S_I32),
                  12, 1, 0, 
   6, 13, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F64_CONVERT_S_I32),
                  13, 1, 0, 
   0,
  19, 
   OPC_CheckChild0TypeI64,
   OPC_SwitchType , 6, 12, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F32_CONVERT_S_I64),
                  12, 1, 0, 
   6, 13, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F64_CONVERT_S_I64),
                  13, 1, 0, 
   0,
  9, 
   OPC_CheckType, 111, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::sint_to_fp_F32x4),
                 111, 1, 0, 
  9, 
   OPC_CheckType, 92, 
   OPC_CheckPatternPredicate5,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::sint_to_fp_F16x8),
                 92, 1, 0, 
  0, 
 63, TARGET_VAL(ISD::UINT_TO_FP),
  OPC_RecordChild0,
  OPC_Scope, 19, 
   OPC_CheckChild0TypeI32,
   OPC_SwitchType , 6, 12, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F32_CONVERT_U_I32),
                  12, 1, 0, 
   6, 13, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F64_CONVERT_U_I32),
                  13, 1, 0, 
   0,
  19, 
   OPC_CheckChild0TypeI64,
   OPC_SwitchType , 6, 12, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F32_CONVERT_U_I64),
                  12, 1, 0, 
   6, 13, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F64_CONVERT_U_I64),
                  13, 1, 0, 
   0,
  9, 
   OPC_CheckType, 111, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::uint_to_fp_F32x4),
                 111, 1, 0, 
  9, 
   OPC_CheckType, 92, 
   OPC_CheckPatternPredicate5,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::uint_to_fp_F16x8),
                 92, 1, 0, 
  0, 
 7, TARGET_VAL(ISD::FP_EXTEND),
  OPC_RecordChild0,
  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F64_PROMOTE_F32),
                13, 1, 0, 
 7, TARGET_VAL(ISD::FP_ROUND),
  OPC_RecordChild0,
  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F32_DEMOTE_F64),
                12, 1, 0, 
 54, TARGET_VAL(ISD::FADD),
  OPC_RecordChild0,
  OPC_RecordChild1,
  OPC_SwitchType , 7, 12, 
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_F32),
                 12, 2, 0, 1, 
  7, 13, 
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_F64),
                 13, 2, 0, 1, 
  8, 111, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_F32x4),
                 111, 2, 0, 1, 
  9, 1|128,1, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_F64x2),
                 1|128,1, 2, 0, 1, 
  8, 92, 
   OPC_CheckPatternPredicate5,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_F16x8),
                 92, 2, 0, 1, 
  0,
 54, TARGET_VAL(ISD::FSUB),
  OPC_RecordChild0,
  OPC_RecordChild1,
  OPC_SwitchType , 7, 12, 
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_F32),
                 12, 2, 0, 1, 
  7, 13, 
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_F64),
                 13, 2, 0, 1, 
  8, 111, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_F32x4),
                 111, 2, 0, 1, 
  9, 1|128,1, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_F64x2),
                 1|128,1, 2, 0, 1, 
  8, 92, 
   OPC_CheckPatternPredicate5,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_F16x8),
                 92, 2, 0, 1, 
  0,
 54, TARGET_VAL(ISD::FMUL),
  OPC_RecordChild0,
  OPC_RecordChild1,
  OPC_SwitchType , 7, 12, 
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_F32),
                 12, 2, 0, 1, 
  7, 13, 
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_F64),
                 13, 2, 0, 1, 
  8, 111, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_F32x4),
                 111, 2, 0, 1, 
  9, 1|128,1, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_F64x2),
                 1|128,1, 2, 0, 1, 
  8, 92, 
   OPC_CheckPatternPredicate5,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_F16x8),
                 92, 2, 0, 1, 
  0,
 54, TARGET_VAL(ISD::FDIV),
  OPC_RecordChild0,
  OPC_RecordChild1,
  OPC_SwitchType , 7, 12, 
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_F32),
                 12, 2, 0, 1, 
  7, 13, 
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_F64),
                 13, 2, 0, 1, 
  8, 111, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_F32x4),
                 111, 2, 0, 1, 
  9, 1|128,1, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_F64x2),
                 1|128,1, 2, 0, 1, 
  8, 92, 
   OPC_CheckPatternPredicate5,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_F16x8),
                 92, 2, 0, 1, 
  0,
 48, TARGET_VAL(ISD::FSQRT),
  OPC_RecordChild0,
  OPC_SwitchType , 6, 12, 
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SQRT_F32),
                 12, 1, 0, 
  6, 13, 
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SQRT_F64),
                 13, 1, 0, 
  7, 111, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SQRT_F32x4),
                 111, 1, 0, 
  8, 1|128,1, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SQRT_F64x2),
                 1|128,1, 1, 0, 
  7, 92, 
   OPC_CheckPatternPredicate5,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SQRT_F16x8),
                 92, 1, 0, 
  0,
 48, TARGET_VAL(ISD::FABS),
  OPC_RecordChild0,
  OPC_SwitchType , 6, 12, 
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_F32),
                 12, 1, 0, 
  6, 13, 
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_F64),
                 13, 1, 0, 
  7, 111, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_F32x4),
                 111, 1, 0, 
  8, 1|128,1, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_F64x2),
                 1|128,1, 1, 0, 
  7, 92, 
   OPC_CheckPatternPredicate5,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_F16x8),
                 92, 1, 0, 
  0,
 48, TARGET_VAL(ISD::FNEG),
  OPC_RecordChild0,
  OPC_SwitchType , 6, 12, 
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_F32),
                 12, 1, 0, 
  6, 13, 
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_F64),
                 13, 1, 0, 
  7, 111, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_F32x4),
                 111, 1, 0, 
  8, 1|128,1, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_F64x2),
                 1|128,1, 1, 0, 
  7, 92, 
   OPC_CheckPatternPredicate5,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_F16x8),
                 92, 1, 0, 
  0,
 62, TARGET_VAL(ISD::FCOPYSIGN),
  OPC_RecordChild0,
  OPC_RecordChild1,
  OPC_Scope, 28, 
   OPC_CheckChild1Type, 12, 
   OPC_SwitchType , 7, 12, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::COPYSIGN_F32),
                  12, 2, 0, 1, 
   13, 13, 
    OPC_EmitNode1None, TARGET_VAL(WebAssembly::F64_PROMOTE_F32),
                  13, 1, 1, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::COPYSIGN_F64),
                  13, 2, 0, 2, 
   0,
  28, 
   OPC_CheckChild1Type, 13, 
   OPC_SwitchType , 7, 13, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::COPYSIGN_F64),
                  13, 2, 0, 1, 
   13, 12, 
    OPC_EmitNode1None, TARGET_VAL(WebAssembly::F32_DEMOTE_F64),
                  12, 1, 1, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::COPYSIGN_F32),
                  12, 2, 0, 2, 
   0,
  0, 
 54, TARGET_VAL(ISD::FMINIMUM),
  OPC_RecordChild0,
  OPC_RecordChild1,
  OPC_SwitchType , 7, 12, 
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_F32),
                 12, 2, 0, 1, 
  7, 13, 
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_F64),
                 13, 2, 0, 1, 
  8, 111, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_F32x4),
                 111, 2, 0, 1, 
  9, 1|128,1, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_F64x2),
                 1|128,1, 2, 0, 1, 
  8, 92, 
   OPC_CheckPatternPredicate5,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_F16x8),
                 92, 2, 0, 1, 
  0,
 54, TARGET_VAL(ISD::FMAXIMUM),
  OPC_RecordChild0,
  OPC_RecordChild1,
  OPC_SwitchType , 7, 12, 
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_F32),
                 12, 2, 0, 1, 
  7, 13, 
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_F64),
                 13, 2, 0, 1, 
  8, 111, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_F32x4),
                 111, 2, 0, 1, 
  9, 1|128,1, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_F64x2),
                 1|128,1, 2, 0, 1, 
  8, 92, 
   OPC_CheckPatternPredicate5,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_F16x8),
                 92, 2, 0, 1, 
  0,
 48, TARGET_VAL(ISD::FCEIL),
  OPC_RecordChild0,
  OPC_SwitchType , 6, 12, 
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CEIL_F32),
                 12, 1, 0, 
  6, 13, 
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CEIL_F64),
                 13, 1, 0, 
  7, 111, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CEIL_F32x4),
                 111, 1, 0, 
  8, 1|128,1, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CEIL_F64x2),
                 1|128,1, 1, 0, 
  7, 92, 
   OPC_CheckPatternPredicate5,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CEIL_F16x8),
                 92, 1, 0, 
  0,
 48, TARGET_VAL(ISD::FFLOOR),
  OPC_RecordChild0,
  OPC_SwitchType , 6, 12, 
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FLOOR_F32),
                 12, 1, 0, 
  6, 13, 
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FLOOR_F64),
                 13, 1, 0, 
  7, 111, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FLOOR_F32x4),
                 111, 1, 0, 
  8, 1|128,1, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FLOOR_F64x2),
                 1|128,1, 1, 0, 
  7, 92, 
   OPC_CheckPatternPredicate5,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FLOOR_F16x8),
                 92, 1, 0, 
  0,
 48, TARGET_VAL(ISD::FTRUNC),
  OPC_RecordChild0,
  OPC_SwitchType , 6, 12, 
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::TRUNC_F32),
                 12, 1, 0, 
  6, 13, 
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::TRUNC_F64),
                 13, 1, 0, 
  7, 111, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::TRUNC_F32x4),
                 111, 1, 0, 
  8, 1|128,1, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::TRUNC_F64x2),
                 1|128,1, 1, 0, 
  7, 92, 
   OPC_CheckPatternPredicate5,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::TRUNC_F16x8),
                 92, 1, 0, 
  0,
 48, TARGET_VAL(ISD::FNEARBYINT),
  OPC_RecordChild0,
  OPC_SwitchType , 6, 12, 
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F32),
                 12, 1, 0, 
  6, 13, 
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F64),
                 13, 1, 0, 
  7, 111, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F32x4),
                 111, 1, 0, 
  8, 1|128,1, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F64x2),
                 1|128,1, 1, 0, 
  7, 92, 
   OPC_CheckPatternPredicate5,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F16x8),
                 92, 1, 0, 
  0,
 45, TARGET_VAL(ISD::FRINT),
  OPC_RecordChild0,
  OPC_SwitchType , 6, 12, 
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F32),
                 12, 1, 0, 
  6, 13, 
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F64),
                 13, 1, 0, 
  6, 111, 
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F32x4),
                 111, 1, 0, 
  7, 1|128,1, 
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F64x2),
                 1|128,1, 1, 0, 
  6, 92, 
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F16x8),
                 92, 1, 0, 
  0,
 45, TARGET_VAL(ISD::FROUNDEVEN),
  OPC_RecordChild0,
  OPC_SwitchType , 6, 12, 
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F32),
                 12, 1, 0, 
  6, 13, 
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F64),
                 13, 1, 0, 
  6, 111, 
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F32x4),
                 111, 1, 0, 
  7, 1|128,1, 
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F64x2),
                 1|128,1, 1, 0, 
  6, 92, 
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F16x8),
                 92, 1, 0, 
  0,
 22|128,3, TARGET_VAL(ISD::BUILD_VECTOR),
  OPC_RecordChild0,
  OPC_MoveChild0,
  OPC_SwitchOpcode , 73|128,2, TARGET_VAL(ISD::Constant),
   OPC_SwitchType , 47|128,2, 7, 
    OPC_Scope, 51|128,1, 
     OPC_CheckPredicate, 9,
     OPC_MoveSibling1,
     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
     OPC_RecordNode,
     OPC_CheckPredicate, 9,
     OPC_CheckTypeI32,
     OPC_MoveSibling2,
     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
     OPC_RecordNode,
     OPC_CheckPredicate, 9,
     OPC_CheckTypeI32,
     OPC_MoveSibling3,
     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
     OPC_RecordNode,
     OPC_CheckPredicate, 9,
     OPC_CheckTypeI32,
     OPC_MoveSibling4,
     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
     OPC_RecordNode,
     OPC_CheckPredicate, 9,
     OPC_CheckTypeI32,
     OPC_MoveSibling5,
     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
     OPC_RecordNode,
     OPC_CheckPredicate, 9,
     OPC_CheckTypeI32,
     OPC_MoveSibling6,
     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
     OPC_RecordNode,
     OPC_CheckPredicate, 9,
     OPC_CheckTypeI32,
     OPC_MoveSibling7,
     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
     OPC_RecordNode,
     OPC_CheckPredicate, 9,
     OPC_CheckTypeI32,
     OPC_MoveSibling, 8,
     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
     OPC_RecordNode,
     OPC_CheckPredicate, 9,
     OPC_CheckTypeI32,
     OPC_MoveSibling, 9,
     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
     OPC_RecordNode,
     OPC_CheckPredicate, 9,
     OPC_CheckTypeI32,
     OPC_MoveSibling, 10,
     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
     OPC_RecordNode,
     OPC_CheckPredicate, 9,
     OPC_CheckTypeI32,
     OPC_MoveSibling, 11,
     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
     OPC_RecordNode,
     OPC_CheckPredicate, 9,
     OPC_CheckTypeI32,
     OPC_MoveSibling, 12,
     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
     OPC_RecordNode,
     OPC_CheckPredicate, 9,
     OPC_CheckTypeI32,
     OPC_MoveSibling, 13,
     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
     OPC_RecordNode,
     OPC_CheckPredicate, 9,
     OPC_CheckTypeI32,
     OPC_MoveSibling, 14,
     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
     OPC_RecordNode,
     OPC_CheckPredicate, 9,
     OPC_CheckTypeI32,
     OPC_MoveSibling, 15,
     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
     OPC_RecordNode,
     OPC_CheckPredicate, 9,
     OPC_CheckTypeI32,
     OPC_MoveParent,
     OPC_CheckType, 39, 
     OPC_CheckPatternPredicate0,
     OPC_EmitConvertToTarget0,
     OPC_EmitConvertToTarget1,
     OPC_EmitConvertToTarget2,
     OPC_EmitConvertToTarget3,
     OPC_EmitConvertToTarget4,
     OPC_EmitConvertToTarget5,
     OPC_EmitConvertToTarget6,
     OPC_EmitConvertToTarget7,
     OPC_EmitConvertToTarget, 8,
     OPC_EmitConvertToTarget, 9,
     OPC_EmitConvertToTarget, 10,
     OPC_EmitConvertToTarget, 11,
     OPC_EmitConvertToTarget, 12,
     OPC_EmitConvertToTarget, 13,
     OPC_EmitConvertToTarget, 14,
     OPC_EmitConvertToTarget, 15,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I8x16),
                   39, 16, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 
    83, 
     OPC_CheckPredicate, 17,
     OPC_MoveSibling1,
     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
     OPC_RecordNode,
     OPC_CheckPredicate, 17,
     OPC_CheckTypeI32,
     OPC_MoveSibling2,
     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
     OPC_RecordNode,
     OPC_CheckPredicate, 17,
     OPC_CheckTypeI32,
     OPC_MoveSibling3,
     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
     OPC_RecordNode,
     OPC_CheckPredicate, 17,
     OPC_CheckTypeI32,
     OPC_MoveSibling4,
     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
     OPC_RecordNode,
     OPC_CheckPredicate, 17,
     OPC_CheckTypeI32,
     OPC_MoveSibling5,
     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
     OPC_RecordNode,
     OPC_CheckPredicate, 17,
     OPC_CheckTypeI32,
     OPC_MoveSibling6,
     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
     OPC_RecordNode,
     OPC_CheckPredicate, 17,
     OPC_CheckTypeI32,
     OPC_MoveSibling7,
     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
     OPC_RecordNode,
     OPC_CheckPredicate, 17,
     OPC_CheckTypeI32,
     OPC_MoveParent,
     OPC_CheckType, 50, 
     OPC_CheckPatternPredicate0,
     OPC_EmitConvertToTarget0,
     OPC_EmitConvertToTarget1,
     OPC_EmitConvertToTarget2,
     OPC_EmitConvertToTarget3,
     OPC_EmitConvertToTarget4,
     OPC_EmitConvertToTarget5,
     OPC_EmitConvertToTarget6,
     OPC_EmitConvertToTarget7,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I16x8),
                   50, 8, 8, 9, 10, 11, 12, 13, 14, 15, 
    35, 
     OPC_MoveSibling1,
     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
     OPC_RecordNode,
     OPC_CheckTypeI32,
     OPC_MoveSibling2,
     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
     OPC_RecordNode,
     OPC_CheckTypeI32,
     OPC_MoveSibling3,
     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
     OPC_RecordNode,
     OPC_CheckTypeI32,
     OPC_MoveParent,
     OPC_CheckType, 60, 
     OPC_CheckPatternPredicate0,
     OPC_EmitConvertToTarget0,
     OPC_EmitConvertToTarget1,
     OPC_EmitConvertToTarget2,
     OPC_EmitConvertToTarget3,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I32x4),
                   60, 4, 4, 5, 6, 7, 
    0, 
   19, 8, 
    OPC_MoveSibling1,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckTypeI64,
    OPC_MoveParent,
    OPC_CheckType, 78, 
    OPC_CheckPatternPredicate0,
    OPC_EmitConvertToTarget0,
    OPC_EmitConvertToTarget1,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I64x2),
                  78, 2, 2, 3, 
   0,
  66, TARGET_VAL(ISD::ConstantFP),
   OPC_SwitchType , 38, 12, 
    OPC_MoveSibling1,
    OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
    OPC_RecordNode,
    OPC_CheckType, 12, 
    OPC_MoveSibling2,
    OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
    OPC_RecordNode,
    OPC_CheckType, 12, 
    OPC_MoveSibling3,
    OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
    OPC_RecordNode,
    OPC_CheckType, 12, 
    OPC_MoveParent,
    OPC_CheckType, 111, 
    OPC_CheckPatternPredicate0,
    OPC_EmitConvertToTarget0,
    OPC_EmitConvertToTarget1,
    OPC_EmitConvertToTarget2,
    OPC_EmitConvertToTarget3,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_F32x4),
                  111, 4, 4, 5, 6, 7, 
   22, 13, 
    OPC_MoveSibling1,
    OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
    OPC_RecordNode,
    OPC_CheckType, 13, 
    OPC_MoveParent,
    OPC_CheckType, 1|128,1, 
    OPC_CheckPatternPredicate0,
    OPC_EmitConvertToTarget0,
    OPC_EmitConvertToTarget1,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_F64x2),
                  1|128,1, 2, 2, 3, 
   0,
  0,
 7|128,16, TARGET_VAL(WebAssemblyISD::SHUFFLE),
  OPC_RecordChild0,
  OPC_Scope, 83|128,2, 
   OPC_CheckChild0Type, 39, 
   OPC_RecordChild1,
   OPC_CheckChild1Type, 39, 
   OPC_RecordChild2,
   OPC_MoveChild2,
   OPC_SwitchOpcode , 41|128,1, TARGET_VAL(ISD::Constant),
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling3,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling4,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling5,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling6,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling7,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling, 8,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling, 9,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling, 10,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling, 11,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling, 12,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling, 13,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling, 14,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling, 15,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling, 16,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling, 17,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveParent,
    OPC_CheckType, 39, 
    OPC_EmitConvertToTarget2,
    OPC_EmitConvertToTarget3,
    OPC_EmitConvertToTarget4,
    OPC_EmitConvertToTarget5,
    OPC_EmitConvertToTarget6,
    OPC_EmitConvertToTarget7,
    OPC_EmitConvertToTarget, 8,
    OPC_EmitConvertToTarget, 9,
    OPC_EmitConvertToTarget, 10,
    OPC_EmitConvertToTarget, 11,
    OPC_EmitConvertToTarget, 12,
    OPC_EmitConvertToTarget, 13,
    OPC_EmitConvertToTarget, 14,
    OPC_EmitConvertToTarget, 15,
    OPC_EmitConvertToTarget, 16,
    OPC_EmitConvertToTarget, 17,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  39, 18, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
   25|128,1, TARGET_VAL(ISD::TargetConstant),
    OPC_CheckTypeI32,
    OPC_MoveSibling3,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling4,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling5,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling6,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling7,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling, 8,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling, 9,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling, 10,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling, 11,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling, 12,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling, 13,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling, 14,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling, 15,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling, 16,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling, 17,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveParent,
    OPC_CheckType, 39, 
    OPC_EmitConvertToTarget2,
    OPC_EmitConvertToTarget3,
    OPC_EmitConvertToTarget4,
    OPC_EmitConvertToTarget5,
    OPC_EmitConvertToTarget6,
    OPC_EmitConvertToTarget7,
    OPC_EmitConvertToTarget, 8,
    OPC_EmitConvertToTarget, 9,
    OPC_EmitConvertToTarget, 10,
    OPC_EmitConvertToTarget, 11,
    OPC_EmitConvertToTarget, 12,
    OPC_EmitConvertToTarget, 13,
    OPC_EmitConvertToTarget, 14,
    OPC_EmitConvertToTarget, 15,
    OPC_EmitConvertToTarget, 16,
    OPC_EmitConvertToTarget, 17,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  39, 18, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
   0,
  83|128,2, 
   OPC_CheckChild0Type, 50, 
   OPC_RecordChild1,
   OPC_CheckChild1Type, 50, 
   OPC_RecordChild2,
   OPC_MoveChild2,
   OPC_SwitchOpcode , 41|128,1, TARGET_VAL(ISD::Constant),
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling3,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling4,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling5,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling6,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling7,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling, 8,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling, 9,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling, 10,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling, 11,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling, 12,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling, 13,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling, 14,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling, 15,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling, 16,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling, 17,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveParent,
    OPC_CheckType, 50, 
    OPC_EmitConvertToTarget2,
    OPC_EmitConvertToTarget3,
    OPC_EmitConvertToTarget4,
    OPC_EmitConvertToTarget5,
    OPC_EmitConvertToTarget6,
    OPC_EmitConvertToTarget7,
    OPC_EmitConvertToTarget, 8,
    OPC_EmitConvertToTarget, 9,
    OPC_EmitConvertToTarget, 10,
    OPC_EmitConvertToTarget, 11,
    OPC_EmitConvertToTarget, 12,
    OPC_EmitConvertToTarget, 13,
    OPC_EmitConvertToTarget, 14,
    OPC_EmitConvertToTarget, 15,
    OPC_EmitConvertToTarget, 16,
    OPC_EmitConvertToTarget, 17,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  50, 18, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
   25|128,1, TARGET_VAL(ISD::TargetConstant),
    OPC_CheckTypeI32,
    OPC_MoveSibling3,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling4,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling5,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling6,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling7,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling, 8,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling, 9,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling, 10,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling, 11,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling, 12,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling, 13,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling, 14,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling, 15,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling, 16,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling, 17,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveParent,
    OPC_CheckType, 50, 
    OPC_EmitConvertToTarget2,
    OPC_EmitConvertToTarget3,
    OPC_EmitConvertToTarget4,
    OPC_EmitConvertToTarget5,
    OPC_EmitConvertToTarget6,
    OPC_EmitConvertToTarget7,
    OPC_EmitConvertToTarget, 8,
    OPC_EmitConvertToTarget, 9,
    OPC_EmitConvertToTarget, 10,
    OPC_EmitConvertToTarget, 11,
    OPC_EmitConvertToTarget, 12,
    OPC_EmitConvertToTarget, 13,
    OPC_EmitConvertToTarget, 14,
    OPC_EmitConvertToTarget, 15,
    OPC_EmitConvertToTarget, 16,
    OPC_EmitConvertToTarget, 17,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  50, 18, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
   0,
  83|128,2, 
   OPC_CheckChild0Type, 60, 
   OPC_RecordChild1,
   OPC_CheckChild1Type, 60, 
   OPC_RecordChild2,
   OPC_MoveChild2,
   OPC_SwitchOpcode , 41|128,1, TARGET_VAL(ISD::Constant),
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling3,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling4,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling5,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling6,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling7,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling, 8,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling, 9,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling, 10,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling, 11,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling, 12,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling, 13,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling, 14,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling, 15,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling, 16,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling, 17,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveParent,
    OPC_CheckType, 60, 
    OPC_EmitConvertToTarget2,
    OPC_EmitConvertToTarget3,
    OPC_EmitConvertToTarget4,
    OPC_EmitConvertToTarget5,
    OPC_EmitConvertToTarget6,
    OPC_EmitConvertToTarget7,
    OPC_EmitConvertToTarget, 8,
    OPC_EmitConvertToTarget, 9,
    OPC_EmitConvertToTarget, 10,
    OPC_EmitConvertToTarget, 11,
    OPC_EmitConvertToTarget, 12,
    OPC_EmitConvertToTarget, 13,
    OPC_EmitConvertToTarget, 14,
    OPC_EmitConvertToTarget, 15,
    OPC_EmitConvertToTarget, 16,
    OPC_EmitConvertToTarget, 17,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  60, 18, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
   25|128,1, TARGET_VAL(ISD::TargetConstant),
    OPC_CheckTypeI32,
    OPC_MoveSibling3,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling4,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling5,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling6,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling7,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling, 8,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling, 9,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling, 10,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling, 11,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling, 12,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling, 13,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling, 14,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling, 15,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling, 16,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling, 17,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveParent,
    OPC_CheckType, 60, 
    OPC_EmitConvertToTarget2,
    OPC_EmitConvertToTarget3,
    OPC_EmitConvertToTarget4,
    OPC_EmitConvertToTarget5,
    OPC_EmitConvertToTarget6,
    OPC_EmitConvertToTarget7,
    OPC_EmitConvertToTarget, 8,
    OPC_EmitConvertToTarget, 9,
    OPC_EmitConvertToTarget, 10,
    OPC_EmitConvertToTarget, 11,
    OPC_EmitConvertToTarget, 12,
    OPC_EmitConvertToTarget, 13,
    OPC_EmitConvertToTarget, 14,
    OPC_EmitConvertToTarget, 15,
    OPC_EmitConvertToTarget, 16,
    OPC_EmitConvertToTarget, 17,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  60, 18, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
   0,
  83|128,2, 
   OPC_CheckChild0Type, 78, 
   OPC_RecordChild1,
   OPC_CheckChild1Type, 78, 
   OPC_RecordChild2,
   OPC_MoveChild2,
   OPC_SwitchOpcode , 41|128,1, TARGET_VAL(ISD::Constant),
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling3,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling4,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling5,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling6,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling7,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling, 8,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling, 9,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling, 10,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling, 11,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling, 12,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling, 13,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling, 14,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling, 15,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling, 16,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling, 17,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveParent,
    OPC_CheckType, 78, 
    OPC_EmitConvertToTarget2,
    OPC_EmitConvertToTarget3,
    OPC_EmitConvertToTarget4,
    OPC_EmitConvertToTarget5,
    OPC_EmitConvertToTarget6,
    OPC_EmitConvertToTarget7,
    OPC_EmitConvertToTarget, 8,
    OPC_EmitConvertToTarget, 9,
    OPC_EmitConvertToTarget, 10,
    OPC_EmitConvertToTarget, 11,
    OPC_EmitConvertToTarget, 12,
    OPC_EmitConvertToTarget, 13,
    OPC_EmitConvertToTarget, 14,
    OPC_EmitConvertToTarget, 15,
    OPC_EmitConvertToTarget, 16,
    OPC_EmitConvertToTarget, 17,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  78, 18, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
   25|128,1, TARGET_VAL(ISD::TargetConstant),
    OPC_CheckTypeI32,
    OPC_MoveSibling3,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling4,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling5,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling6,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling7,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling, 8,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling, 9,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling, 10,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling, 11,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling, 12,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling, 13,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling, 14,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling, 15,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling, 16,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling, 17,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveParent,
    OPC_CheckType, 78, 
    OPC_EmitConvertToTarget2,
    OPC_EmitConvertToTarget3,
    OPC_EmitConvertToTarget4,
    OPC_EmitConvertToTarget5,
    OPC_EmitConvertToTarget6,
    OPC_EmitConvertToTarget7,
    OPC_EmitConvertToTarget, 8,
    OPC_EmitConvertToTarget, 9,
    OPC_EmitConvertToTarget, 10,
    OPC_EmitConvertToTarget, 11,
    OPC_EmitConvertToTarget, 12,
    OPC_EmitConvertToTarget, 13,
    OPC_EmitConvertToTarget, 14,
    OPC_EmitConvertToTarget, 15,
    OPC_EmitConvertToTarget, 16,
    OPC_EmitConvertToTarget, 17,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  78, 18, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
   0,
  83|128,2, 
   OPC_CheckChild0Type, 111, 
   OPC_RecordChild1,
   OPC_CheckChild1Type, 111, 
   OPC_RecordChild2,
   OPC_MoveChild2,
   OPC_SwitchOpcode , 41|128,1, TARGET_VAL(ISD::Constant),
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling3,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling4,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling5,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling6,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling7,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling, 8,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling, 9,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling, 10,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling, 11,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling, 12,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling, 13,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling, 14,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling, 15,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling, 16,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling, 17,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveParent,
    OPC_CheckType, 111, 
    OPC_EmitConvertToTarget2,
    OPC_EmitConvertToTarget3,
    OPC_EmitConvertToTarget4,
    OPC_EmitConvertToTarget5,
    OPC_EmitConvertToTarget6,
    OPC_EmitConvertToTarget7,
    OPC_EmitConvertToTarget, 8,
    OPC_EmitConvertToTarget, 9,
    OPC_EmitConvertToTarget, 10,
    OPC_EmitConvertToTarget, 11,
    OPC_EmitConvertToTarget, 12,
    OPC_EmitConvertToTarget, 13,
    OPC_EmitConvertToTarget, 14,
    OPC_EmitConvertToTarget, 15,
    OPC_EmitConvertToTarget, 16,
    OPC_EmitConvertToTarget, 17,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  111, 18, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
   25|128,1, TARGET_VAL(ISD::TargetConstant),
    OPC_CheckTypeI32,
    OPC_MoveSibling3,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling4,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling5,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling6,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling7,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling, 8,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling, 9,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling, 10,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling, 11,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling, 12,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling, 13,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling, 14,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling, 15,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling, 16,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling, 17,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveParent,
    OPC_CheckType, 111, 
    OPC_EmitConvertToTarget2,
    OPC_EmitConvertToTarget3,
    OPC_EmitConvertToTarget4,
    OPC_EmitConvertToTarget5,
    OPC_EmitConvertToTarget6,
    OPC_EmitConvertToTarget7,
    OPC_EmitConvertToTarget, 8,
    OPC_EmitConvertToTarget, 9,
    OPC_EmitConvertToTarget, 10,
    OPC_EmitConvertToTarget, 11,
    OPC_EmitConvertToTarget, 12,
    OPC_EmitConvertToTarget, 13,
    OPC_EmitConvertToTarget, 14,
    OPC_EmitConvertToTarget, 15,
    OPC_EmitConvertToTarget, 16,
    OPC_EmitConvertToTarget, 17,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  111, 18, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
   0,
  89|128,2, 
   OPC_CheckChild0Type, 1|128,1, 
   OPC_RecordChild1,
   OPC_CheckChild1Type, 1|128,1, 
   OPC_RecordChild2,
   OPC_MoveChild2,
   OPC_SwitchOpcode , 43|128,1, TARGET_VAL(ISD::Constant),
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling3,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling4,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling5,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling6,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling7,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling, 8,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling, 9,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling, 10,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling, 11,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling, 12,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling, 13,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling, 14,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling, 15,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling, 16,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveSibling, 17,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_RecordNode,
    OPC_CheckPredicate0, 
    OPC_CheckTypeI32,
    OPC_MoveParent,
    OPC_CheckType, 1|128,1, 
    OPC_EmitConvertToTarget2,
    OPC_EmitConvertToTarget3,
    OPC_EmitConvertToTarget4,
    OPC_EmitConvertToTarget5,
    OPC_EmitConvertToTarget6,
    OPC_EmitConvertToTarget7,
    OPC_EmitConvertToTarget, 8,
    OPC_EmitConvertToTarget, 9,
    OPC_EmitConvertToTarget, 10,
    OPC_EmitConvertToTarget, 11,
    OPC_EmitConvertToTarget, 12,
    OPC_EmitConvertToTarget, 13,
    OPC_EmitConvertToTarget, 14,
    OPC_EmitConvertToTarget, 15,
    OPC_EmitConvertToTarget, 16,
    OPC_EmitConvertToTarget, 17,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  1|128,1, 18, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
   27|128,1, TARGET_VAL(ISD::TargetConstant),
    OPC_CheckTypeI32,
    OPC_MoveSibling3,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling4,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling5,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling6,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling7,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling, 8,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling, 9,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling, 10,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling, 11,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling, 12,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling, 13,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling, 14,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling, 15,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling, 16,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveSibling, 17,
    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
    OPC_RecordNode,
    OPC_CheckTypeI32,
    OPC_MoveParent,
    OPC_CheckType, 1|128,1, 
    OPC_EmitConvertToTarget2,
    OPC_EmitConvertToTarget3,
    OPC_EmitConvertToTarget4,
    OPC_EmitConvertToTarget5,
    OPC_EmitConvertToTarget6,
    OPC_EmitConvertToTarget7,
    OPC_EmitConvertToTarget, 8,
    OPC_EmitConvertToTarget, 9,
    OPC_EmitConvertToTarget, 10,
    OPC_EmitConvertToTarget, 11,
    OPC_EmitConvertToTarget, 12,
    OPC_EmitConvertToTarget, 13,
    OPC_EmitConvertToTarget, 14,
    OPC_EmitConvertToTarget, 15,
    OPC_EmitConvertToTarget, 16,
    OPC_EmitConvertToTarget, 17,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  1|128,1, 18, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
   0,
  0, 
 73|128,8, TARGET_VAL(ISD::INSERT_VECTOR_ELT),
  OPC_Scope, 6|128,1, 
   OPC_MoveChild0,
   OPC_CheckOpcode, TARGET_VAL(ISD::SPLAT_VECTOR),
   OPC_CheckChild0Integer, 0, 
   OPC_Scope, 62, 
    OPC_CheckChild0TypeI32,
    OPC_MoveSibling1,
    OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
    OPC_RecordMemRef,
    OPC_RecordNode,
    OPC_CheckFoldableChainNode,
    OPC_RecordChild1,
    OPC_CheckTypeI32,
    OPC_Scope, 24, 
     OPC_CheckChild1TypeI32,
     OPC_CheckPredicate, 8,
     OPC_CheckPredicate6, 
     OPC_MoveParent,
     OPC_CheckChild2Integer, 0, 
     OPC_CheckType, 60, 
     OPC_CheckPatternPredicate1,
     OPC_CheckComplexPat0, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   60, 3, 4, 2, 3, 
    24, 
     OPC_CheckChild1TypeI64,
     OPC_CheckPredicate, 8,
     OPC_CheckPredicate6, 
     OPC_MoveParent,
     OPC_CheckChild2Integer, 0, 
     OPC_CheckType, 60, 
     OPC_CheckPatternPredicate2,
     OPC_CheckComplexPat1, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   60, 3, 4, 2, 3, 
    0, 
   62, 
    OPC_CheckChild0TypeI64,
    OPC_MoveSibling1,
    OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
    OPC_RecordMemRef,
    OPC_RecordNode,
    OPC_CheckFoldableChainNode,
    OPC_RecordChild1,
    OPC_CheckTypeI64,
    OPC_Scope, 24, 
     OPC_CheckChild1TypeI32,
     OPC_CheckPredicate, 8,
     OPC_CheckPredicate6, 
     OPC_MoveParent,
     OPC_CheckChild2Integer, 0, 
     OPC_CheckType, 78, 
     OPC_CheckPatternPredicate1,
     OPC_CheckComplexPat0, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   78, 3, 4, 2, 3, 
    24, 
     OPC_CheckChild1TypeI64,
     OPC_CheckPredicate, 8,
     OPC_CheckPredicate6, 
     OPC_MoveParent,
     OPC_CheckChild2Integer, 0, 
     OPC_CheckType, 78, 
     OPC_CheckPatternPredicate2,
     OPC_CheckComplexPat1, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   78, 3, 4, 2, 3, 
    0, 
   0, 
  61|128,7, 
   OPC_RecordChild0,
   OPC_Scope, 32|128,3, 
    OPC_MoveChild1,
    OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
    OPC_RecordMemRef,
    OPC_RecordNode,
    OPC_CheckFoldableChainNode,
    OPC_RecordChild1,
    OPC_Scope, 73|128,1, 
     OPC_CheckChild1TypeI32,
     OPC_CheckPredicate, 8,
     OPC_Scope, 67, 
      OPC_CheckPredicate, 10,
      OPC_CheckTypeI32,
      OPC_Scope, 30, 
       OPC_CheckPredicate1, 
       OPC_MoveSibling2,
       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
       OPC_RecordNode,
       OPC_CheckPredicate, 18,
       OPC_CheckTypeI32,
       OPC_MoveParent,
       OPC_CheckType, 39, 
       OPC_CheckPatternPredicate1,
       OPC_EmitMergeInputChains1_1,
       OPC_EmitInteger32, 0, 
       OPC_EmitInteger32, 0, 
       OPC_EmitConvertToTarget3,
       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     39, 5, 4, 5, 6, 2, 0, 
      30, 
       OPC_CheckPredicate2, 
       OPC_MoveSibling2,
       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
       OPC_RecordNode,
       OPC_CheckPredicate, 13,
       OPC_CheckTypeI32,
       OPC_MoveParent,
       OPC_CheckType, 50, 
       OPC_CheckPatternPredicate1,
       OPC_EmitMergeInputChains1_1,
       OPC_EmitInteger32, 0, 
       OPC_EmitInteger32, 0, 
       OPC_EmitConvertToTarget3,
       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_16_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     50, 5, 4, 5, 6, 2, 0, 
      0, 
     127, 
      OPC_CheckPredicate6, 
      OPC_SwitchType , 29, 7, 
       OPC_MoveSibling2,
       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
       OPC_RecordNode,
       OPC_CheckPredicate, 11,
       OPC_CheckTypeI32,
       OPC_MoveParent,
       OPC_CheckType, 60, 
       OPC_CheckPatternPredicate1,
       OPC_EmitMergeInputChains1_1,
       OPC_EmitInteger32, 0, 
       OPC_EmitInteger32, 0, 
       OPC_EmitConvertToTarget3,
       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     60, 5, 4, 5, 6, 2, 0, 
      29, 12, 
       OPC_MoveSibling2,
       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
       OPC_RecordNode,
       OPC_CheckPredicate, 11,
       OPC_CheckTypeI32,
       OPC_MoveParent,
       OPC_CheckType, 60, 
       OPC_CheckPatternPredicate1,
       OPC_EmitMergeInputChains1_1,
       OPC_EmitInteger32, 0, 
       OPC_EmitInteger32, 0, 
       OPC_EmitConvertToTarget3,
       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     60, 5, 4, 5, 6, 2, 0, 
      29, 8, 
       OPC_MoveSibling2,
       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
       OPC_RecordNode,
       OPC_CheckPredicate, 12,
       OPC_CheckTypeI32,
       OPC_MoveParent,
       OPC_CheckType, 78, 
       OPC_CheckPatternPredicate1,
       OPC_EmitMergeInputChains1_1,
       OPC_EmitInteger32, 0, 
       OPC_EmitInteger32, 0, 
       OPC_EmitConvertToTarget3,
       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     78, 5, 4, 5, 6, 2, 0, 
      29, 13, 
       OPC_MoveSibling2,
       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
       OPC_RecordNode,
       OPC_CheckPredicate, 12,
       OPC_CheckTypeI32,
       OPC_MoveParent,
       OPC_CheckType, 78, 
       OPC_CheckPatternPredicate1,
       OPC_EmitMergeInputChains1_1,
       OPC_EmitInteger32, 0, 
       OPC_EmitInteger32, 0, 
       OPC_EmitConvertToTarget3,
       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     78, 5, 4, 5, 6, 2, 0, 
      0,
     0, 
    73|128,1, 
     OPC_CheckChild1TypeI64,
     OPC_CheckPredicate, 8,
     OPC_Scope, 67, 
      OPC_CheckPredicate, 10,
      OPC_CheckTypeI32,
      OPC_Scope, 30, 
       OPC_CheckPredicate1, 
       OPC_MoveSibling2,
       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
       OPC_RecordNode,
       OPC_CheckPredicate, 18,
       OPC_CheckTypeI32,
       OPC_MoveParent,
       OPC_CheckType, 39, 
       OPC_CheckPatternPredicate2,
       OPC_EmitMergeInputChains1_1,
       OPC_EmitInteger32, 0, 
       OPC_EmitInteger64, 0, 
       OPC_EmitConvertToTarget3,
       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     39, 5, 4, 5, 6, 2, 0, 
      30, 
       OPC_CheckPredicate2, 
       OPC_MoveSibling2,
       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
       OPC_RecordNode,
       OPC_CheckPredicate, 13,
       OPC_CheckTypeI32,
       OPC_MoveParent,
       OPC_CheckType, 50, 
       OPC_CheckPatternPredicate2,
       OPC_EmitMergeInputChains1_1,
       OPC_EmitInteger32, 0, 
       OPC_EmitInteger64, 0, 
       OPC_EmitConvertToTarget3,
       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_16_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     50, 5, 4, 5, 6, 2, 0, 
      0, 
     127, 
      OPC_CheckPredicate6, 
      OPC_SwitchType , 29, 7, 
       OPC_MoveSibling2,
       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
       OPC_RecordNode,
       OPC_CheckPredicate, 11,
       OPC_CheckTypeI32,
       OPC_MoveParent,
       OPC_CheckType, 60, 
       OPC_CheckPatternPredicate2,
       OPC_EmitMergeInputChains1_1,
       OPC_EmitInteger32, 0, 
       OPC_EmitInteger64, 0, 
       OPC_EmitConvertToTarget3,
       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     60, 5, 4, 5, 6, 2, 0, 
      29, 12, 
       OPC_MoveSibling2,
       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
       OPC_RecordNode,
       OPC_CheckPredicate, 11,
       OPC_CheckTypeI32,
       OPC_MoveParent,
       OPC_CheckType, 60, 
       OPC_CheckPatternPredicate2,
       OPC_EmitMergeInputChains1_1,
       OPC_EmitInteger32, 0, 
       OPC_EmitInteger64, 0, 
       OPC_EmitConvertToTarget3,
       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     60, 5, 4, 5, 6, 2, 0, 
      29, 8, 
       OPC_MoveSibling2,
       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
       OPC_RecordNode,
       OPC_CheckPredicate, 12,
       OPC_CheckTypeI32,
       OPC_MoveParent,
       OPC_CheckType, 78, 
       OPC_CheckPatternPredicate2,
       OPC_EmitMergeInputChains1_1,
       OPC_EmitInteger32, 0, 
       OPC_EmitInteger64, 0, 
       OPC_EmitConvertToTarget3,
       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     78, 5, 4, 5, 6, 2, 0, 
      29, 13, 
       OPC_MoveSibling2,
       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
       OPC_RecordNode,
       OPC_CheckPredicate, 12,
       OPC_CheckTypeI32,
       OPC_MoveParent,
       OPC_CheckType, 78, 
       OPC_CheckPatternPredicate2,
       OPC_EmitMergeInputChains1_1,
       OPC_EmitInteger32, 0, 
       OPC_EmitInteger64, 0, 
       OPC_EmitConvertToTarget3,
       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     78, 5, 4, 5, 6, 2, 0, 
      0,
     0, 
    0, 
   24|128,1, 
    OPC_RecordChild1,
    OPC_Scope, 104, 
     OPC_CheckChild1TypeI32,
     OPC_Scope, 56, 
      OPC_RecordChild2,
      OPC_MoveChild2,
      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
      OPC_CheckTypeI32,
      OPC_Scope, 15, 
       OPC_CheckPredicate, 18,
       OPC_MoveParent,
       OPC_CheckType, 39, 
       OPC_CheckPatternPredicate0,
       OPC_EmitConvertToTarget2,
       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I8x16),
                     39, 3, 0, 3, 1, 
      15, 
       OPC_CheckPredicate, 13,
       OPC_MoveParent,
       OPC_CheckType, 50, 
       OPC_CheckPatternPredicate0,
       OPC_EmitConvertToTarget2,
       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I16x8),
                     50, 3, 0, 3, 1, 
      15, 
       OPC_CheckPredicate, 11,
       OPC_MoveParent,
       OPC_CheckType, 60, 
       OPC_CheckPatternPredicate0,
       OPC_EmitConvertToTarget2,
       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I32x4),
                     60, 3, 0, 3, 1, 
      0, 
     43, 
      OPC_MoveChild2,
      OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
      OPC_MoveParent,
      OPC_SwitchType , 10, 39, 
       OPC_EmitInteger32, 0, 
       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I8x16),
                     39, 3, 0, 2, 1, 
      10, 50, 
       OPC_EmitInteger32, 0, 
       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I16x8),
                     50, 3, 0, 2, 1, 
      10, 60, 
       OPC_EmitInteger32, 0, 
       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I32x4),
                     60, 3, 0, 2, 1, 
      0,
     0, 
    43, 
     OPC_CheckChild1TypeI64,
     OPC_Scope, 21, 
      OPC_RecordChild2,
      OPC_MoveChild2,
      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
      OPC_CheckPredicate, 12,
      OPC_CheckTypeI32,
      OPC_MoveParent,
      OPC_CheckType, 78, 
      OPC_CheckPatternPredicate0,
      OPC_EmitConvertToTarget2,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I64x2),
                    78, 3, 0, 3, 1, 
     17, 
      OPC_MoveChild2,
      OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
      OPC_MoveParent,
      OPC_CheckType, 78, 
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I64x2),
                    78, 3, 0, 2, 1, 
     0, 
    0, 
   26|128,2, 
    OPC_MoveChild1,
    OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
    OPC_RecordMemRef,
    OPC_RecordNode,
    OPC_CheckFoldableChainNode,
    OPC_RecordChild1,
    OPC_Scope, 6|128,1, 
     OPC_CheckChild1TypeI32,
     OPC_CheckPredicate, 8,
     OPC_CheckPredicate6, 
     OPC_SwitchType , 29, 7, 
      OPC_MoveSibling2,
      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
      OPC_RecordNode,
      OPC_CheckPredicate, 11,
      OPC_CheckTypeI32,
      OPC_MoveParent,
      OPC_CheckType, 111, 
      OPC_CheckPatternPredicate1,
      OPC_EmitMergeInputChains1_1,
      OPC_EmitInteger32, 0, 
      OPC_EmitInteger32, 0, 
      OPC_EmitConvertToTarget3,
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    111, 5, 4, 5, 6, 2, 0, 
     29, 12, 
      OPC_MoveSibling2,
      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
      OPC_RecordNode,
      OPC_CheckPredicate, 11,
      OPC_CheckTypeI32,
      OPC_MoveParent,
      OPC_CheckType, 111, 
      OPC_CheckPatternPredicate1,
      OPC_EmitMergeInputChains1_1,
      OPC_EmitInteger32, 0, 
      OPC_EmitInteger32, 0, 
      OPC_EmitConvertToTarget3,
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    111, 5, 4, 5, 6, 2, 0, 
     31, 8, 
      OPC_MoveSibling2,
      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
      OPC_RecordNode,
      OPC_CheckPredicate, 12,
      OPC_CheckTypeI32,
      OPC_MoveParent,
      OPC_CheckType, 1|128,1, 
      OPC_CheckPatternPredicate1,
      OPC_EmitMergeInputChains1_1,
      OPC_EmitInteger32, 0, 
      OPC_EmitInteger32, 0, 
      OPC_EmitConvertToTarget3,
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    1|128,1, 5, 4, 5, 6, 2, 0, 
     31, 13, 
      OPC_MoveSibling2,
      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
      OPC_RecordNode,
      OPC_CheckPredicate, 12,
      OPC_CheckTypeI32,
      OPC_MoveParent,
      OPC_CheckType, 1|128,1, 
      OPC_CheckPatternPredicate1,
      OPC_EmitMergeInputChains1_1,
      OPC_EmitInteger32, 0, 
      OPC_EmitInteger32, 0, 
      OPC_EmitConvertToTarget3,
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    1|128,1, 5, 4, 5, 6, 2, 0, 
     0,
    6|128,1, 
     OPC_CheckChild1TypeI64,
     OPC_CheckPredicate, 8,
     OPC_CheckPredicate6, 
     OPC_SwitchType , 29, 7, 
      OPC_MoveSibling2,
      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
      OPC_RecordNode,
      OPC_CheckPredicate, 11,
      OPC_CheckTypeI32,
      OPC_MoveParent,
      OPC_CheckType, 111, 
      OPC_CheckPatternPredicate2,
      OPC_EmitMergeInputChains1_1,
      OPC_EmitInteger32, 0, 
      OPC_EmitInteger64, 0, 
      OPC_EmitConvertToTarget3,
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    111, 5, 4, 5, 6, 2, 0, 
     29, 12, 
      OPC_MoveSibling2,
      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
      OPC_RecordNode,
      OPC_CheckPredicate, 11,
      OPC_CheckTypeI32,
      OPC_MoveParent,
      OPC_CheckType, 111, 
      OPC_CheckPatternPredicate2,
      OPC_EmitMergeInputChains1_1,
      OPC_EmitInteger32, 0, 
      OPC_EmitInteger64, 0, 
      OPC_EmitConvertToTarget3,
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    111, 5, 4, 5, 6, 2, 0, 
     31, 8, 
      OPC_MoveSibling2,
      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
      OPC_RecordNode,
      OPC_CheckPredicate, 12,
      OPC_CheckTypeI32,
      OPC_MoveParent,
      OPC_CheckType, 1|128,1, 
      OPC_CheckPatternPredicate2,
      OPC_EmitMergeInputChains1_1,
      OPC_EmitInteger32, 0, 
      OPC_EmitInteger64, 0, 
      OPC_EmitConvertToTarget3,
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    1|128,1, 5, 4, 5, 6, 2, 0, 
     31, 13, 
      OPC_MoveSibling2,
      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
      OPC_RecordNode,
      OPC_CheckPredicate, 12,
      OPC_CheckTypeI32,
      OPC_MoveParent,
      OPC_CheckType, 1|128,1, 
      OPC_CheckPatternPredicate2,
      OPC_EmitMergeInputChains1_1,
      OPC_EmitInteger32, 0, 
      OPC_EmitInteger64, 0, 
      OPC_EmitConvertToTarget3,
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    1|128,1, 5, 4, 5, 6, 2, 0, 
     0,
    0, 
   97, 
    OPC_RecordChild1,
    OPC_Scope, 44, 
     OPC_CheckChild1Type, 12, 
     OPC_Scope, 21, 
      OPC_RecordChild2,
      OPC_MoveChild2,
      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
      OPC_CheckPredicate, 11,
      OPC_CheckTypeI32,
      OPC_MoveParent,
      OPC_CheckType, 111, 
      OPC_CheckPatternPredicate0,
      OPC_EmitConvertToTarget2,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_F32x4),
                    111, 3, 0, 3, 1, 
     17, 
      OPC_MoveChild2,
      OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
      OPC_MoveParent,
      OPC_CheckType, 111, 
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_F32x4),
                    111, 3, 0, 2, 1, 
     0, 
    48, 
     OPC_CheckChild1Type, 13, 
     OPC_Scope, 23, 
      OPC_RecordChild2,
      OPC_MoveChild2,
      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
      OPC_CheckPredicate, 12,
      OPC_CheckTypeI32,
      OPC_MoveParent,
      OPC_CheckType, 1|128,1, 
      OPC_CheckPatternPredicate0,
      OPC_EmitConvertToTarget2,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_F64x2),
                    1|128,1, 3, 0, 3, 1, 
     19, 
      OPC_MoveChild2,
      OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
      OPC_MoveParent,
      OPC_CheckType, 1|128,1, 
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_F64x2),
                    1|128,1, 3, 0, 2, 1, 
     0, 
    0, 
   0, 
  0, 
 96|128,1, TARGET_VAL(WebAssemblyISD::VEC_SHR_U),
  OPC_Scope, 87, 
   OPC_MoveChild0,
   OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
   OPC_MoveChild0,
   OPC_SwitchOpcode , 37, TARGET_VAL(ISD::ADD),
    OPC_RecordChild0,
    OPC_RecordChild1,
    OPC_CheckPredicate, 24,
    OPC_MoveSibling1,
    OPC_CheckOpcode, TARGET_VAL(ISD::SPLAT_VECTOR),
    OPC_CheckChild0Integer, 2, 
    OPC_CheckChild0TypeI32,
    OPC_MoveParent,
    OPC_CheckPredicate, 24,
    OPC_MoveParent,
    OPC_CheckChild1Integer, 2, 
    OPC_SwitchType , 7, 39, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AVGR_U_I8x16),
                   39, 2, 0, 1, 
    7, 50, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AVGR_U_I16x8),
                   50, 2, 0, 1, 
    0,
   37, TARGET_VAL(ISD::SPLAT_VECTOR),
    OPC_CheckChild0Integer, 2, 
    OPC_CheckChild0TypeI32,
    OPC_MoveSibling1,
    OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
    OPC_RecordChild0,
    OPC_RecordChild1,
    OPC_CheckPredicate, 24,
    OPC_MoveParent,
    OPC_CheckPredicate, 24,
    OPC_MoveParent,
    OPC_CheckChild1Integer, 2, 
    OPC_SwitchType , 7, 39, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AVGR_U_I8x16),
                   39, 2, 0, 1, 
    7, 50, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AVGR_U_I16x8),
                   50, 2, 0, 1, 
    0,
   0,
  4|128,1, 
   OPC_RecordChild0,
   OPC_Scope, 84, 
    OPC_MoveChild1,
    OPC_Scope, 24, 
     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
     OPC_MoveChild0,
     OPC_CheckAndImm, 63, 
     OPC_RecordChild0,
     OPC_MoveParent,
     OPC_MoveParent,
     OPC_CheckType, 78, 
     OPC_EmitNode1None, TARGET_VAL(WebAssembly::I32_WRAP_I64),
                   7, 1, 1, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I64x2),
                   78, 2, 0, 2, 
    13, 
     OPC_CheckAndImm, 7, 
     OPC_RecordChild0,
     OPC_MoveParent,
     OPC_CheckType, 39, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I8x16),
                   39, 2, 0, 1, 
    13, 
     OPC_CheckAndImm, 15, 
     OPC_RecordChild0,
     OPC_MoveParent,
     OPC_CheckType, 50, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I16x8),
                   50, 2, 0, 1, 
    13, 
     OPC_CheckAndImm, 31, 
     OPC_RecordChild0,
     OPC_MoveParent,
     OPC_CheckType, 60, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I32x4),
                   60, 2, 0, 1, 
    13, 
     OPC_CheckAndImm, 63, 
     OPC_RecordChild0,
     OPC_MoveParent,
     OPC_CheckType, 78, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I64x2),
                   78, 2, 0, 1, 
    0, 
   43, 
    OPC_RecordChild1,
    OPC_SwitchType , 8, 39, 
     OPC_CheckPatternPredicate0,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I8x16),
                   39, 2, 0, 1, 
    8, 50, 
     OPC_CheckPatternPredicate0,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I16x8),
                   50, 2, 0, 1, 
    8, 60, 
     OPC_CheckPatternPredicate0,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I32x4),
                   60, 2, 0, 1, 
    8, 78, 
     OPC_CheckPatternPredicate0,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I64x2),
                   78, 2, 0, 1, 
    0,
   0, 
  0, 
 22|128,4, TARGET_VAL(ISD::SPLAT_VECTOR),
  OPC_Scope, 73|128,1, 
   OPC_MoveChild0,
   OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
   OPC_RecordMemRef,
   OPC_RecordNode,
   OPC_RecordChild1,
   OPC_Scope, 95, 
    OPC_CheckChild1TypeI32,
    OPC_CheckPredicate, 8,
    OPC_Scope, 45, 
     OPC_CheckPredicate, 10,
     OPC_CheckTypeI32,
     OPC_Scope, 19, 
      OPC_CheckPredicate1, 
      OPC_MoveParent,
      OPC_CheckType, 39, 
      OPC_CheckPatternPredicate1,
      OPC_CheckComplexPat0, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    39, 3, 4, 2, 3, 
     19, 
      OPC_CheckPredicate2, 
      OPC_MoveParent,
      OPC_CheckType, 50, 
      OPC_CheckPatternPredicate1,
      OPC_CheckComplexPat0, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    50, 3, 4, 2, 3, 
     0, 
    43, 
     OPC_CheckPredicate6, 
     OPC_SwitchType , 18, 7, 
      OPC_MoveParent,
      OPC_CheckType, 60, 
      OPC_CheckPatternPredicate1,
      OPC_CheckComplexPat0, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    60, 3, 4, 2, 3, 
     18, 8, 
      OPC_MoveParent,
      OPC_CheckType, 78, 
      OPC_CheckPatternPredicate1,
      OPC_CheckComplexPat0, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    78, 3, 4, 2, 3, 
     0,
    0, 
   95, 
    OPC_CheckChild1TypeI64,
    OPC_CheckPredicate, 8,
    OPC_Scope, 45, 
     OPC_CheckPredicate, 10,
     OPC_CheckTypeI32,
     OPC_Scope, 19, 
      OPC_CheckPredicate1, 
      OPC_MoveParent,
      OPC_CheckType, 39, 
      OPC_CheckPatternPredicate2,
      OPC_CheckComplexPat1, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    39, 3, 4, 2, 3, 
     19, 
      OPC_CheckPredicate2, 
      OPC_MoveParent,
      OPC_CheckType, 50, 
      OPC_CheckPatternPredicate2,
      OPC_CheckComplexPat1, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    50, 3, 4, 2, 3, 
     0, 
    43, 
     OPC_CheckPredicate6, 
     OPC_SwitchType , 18, 7, 
      OPC_MoveParent,
      OPC_CheckType, 60, 
      OPC_CheckPatternPredicate2,
      OPC_CheckComplexPat1, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    60, 3, 4, 2, 3, 
     18, 8, 
      OPC_MoveParent,
      OPC_CheckType, 78, 
      OPC_CheckPatternPredicate2,
      OPC_CheckComplexPat1, /*#*/1,
      OPC_EmitMergeInputChains1_0,
      OPC_EmitInteger32, 0, 
      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    78, 3, 4, 2, 3, 
     0,
    0, 
   0, 
  20|128,1, 
   OPC_RecordChild0,
   OPC_Scope, 102, 
    OPC_MoveChild0,
    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
    OPC_SwitchType , 80, 7, 
     OPC_MoveParent,
     OPC_SwitchType , 37, 39, 
      OPC_EmitConvertToTarget0,
      OPC_EmitConvertToTarget0,
      OPC_EmitConvertToTarget0,
      OPC_EmitConvertToTarget0,
      OPC_EmitConvertToTarget0,
      OPC_EmitConvertToTarget0,
      OPC_EmitConvertToTarget0,
      OPC_EmitConvertToTarget0,
      OPC_EmitConvertToTarget0,
      OPC_EmitConvertToTarget0,
      OPC_EmitConvertToTarget0,
      OPC_EmitConvertToTarget0,
      OPC_EmitConvertToTarget0,
      OPC_EmitConvertToTarget0,
      OPC_EmitConvertToTarget0,
      OPC_EmitConvertToTarget0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I8x16),
                    39, 16, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 
     21, 50, 
      OPC_EmitConvertToTarget0,
      OPC_EmitConvertToTarget0,
      OPC_EmitConvertToTarget0,
      OPC_EmitConvertToTarget0,
      OPC_EmitConvertToTarget0,
      OPC_EmitConvertToTarget0,
      OPC_EmitConvertToTarget0,
      OPC_EmitConvertToTarget0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I16x8),
                    50, 8, 1, 2, 3, 4, 5, 6, 7, 8, 
     13, 60, 
      OPC_EmitConvertToTarget0,
      OPC_EmitConvertToTarget0,
      OPC_EmitConvertToTarget0,
      OPC_EmitConvertToTarget0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I32x4),
                    60, 4, 1, 2, 3, 4, 
     0,
    12, 8, 
     OPC_MoveParent,
     OPC_CheckType, 78, 
     OPC_EmitConvertToTarget0,
     OPC_EmitConvertToTarget0,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I64x2),
                   78, 2, 1, 2, 
    0,
   30, 
    OPC_CheckChild0TypeI32,
    OPC_SwitchType , 7, 39, 
     OPC_CheckPatternPredicate0,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I8x16),
                   39, 1, 0, 
    7, 50, 
     OPC_CheckPatternPredicate0,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I16x8),
                   50, 1, 0, 
    7, 60, 
     OPC_CheckPatternPredicate0,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I32x4),
                   60, 1, 0, 
    0,
   10, 
    OPC_CheckChild0TypeI64,
    OPC_CheckType, 78, 
    OPC_CheckPatternPredicate0,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I64x2),
                  78, 1, 0, 
   0, 
  107, 
   OPC_MoveChild0,
   OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
   OPC_RecordMemRef,
   OPC_RecordNode,
   OPC_RecordChild1,
   OPC_Scope, 48, 
    OPC_CheckChild1TypeI32,
    OPC_CheckPredicate, 8,
    OPC_CheckPredicate6, 
    OPC_SwitchType , 18, 12, 
     OPC_MoveParent,
     OPC_CheckType, 111, 
     OPC_CheckPatternPredicate1,
     OPC_CheckComplexPat0, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   111, 3, 4, 2, 3, 
    20, 13, 
     OPC_MoveParent,
     OPC_CheckType, 1|128,1, 
     OPC_CheckPatternPredicate1,
     OPC_CheckComplexPat0, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   1|128,1, 3, 4, 2, 3, 
    0,
   48, 
    OPC_CheckChild1TypeI64,
    OPC_CheckPredicate, 8,
    OPC_CheckPredicate6, 
    OPC_SwitchType , 18, 12, 
     OPC_MoveParent,
     OPC_CheckType, 111, 
     OPC_CheckPatternPredicate2,
     OPC_CheckComplexPat1, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   111, 3, 4, 2, 3, 
    20, 13, 
     OPC_MoveParent,
     OPC_CheckType, 1|128,1, 
     OPC_CheckPatternPredicate2,
     OPC_CheckComplexPat1, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   1|128,1, 3, 4, 2, 3, 
    0,
   0, 
  70, 
   OPC_RecordChild0,
   OPC_Scope, 40, 
    OPC_MoveChild0,
    OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
    OPC_SwitchType , 16, 12, 
     OPC_MoveParent,
     OPC_CheckType, 111, 
     OPC_EmitConvertToTarget0,
     OPC_EmitConvertToTarget0,
     OPC_EmitConvertToTarget0,
     OPC_EmitConvertToTarget0,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_F32x4),
                   111, 4, 1, 2, 3, 4, 
    14, 13, 
     OPC_MoveParent,
     OPC_CheckType, 1|128,1, 
     OPC_EmitConvertToTarget0,
     OPC_EmitConvertToTarget0,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_F64x2),
                   1|128,1, 2, 1, 2, 
    0,
   11, 
    OPC_CheckChild0Type, 12, 
    OPC_CheckType, 111, 
    OPC_CheckPatternPredicate0,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_F32x4),
                  111, 1, 0, 
   13, 
    OPC_CheckChild0Type, 13, 
    OPC_CheckType, 1|128,1, 
    OPC_CheckPatternPredicate0,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_F64x2),
                  1|128,1, 1, 0, 
   0, 
  0, 
 26|128,2, TARGET_VAL(ISD::SCALAR_TO_VECTOR),
  OPC_Scope, 103, 
   OPC_MoveChild0,
   OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
   OPC_RecordMemRef,
   OPC_RecordNode,
   OPC_RecordChild1,
   OPC_Scope, 46, 
    OPC_CheckChild1TypeI32,
    OPC_CheckPredicate, 8,
    OPC_CheckPredicate6, 
    OPC_SwitchType , 18, 7, 
     OPC_MoveParent,
     OPC_CheckType, 60, 
     OPC_CheckPatternPredicate1,
     OPC_CheckComplexPat0, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   60, 3, 4, 2, 3, 
    18, 8, 
     OPC_MoveParent,
     OPC_CheckType, 78, 
     OPC_CheckPatternPredicate1,
     OPC_CheckComplexPat0, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   78, 3, 4, 2, 3, 
    0,
   46, 
    OPC_CheckChild1TypeI64,
    OPC_CheckPredicate, 8,
    OPC_CheckPredicate6, 
    OPC_SwitchType , 18, 7, 
     OPC_MoveParent,
     OPC_CheckType, 60, 
     OPC_CheckPatternPredicate2,
     OPC_CheckComplexPat1, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   60, 3, 4, 2, 3, 
    18, 8, 
     OPC_MoveParent,
     OPC_CheckType, 78, 
     OPC_CheckPatternPredicate2,
     OPC_CheckComplexPat1, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   78, 3, 4, 2, 3, 
    0,
   0, 
  41, 
   OPC_RecordChild0,
   OPC_Scope, 27, 
    OPC_CheckChild0TypeI32,
    OPC_SwitchType , 6, 39, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I8x16),
                   39, 1, 0, 
    6, 50, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I16x8),
                   50, 1, 0, 
    6, 60, 
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I32x4),
                   60, 1, 0, 
    0,
   9, 
    OPC_CheckChild0TypeI64,
    OPC_CheckType, 78, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I64x2),
                  78, 1, 0, 
   0, 
  107, 
   OPC_MoveChild0,
   OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
   OPC_RecordMemRef,
   OPC_RecordNode,
   OPC_RecordChild1,
   OPC_Scope, 48, 
    OPC_CheckChild1TypeI32,
    OPC_CheckPredicate, 8,
    OPC_CheckPredicate6, 
    OPC_SwitchType , 18, 12, 
     OPC_MoveParent,
     OPC_CheckType, 111, 
     OPC_CheckPatternPredicate1,
     OPC_CheckComplexPat0, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   111, 3, 4, 2, 3, 
    20, 13, 
     OPC_MoveParent,
     OPC_CheckType, 1|128,1, 
     OPC_CheckPatternPredicate1,
     OPC_CheckComplexPat0, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   1|128,1, 3, 4, 2, 3, 
    0,
   48, 
    OPC_CheckChild1TypeI64,
    OPC_CheckPredicate, 8,
    OPC_CheckPredicate6, 
    OPC_SwitchType , 18, 12, 
     OPC_MoveParent,
     OPC_CheckType, 111, 
     OPC_CheckPatternPredicate2,
     OPC_CheckComplexPat1, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   111, 3, 4, 2, 3, 
    20, 13, 
     OPC_MoveParent,
     OPC_CheckType, 1|128,1, 
     OPC_CheckPatternPredicate2,
     OPC_CheckComplexPat1, /*#*/1,
     OPC_EmitMergeInputChains1_0,
     OPC_EmitInteger32, 0, 
     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   1|128,1, 3, 4, 2, 3, 
    0,
   0, 
  25, 
   OPC_RecordChild0,
   OPC_SwitchType , 8, 111, 
    OPC_CheckChild0Type, 12, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_F32x4),
                  111, 1, 0, 
   9, 1|128,1, 
    OPC_CheckChild0Type, 13, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_F64x2),
                  1|128,1, 1, 0, 
   0,
  0, 
 4|128,1, TARGET_VAL(WebAssemblyISD::VEC_SHL),
  OPC_RecordChild0,
  OPC_Scope, 84, 
   OPC_MoveChild1,
   OPC_Scope, 24, 
    OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
    OPC_MoveChild0,
    OPC_CheckAndImm, 63, 
    OPC_RecordChild0,
    OPC_MoveParent,
    OPC_MoveParent,
    OPC_CheckType, 78, 
    OPC_EmitNode1None, TARGET_VAL(WebAssembly::I32_WRAP_I64),
                  7, 1, 1, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I64x2),
                  78, 2, 0, 2, 
   13, 
    OPC_CheckAndImm, 7, 
    OPC_RecordChild0,
    OPC_MoveParent,
    OPC_CheckType, 39, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I8x16),
                  39, 2, 0, 1, 
   13, 
    OPC_CheckAndImm, 15, 
    OPC_RecordChild0,
    OPC_MoveParent,
    OPC_CheckType, 50, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I16x8),
                  50, 2, 0, 1, 
   13, 
    OPC_CheckAndImm, 31, 
    OPC_RecordChild0,
    OPC_MoveParent,
    OPC_CheckType, 60, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I32x4),
                  60, 2, 0, 1, 
   13, 
    OPC_CheckAndImm, 63, 
    OPC_RecordChild0,
    OPC_MoveParent,
    OPC_CheckType, 78, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I64x2),
                  78, 2, 0, 1, 
   0, 
  43, 
   OPC_RecordChild1,
   OPC_SwitchType , 8, 39, 
    OPC_CheckPatternPredicate0,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I8x16),
                  39, 2, 0, 1, 
   8, 50, 
    OPC_CheckPatternPredicate0,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I16x8),
                  50, 2, 0, 1, 
   8, 60, 
    OPC_CheckPatternPredicate0,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I32x4),
                  60, 2, 0, 1, 
   8, 78, 
    OPC_CheckPatternPredicate0,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I64x2),
                  78, 2, 0, 1, 
   0,
  0, 
 4|128,1, TARGET_VAL(WebAssemblyISD::VEC_SHR_S),
  OPC_RecordChild0,
  OPC_Scope, 84, 
   OPC_MoveChild1,
   OPC_Scope, 24, 
    OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
    OPC_MoveChild0,
    OPC_CheckAndImm, 63, 
    OPC_RecordChild0,
    OPC_MoveParent,
    OPC_MoveParent,
    OPC_CheckType, 78, 
    OPC_EmitNode1None, TARGET_VAL(WebAssembly::I32_WRAP_I64),
                  7, 1, 1, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I64x2),
                  78, 2, 0, 2, 
   13, 
    OPC_CheckAndImm, 7, 
    OPC_RecordChild0,
    OPC_MoveParent,
    OPC_CheckType, 39, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I8x16),
                  39, 2, 0, 1, 
   13, 
    OPC_CheckAndImm, 15, 
    OPC_RecordChild0,
    OPC_MoveParent,
    OPC_CheckType, 50, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I16x8),
                  50, 2, 0, 1, 
   13, 
    OPC_CheckAndImm, 31, 
    OPC_RecordChild0,
    OPC_MoveParent,
    OPC_CheckType, 60, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I32x4),
                  60, 2, 0, 1, 
   13, 
    OPC_CheckAndImm, 63, 
    OPC_RecordChild0,
    OPC_MoveParent,
    OPC_CheckType, 78, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I64x2),
                  78, 2, 0, 1, 
   0, 
  43, 
   OPC_RecordChild1,
   OPC_SwitchType , 8, 39, 
    OPC_CheckPatternPredicate0,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I8x16),
                  39, 2, 0, 1, 
   8, 50, 
    OPC_CheckPatternPredicate0,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I16x8),
                  50, 2, 0, 1, 
   8, 60, 
    OPC_CheckPatternPredicate0,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I32x4),
                  60, 2, 0, 1, 
   8, 78, 
    OPC_CheckPatternPredicate0,
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I64x2),
                  78, 2, 0, 1, 
   0,
  0, 
 66|128,8, TARGET_VAL(ISD::VSELECT),
  OPC_Scope, 13|128,1, 
   OPC_MoveChild0,
   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
   OPC_MoveChild0,
   OPC_CheckOpcode, TARGET_VAL(ISD::BITCAST),
   OPC_RecordChild0,
   OPC_SwitchType , 41, 111, 
    OPC_CheckChild0Type, 60, 
    OPC_MoveSibling1,
    OPC_CheckOpcode, TARGET_VAL(ISD::BITCAST),
    OPC_RecordChild0,
    OPC_CheckChild0Type, 60, 
    OPC_MoveParent,
    OPC_CheckChild2CondCode, ISD::SETOLT,
    OPC_MoveParent,
    OPC_CheckType, 60, 
    OPC_Scope, 11, 
     OPC_CheckChild1Same, 0,
     OPC_CheckChild2Same, 1,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                   60, 2, 1, 0, 
    11, 
     OPC_CheckChild1Same, 1,
     OPC_CheckChild2Same, 0,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                   60, 2, 0, 1, 
    0, 
   41, 1|128,1, 
    OPC_CheckChild0Type, 78, 
    OPC_MoveSibling1,
    OPC_CheckOpcode, TARGET_VAL(ISD::BITCAST),
    OPC_RecordChild0,
    OPC_CheckChild0Type, 78, 
    OPC_MoveParent,
    OPC_CheckChild2CondCode, ISD::SETOLT,
    OPC_MoveParent,
    OPC_CheckType, 78, 
    OPC_Scope, 11, 
     OPC_CheckChild1Same, 0,
     OPC_CheckChild2Same, 1,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                   78, 2, 1, 0, 
    11, 
     OPC_CheckChild1Same, 1,
     OPC_CheckChild2Same, 0,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                   78, 2, 0, 1, 
    0, 
   41, 92, 
    OPC_CheckChild0Type, 50, 
    OPC_MoveSibling1,
    OPC_CheckOpcode, TARGET_VAL(ISD::BITCAST),
    OPC_RecordChild0,
    OPC_CheckChild0Type, 50, 
    OPC_MoveParent,
    OPC_CheckChild2CondCode, ISD::SETOLT,
    OPC_MoveParent,
    OPC_CheckType, 50, 
    OPC_Scope, 11, 
     OPC_CheckChild1Same, 0,
     OPC_CheckChild2Same, 1,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                   50, 2, 1, 0, 
    11, 
     OPC_CheckChild1Same, 1,
     OPC_CheckChild2Same, 0,
     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                   50, 2, 0, 1, 
    0, 
   0,
  45, 
   OPC_RecordChild0,
   OPC_RecordChild1,
   OPC_RecordChild2,
   OPC_SwitchType , 8, 39, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  39, 3, 1, 2, 0, 
   8, 50, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  50, 3, 1, 2, 0, 
   8, 60, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  60, 3, 1, 2, 0, 
   8, 78, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  78, 3, 1, 2, 0, 
   0,
  101|128,6, 
   OPC_MoveChild0,
   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
   OPC_RecordChild0,
   OPC_Scope, 21|128,2, 
    OPC_CheckChild0Type, 111, 
    OPC_RecordChild1,
    OPC_Scope, 33, 
     OPC_CheckChild2CondCode, ISD::SETOLT,
     OPC_MoveParent,
     OPC_CheckType, 111, 
     OPC_Scope, 12, 
      OPC_CheckChild1Same, 0,
      OPC_CheckChild2Same, 1,
      OPC_CheckPatternPredicate0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                    111, 2, 1, 0, 
     12, 
      OPC_CheckChild1Same, 1,
      OPC_CheckChild2Same, 0,
      OPC_CheckPatternPredicate0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                    111, 2, 0, 1, 
     0, 
    33, 
     OPC_CheckChild2CondCode, ISD::SETOLE,
     OPC_MoveParent,
     OPC_CheckType, 111, 
     OPC_Scope, 12, 
      OPC_CheckChild1Same, 0,
      OPC_CheckChild2Same, 1,
      OPC_CheckPatternPredicate0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                    111, 2, 1, 0, 
     12, 
      OPC_CheckChild1Same, 1,
      OPC_CheckChild2Same, 0,
      OPC_CheckPatternPredicate0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                    111, 2, 0, 1, 
     0, 
    33, 
     OPC_CheckChild2CondCode, ISD::SETOGT,
     OPC_MoveParent,
     OPC_CheckType, 111, 
     OPC_Scope, 12, 
      OPC_CheckChild1Same, 1,
      OPC_CheckChild2Same, 0,
      OPC_CheckPatternPredicate0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                    111, 2, 0, 1, 
     12, 
      OPC_CheckChild1Same, 0,
      OPC_CheckChild2Same, 1,
      OPC_CheckPatternPredicate0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                    111, 2, 1, 0, 
     0, 
    33, 
     OPC_CheckChild2CondCode, ISD::SETOGE,
     OPC_MoveParent,
     OPC_CheckType, 111, 
     OPC_Scope, 12, 
      OPC_CheckChild1Same, 1,
      OPC_CheckChild2Same, 0,
      OPC_CheckPatternPredicate0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                    111, 2, 0, 1, 
     12, 
      OPC_CheckChild1Same, 0,
      OPC_CheckChild2Same, 1,
      OPC_CheckPatternPredicate0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                    111, 2, 1, 0, 
     0, 
    33, 
     OPC_CheckChild2CondCode, ISD::SETLT,
     OPC_MoveParent,
     OPC_CheckType, 111, 
     OPC_Scope, 12, 
      OPC_CheckChild1Same, 0,
      OPC_CheckChild2Same, 1,
      OPC_CheckPatternPredicate0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                    111, 2, 0, 1, 
     12, 
      OPC_CheckChild1Same, 1,
      OPC_CheckChild2Same, 0,
      OPC_CheckPatternPredicate0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                    111, 2, 0, 1, 
     0, 
    33, 
     OPC_CheckChild2CondCode, ISD::SETLE,
     OPC_MoveParent,
     OPC_CheckType, 111, 
     OPC_Scope, 12, 
      OPC_CheckChild1Same, 0,
      OPC_CheckChild2Same, 1,
      OPC_CheckPatternPredicate0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                    111, 2, 0, 1, 
     12, 
      OPC_CheckChild1Same, 1,
      OPC_CheckChild2Same, 0,
      OPC_CheckPatternPredicate0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                    111, 2, 0, 1, 
     0, 
    33, 
     OPC_CheckChild2CondCode, ISD::SETGT,
     OPC_MoveParent,
     OPC_CheckType, 111, 
     OPC_Scope, 12, 
      OPC_CheckChild1Same, 1,
      OPC_CheckChild2Same, 0,
      OPC_CheckPatternPredicate0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                    111, 2, 0, 1, 
     12, 
      OPC_CheckChild1Same, 0,
      OPC_CheckChild2Same, 1,
      OPC_CheckPatternPredicate0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                    111, 2, 0, 1, 
     0, 
    33, 
     OPC_CheckChild2CondCode, ISD::SETGE,
     OPC_MoveParent,
     OPC_CheckType, 111, 
     OPC_Scope, 12, 
      OPC_CheckChild1Same, 1,
      OPC_CheckChild2Same, 0,
      OPC_CheckPatternPredicate0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                    111, 2, 0, 1, 
     12, 
      OPC_CheckChild1Same, 0,
      OPC_CheckChild2Same, 1,
      OPC_CheckPatternPredicate0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                    111, 2, 0, 1, 
     0, 
    0, 
   46|128,2, 
    OPC_CheckChild0Type, 1|128,1, 
    OPC_RecordChild1,
    OPC_Scope, 36, 
     OPC_CheckChild2CondCode, ISD::SETOLT,
     OPC_MoveParent,
     OPC_CheckType, 1|128,1, 
     OPC_Scope, 13, 
      OPC_CheckChild1Same, 0,
      OPC_CheckChild2Same, 1,
      OPC_CheckPatternPredicate0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                    1|128,1, 2, 1, 0, 
     13, 
      OPC_CheckChild1Same, 1,
      OPC_CheckChild2Same, 0,
      OPC_CheckPatternPredicate0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                    1|128,1, 2, 0, 1, 
     0, 
    36, 
     OPC_CheckChild2CondCode, ISD::SETOLE,
     OPC_MoveParent,
     OPC_CheckType, 1|128,1, 
     OPC_Scope, 13, 
      OPC_CheckChild1Same, 0,
      OPC_CheckChild2Same, 1,
      OPC_CheckPatternPredicate0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                    1|128,1, 2, 1, 0, 
     13, 
      OPC_CheckChild1Same, 1,
      OPC_CheckChild2Same, 0,
      OPC_CheckPatternPredicate0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                    1|128,1, 2, 0, 1, 
     0, 
    36, 
     OPC_CheckChild2CondCode, ISD::SETOGT,
     OPC_MoveParent,
     OPC_CheckType, 1|128,1, 
     OPC_Scope, 13, 
      OPC_CheckChild1Same, 1,
      OPC_CheckChild2Same, 0,
      OPC_CheckPatternPredicate0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                    1|128,1, 2, 0, 1, 
     13, 
      OPC_CheckChild1Same, 0,
      OPC_CheckChild2Same, 1,
      OPC_CheckPatternPredicate0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                    1|128,1, 2, 1, 0, 
     0, 
    36, 
     OPC_CheckChild2CondCode, ISD::SETOGE,
     OPC_MoveParent,
     OPC_CheckType, 1|128,1, 
     OPC_Scope, 13, 
      OPC_CheckChild1Same, 1,
      OPC_CheckChild2Same, 0,
      OPC_CheckPatternPredicate0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                    1|128,1, 2, 0, 1, 
     13, 
      OPC_CheckChild1Same, 0,
      OPC_CheckChild2Same, 1,
      OPC_CheckPatternPredicate0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                    1|128,1, 2, 1, 0, 
     0, 
    36, 
     OPC_CheckChild2CondCode, ISD::SETLT,
     OPC_MoveParent,
     OPC_CheckType, 1|128,1, 
     OPC_Scope, 13, 
      OPC_CheckChild1Same, 0,
      OPC_CheckChild2Same, 1,
      OPC_CheckPatternPredicate0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                    1|128,1, 2, 0, 1, 
     13, 
      OPC_CheckChild1Same, 1,
      OPC_CheckChild2Same, 0,
      OPC_CheckPatternPredicate0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                    1|128,1, 2, 0, 1, 
     0, 
    36, 
     OPC_CheckChild2CondCode, ISD::SETLE,
     OPC_MoveParent,
     OPC_CheckType, 1|128,1, 
     OPC_Scope, 13, 
      OPC_CheckChild1Same, 0,
      OPC_CheckChild2Same, 1,
      OPC_CheckPatternPredicate0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                    1|128,1, 2, 0, 1, 
     13, 
      OPC_CheckChild1Same, 1,
      OPC_CheckChild2Same, 0,
      OPC_CheckPatternPredicate0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                    1|128,1, 2, 0, 1, 
     0, 
    36, 
     OPC_CheckChild2CondCode, ISD::SETGT,
     OPC_MoveParent,
     OPC_CheckType, 1|128,1, 
     OPC_Scope, 13, 
      OPC_CheckChild1Same, 1,
      OPC_CheckChild2Same, 0,
      OPC_CheckPatternPredicate0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                    1|128,1, 2, 0, 1, 
     13, 
      OPC_CheckChild1Same, 0,
      OPC_CheckChild2Same, 1,
      OPC_CheckPatternPredicate0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                    1|128,1, 2, 0, 1, 
     0, 
    36, 
     OPC_CheckChild2CondCode, ISD::SETGE,
     OPC_MoveParent,
     OPC_CheckType, 1|128,1, 
     OPC_Scope, 13, 
      OPC_CheckChild1Same, 1,
      OPC_CheckChild2Same, 0,
      OPC_CheckPatternPredicate0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                    1|128,1, 2, 0, 1, 
     13, 
      OPC_CheckChild1Same, 0,
      OPC_CheckChild2Same, 1,
      OPC_CheckPatternPredicate0,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                    1|128,1, 2, 0, 1, 
     0, 
    0, 
   21|128,2, 
    OPC_CheckChild0Type, 92, 
    OPC_RecordChild1,
    OPC_Scope, 33, 
     OPC_CheckChild2CondCode, ISD::SETOLT,
     OPC_MoveParent,
     OPC_CheckType, 92, 
     OPC_Scope, 12, 
      OPC_CheckChild1Same, 0,
      OPC_CheckChild2Same, 1,
      OPC_CheckPatternPredicate5,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                    92, 2, 1, 0, 
     12, 
      OPC_CheckChild1Same, 1,
      OPC_CheckChild2Same, 0,
      OPC_CheckPatternPredicate5,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                    92, 2, 0, 1, 
     0, 
    33, 
     OPC_CheckChild2CondCode, ISD::SETOLE,
     OPC_MoveParent,
     OPC_CheckType, 92, 
     OPC_Scope, 12, 
      OPC_CheckChild1Same, 0,
      OPC_CheckChild2Same, 1,
      OPC_CheckPatternPredicate5,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                    92, 2, 1, 0, 
     12, 
      OPC_CheckChild1Same, 1,
      OPC_CheckChild2Same, 0,
      OPC_CheckPatternPredicate5,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                    92, 2, 0, 1, 
     0, 
    33, 
     OPC_CheckChild2CondCode, ISD::SETOGT,
     OPC_MoveParent,
     OPC_CheckType, 92, 
     OPC_Scope, 12, 
      OPC_CheckChild1Same, 1,
      OPC_CheckChild2Same, 0,
      OPC_CheckPatternPredicate5,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                    92, 2, 0, 1, 
     12, 
      OPC_CheckChild1Same, 0,
      OPC_CheckChild2Same, 1,
      OPC_CheckPatternPredicate5,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                    92, 2, 1, 0, 
     0, 
    33, 
     OPC_CheckChild2CondCode, ISD::SETOGE,
     OPC_MoveParent,
     OPC_CheckType, 92, 
     OPC_Scope, 12, 
      OPC_CheckChild1Same, 1,
      OPC_CheckChild2Same, 0,
      OPC_CheckPatternPredicate5,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                    92, 2, 0, 1, 
     12, 
      OPC_CheckChild1Same, 0,
      OPC_CheckChild2Same, 1,
      OPC_CheckPatternPredicate5,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                    92, 2, 1, 0, 
     0, 
    33, 
     OPC_CheckChild2CondCode, ISD::SETLT,
     OPC_MoveParent,
     OPC_CheckType, 92, 
     OPC_Scope, 12, 
      OPC_CheckChild1Same, 0,
      OPC_CheckChild2Same, 1,
      OPC_CheckPatternPredicate5,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                    92, 2, 0, 1, 
     12, 
      OPC_CheckChild1Same, 1,
      OPC_CheckChild2Same, 0,
      OPC_CheckPatternPredicate5,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                    92, 2, 0, 1, 
     0, 
    33, 
     OPC_CheckChild2CondCode, ISD::SETLE,
     OPC_MoveParent,
     OPC_CheckType, 92, 
     OPC_Scope, 12, 
      OPC_CheckChild1Same, 0,
      OPC_CheckChild2Same, 1,
      OPC_CheckPatternPredicate5,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                    92, 2, 0, 1, 
     12, 
      OPC_CheckChild1Same, 1,
      OPC_CheckChild2Same, 0,
      OPC_CheckPatternPredicate5,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                    92, 2, 0, 1, 
     0, 
    33, 
     OPC_CheckChild2CondCode, ISD::SETGT,
     OPC_MoveParent,
     OPC_CheckType, 92, 
     OPC_Scope, 12, 
      OPC_CheckChild1Same, 1,
      OPC_CheckChild2Same, 0,
      OPC_CheckPatternPredicate5,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                    92, 2, 0, 1, 
     12, 
      OPC_CheckChild1Same, 0,
      OPC_CheckChild2Same, 1,
      OPC_CheckPatternPredicate5,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                    92, 2, 0, 1, 
     0, 
    33, 
     OPC_CheckChild2CondCode, ISD::SETGE,
     OPC_MoveParent,
     OPC_CheckType, 92, 
     OPC_Scope, 12, 
      OPC_CheckChild1Same, 1,
      OPC_CheckChild2Same, 0,
      OPC_CheckPatternPredicate5,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                    92, 2, 0, 1, 
     12, 
      OPC_CheckChild1Same, 0,
      OPC_CheckChild2Same, 1,
      OPC_CheckPatternPredicate5,
      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                    92, 2, 0, 1, 
     0, 
    0, 
   0, 
  27, 
   OPC_RecordChild0,
   OPC_RecordChild1,
   OPC_RecordChild2,
   OPC_SwitchType , 8, 111, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  111, 3, 1, 2, 0, 
   9, 1|128,1, 
    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  1|128,1, 3, 1, 2, 0, 
   0,
  0, 
 16, TARGET_VAL(WebAssemblyISD::SWIZZLE),
  OPC_RecordChild0,
  OPC_CheckChild0Type, 39, 
  OPC_RecordChild1,
  OPC_CheckChild1Type, 39, 
  OPC_CheckType, 39, 
  OPC_CheckPatternPredicate0,
  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SWIZZLE),
                39, 2, 0, 1, 
 39, TARGET_VAL(ISD::ABS),
  OPC_RecordChild0,
  OPC_SwitchType , 7, 39, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_I8x16),
                 39, 1, 0, 
  7, 50, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_I16x8),
                 50, 1, 0, 
  7, 60, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_I32x4),
                 60, 1, 0, 
  7, 78, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_I64x2),
                 78, 1, 0, 
  0,
 24, TARGET_VAL(ISD::SADDSAT),
  OPC_RecordChild0,
  OPC_RecordChild1,
  OPC_SwitchType , 8, 39, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_SAT_S_I8x16),
                 39, 2, 0, 1, 
  8, 50, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_SAT_S_I16x8),
                 50, 2, 0, 1, 
  0,
 24, TARGET_VAL(ISD::UADDSAT),
  OPC_RecordChild0,
  OPC_RecordChild1,
  OPC_SwitchType , 8, 39, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_SAT_U_I8x16),
                 39, 2, 0, 1, 
  8, 50, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_SAT_U_I16x8),
                 50, 2, 0, 1, 
  0,
 24, TARGET_VAL(ISD::SSUBSAT),
  OPC_RecordChild0,
  OPC_RecordChild1,
  OPC_SwitchType , 8, 39, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_SAT_S_I8x16),
                 39, 2, 0, 1, 
  8, 50, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_SAT_S_I16x8),
                 50, 2, 0, 1, 
  0,
 24, TARGET_VAL(ISD::USUBSAT),
  OPC_RecordChild0,
  OPC_RecordChild1,
  OPC_SwitchType , 8, 39, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_SAT_U_I8x16),
                 39, 2, 0, 1, 
  8, 50, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_SAT_U_I16x8),
                 50, 2, 0, 1, 
  0,
 34, TARGET_VAL(ISD::SMIN),
  OPC_RecordChild0,
  OPC_RecordChild1,
  OPC_SwitchType , 8, 39, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_S_I8x16),
                 39, 2, 0, 1, 
  8, 50, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_S_I16x8),
                 50, 2, 0, 1, 
  8, 60, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_S_I32x4),
                 60, 2, 0, 1, 
  0,
 34, TARGET_VAL(ISD::UMIN),
  OPC_RecordChild0,
  OPC_RecordChild1,
  OPC_SwitchType , 8, 39, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_U_I8x16),
                 39, 2, 0, 1, 
  8, 50, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_U_I16x8),
                 50, 2, 0, 1, 
  8, 60, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_U_I32x4),
                 60, 2, 0, 1, 
  0,
 34, TARGET_VAL(ISD::SMAX),
  OPC_RecordChild0,
  OPC_RecordChild1,
  OPC_SwitchType , 8, 39, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_S_I8x16),
                 39, 2, 0, 1, 
  8, 50, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_S_I16x8),
                 50, 2, 0, 1, 
  8, 60, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_S_I32x4),
                 60, 2, 0, 1, 
  0,
 34, TARGET_VAL(ISD::UMAX),
  OPC_RecordChild0,
  OPC_RecordChild1,
  OPC_SwitchType , 8, 39, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_U_I8x16),
                 39, 2, 0, 1, 
  8, 50, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_U_I16x8),
                 50, 2, 0, 1, 
  8, 60, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_U_I32x4),
                 60, 2, 0, 1, 
  0,
 13, TARGET_VAL(WebAssemblyISD::TRUNC_SAT_ZERO_S),
  OPC_RecordChild0,
  OPC_CheckChild0Type, 1|128,1, 
  OPC_CheckType, 60, 
  OPC_CheckPatternPredicate0,
  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::trunc_sat_zero_s_I32x4),
                60, 1, 0, 
 13, TARGET_VAL(WebAssemblyISD::TRUNC_SAT_ZERO_U),
  OPC_RecordChild0,
  OPC_CheckChild0Type, 1|128,1, 
  OPC_CheckType, 60, 
  OPC_CheckPatternPredicate0,
  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::trunc_sat_zero_u_I32x4),
                60, 1, 0, 
 36, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_S),
  OPC_RecordChild0,
  OPC_SwitchType , 9, 50, 
   OPC_CheckChild0Type, 39, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_low_s_I16x8),
                 50, 1, 0, 
  9, 60, 
   OPC_CheckChild0Type, 50, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_low_s_I32x4),
                 60, 1, 0, 
  9, 78, 
   OPC_CheckChild0Type, 60, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_low_s_I64x2),
                 78, 1, 0, 
  0,
 36, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_S),
  OPC_RecordChild0,
  OPC_SwitchType , 9, 50, 
   OPC_CheckChild0Type, 39, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_high_s_I16x8),
                 50, 1, 0, 
  9, 60, 
   OPC_CheckChild0Type, 50, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_high_s_I32x4),
                 60, 1, 0, 
  9, 78, 
   OPC_CheckChild0Type, 60, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_high_s_I64x2),
                 78, 1, 0, 
  0,
 36, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_U),
  OPC_RecordChild0,
  OPC_SwitchType , 9, 50, 
   OPC_CheckChild0Type, 39, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_low_u_I16x8),
                 50, 1, 0, 
  9, 60, 
   OPC_CheckChild0Type, 50, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_low_u_I32x4),
                 60, 1, 0, 
  9, 78, 
   OPC_CheckChild0Type, 60, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_low_u_I64x2),
                 78, 1, 0, 
  0,
 36, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_U),
  OPC_RecordChild0,
  OPC_SwitchType , 9, 50, 
   OPC_CheckChild0Type, 39, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_high_u_I16x8),
                 50, 1, 0, 
  9, 60, 
   OPC_CheckChild0Type, 50, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_high_u_I32x4),
                 60, 1, 0, 
  9, 78, 
   OPC_CheckChild0Type, 60, 
   OPC_CheckPatternPredicate0,
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_high_u_I64x2),
                 78, 1, 0, 
  0,
 31, TARGET_VAL(WebAssemblyISD::NARROW_U),
  OPC_RecordChild0,
  OPC_SwitchType , 12, 39, 
   OPC_CheckChild0Type, 50, 
   OPC_RecordChild1,
   OPC_CheckChild1Type, 50, 
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NARROW_U_I8x16),
                 39, 2, 0, 1, 
  12, 50, 
   OPC_CheckChild0Type, 60, 
   OPC_RecordChild1,
   OPC_CheckChild1Type, 60, 
   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NARROW_U_I16x8),
                 50, 2, 0, 1, 
  0,
 14, TARGET_VAL(WebAssemblyISD::CONVERT_LOW_S),
  OPC_RecordChild0,
  OPC_CheckChild0Type, 60, 
  OPC_CheckType, 1|128,1, 
  OPC_CheckPatternPredicate0,
  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::convert_low_s_F64x2),
                1|128,1, 1, 0, 
 14, TARGET_VAL(WebAssemblyISD::CONVERT_LOW_U),
  OPC_RecordChild0,
  OPC_CheckChild0Type, 60, 
  OPC_CheckType, 1|128,1, 
  OPC_CheckPatternPredicate0,
  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::convert_low_u_F64x2),
                1|128,1, 1, 0, 
 13, TARGET_VAL(WebAssemblyISD::DEMOTE_ZERO),
  OPC_RecordChild0,
  OPC_CheckChild0Type, 1|128,1, 
  OPC_CheckType, 111, 
  OPC_CheckPatternPredicate0,
  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::demote_zero_F32x4),
                111, 1, 0, 
 14, TARGET_VAL(WebAssemblyISD::PROMOTE_LOW),
  OPC_RecordChild0,
  OPC_CheckChild0Type, 111, 
  OPC_CheckType, 1|128,1, 
  OPC_CheckPatternPredicate0,
  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::promote_low_F64x2),
                1|128,1, 1, 0, 
 0,
    0
  }; // Total Array size is 24975 bytes

  #undef COVERAGE_IDX_VAL
  #undef TARGET_VAL
  SelectCodeCommon(N, MatcherTable, sizeof(MatcherTable));
}
#endif // GET_DAGISEL_BODY

#ifdef GET_DAGISEL_DECL
bool CheckPatternPredicate(unsigned PredNo) const override;
#endif
#if defined(GET_DAGISEL_BODY) || DAGISEL_INLINE
bool DAGISEL_CLASS_COLONCOLON CheckPatternPredicate(unsigned PredNo) const
#if DAGISEL_INLINE
  override
#endif
{
  switch (PredNo) {
  default: llvm_unreachable("Invalid predicate in table?");
  case 0: return (Subtarget->hasSIMD128());
  case 1: return (!Subtarget->hasAddr64());
  case 2: return (Subtarget->hasAddr64());
  case 3: return (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics());
  case 4: return (Subtarget->hasAddr64()) && (Subtarget->hasAtomics());
  case 5: return (Subtarget->hasFP16()) && (Subtarget->hasSIMD128());
  case 6: return (Subtarget->hasReferenceTypes());
  case 7: return (Subtarget->hasRelaxedSIMD());
  case 8: return (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes());
  case 9: return (Subtarget->hasNontrappingFPToInt());
  case 10: return (!Subtarget->hasNontrappingFPToInt());
  case 11: return (Subtarget->hasSignExt());
  case 12: return (Subtarget->hasBulkMemoryOpt());
  case 13: return (Subtarget->hasRelaxedSIMD()) && (Subtarget->hasSIMD128());
  case 14: return (!Subtarget->hasAddr64()) && (TM.isPositionIndependent());
  case 15: return (Subtarget->hasAddr64()) && (TM.isPositionIndependent());
  case 16: return (Subtarget->hasFP16());
  case 17: return (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent());
  case 18: return (Subtarget->hasAddr64()) && (!TM.isPositionIndependent());
  case 19: return (Subtarget->hasExceptionHandling());
  }
}
#endif // GET_DAGISEL_BODY

#ifdef GET_DAGISEL_DECL
bool CheckNodePredicate(SDNode *Node, unsigned PredNo) const override;
#endif
#if defined(GET_DAGISEL_BODY) || DAGISEL_INLINE
bool DAGISEL_CLASS_COLONCOLON CheckNodePredicate(SDNode *Node, unsigned PredNo) const
#if DAGISEL_INLINE
  override
#endif
{
  switch (PredNo) {
  default: llvm_unreachable("Invalid predicate in table?");
  case 0: {
    // Predicate_LaneIdx32
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 32;
  }
  case 1: {
    // Predicate_atomic_cmp_swap_i8
    // Predicate_atomic_load_8
    // Predicate_atomic_load_add_i8
    // Predicate_atomic_load_and_i8
    // Predicate_atomic_load_or_i8
    // Predicate_atomic_load_sub_i8
    // Predicate_atomic_load_xor_i8
    // Predicate_atomic_store_8
    // Predicate_atomic_swap_i8
    // Predicate_extloadi8
    // Predicate_sextloadi8
    // Predicate_zextloadi8
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i8) return false;
return true;

  }
  case 2: {
    // Predicate_atomic_cmp_swap_i16
    // Predicate_atomic_load_16
    // Predicate_atomic_load_add_i16
    // Predicate_atomic_load_and_i16
    // Predicate_atomic_load_or_i16
    // Predicate_atomic_load_sub_i16
    // Predicate_atomic_load_xor_i16
    // Predicate_atomic_store_16
    // Predicate_atomic_swap_i16
    // Predicate_extloadi16
    // Predicate_sextloadi16
    // Predicate_zextloadi16
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i16) return false;
return true;

  }
  case 3: {
    // Predicate_atomic_cmp_swap_i32
    // Predicate_atomic_load_32
    // Predicate_atomic_load_add_i32
    // Predicate_atomic_load_and_i32
    // Predicate_atomic_load_or_i32
    // Predicate_atomic_load_sub_i32
    // Predicate_atomic_load_xor_i32
    // Predicate_atomic_store_32
    // Predicate_atomic_swap_i32
    // Predicate_extloadi32
    // Predicate_sextloadi32
    // Predicate_zextloadi32
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i32) return false;
return true;

  }
  case 4: {
    // Predicate_unindexedstore
    SDNode *N = Node;
    (void)N;
if (cast<StoreSDNode>(N)->getAddressingMode() != ISD::UNINDEXED) return false;
return true;

  }
  case 5: {
    // Predicate_store
    SDNode *N = Node;
    (void)N;
 if (cast<StoreSDNode>(N)->isTruncatingStore()) return false;
return true;

  }
  case 6: {
    // Predicate_load
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getExtensionType() != ISD::NON_EXTLOAD) return false;
return true;

  }
  case 7: {
    // Predicate_atomic_cmp_swap_i64
    // Predicate_atomic_load_64
    // Predicate_atomic_load_add_i64
    // Predicate_atomic_load_and_i64
    // Predicate_atomic_load_or_i64
    // Predicate_atomic_load_sub_i64
    // Predicate_atomic_load_xor_i64
    // Predicate_atomic_store_64
    // Predicate_atomic_swap_i64
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i64) return false;
return true;

  }
  case 8: {
    // Predicate_unindexedload
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getAddressingMode() != ISD::UNINDEXED) return false;
return true;

  }
  case 9: {
    // Predicate_ImmI8
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return -(1 << (8 - 1)) <= Imm && Imm < (1 << 8);
  }
  case 10: {
    // Predicate_extload
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getExtensionType() != ISD::EXTLOAD) return false;
return true;

  }
  case 11: {
    // Predicate_LaneIdx4
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 4;
  }
  case 12: {
    // Predicate_LaneIdx2
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 2;
  }
  case 13: {
    // Predicate_LaneIdx8
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 8;
  }
  case 14: {
    // Predicate_truncstore
    SDNode *N = Node;
    (void)N;
 if (!cast<StoreSDNode>(N)->isTruncatingStore()) return false;
return true;

  }
  case 15: {
    // Predicate_sextload
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getExtensionType() != ISD::SEXTLOAD) return false;
return true;

  }
  case 16: {
    // Predicate_zextload
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getExtensionType() != ISD::ZEXTLOAD) return false;
return true;

  }
  case 17: {
    // Predicate_ImmI16
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return -(1 << (16 - 1)) <= Imm && Imm < (1 << 16);
  }
  case 18: {
    // Predicate_LaneIdx16
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 16;
  }
  case 19: {
    // Predicate_truncstorei8
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i8) return false;
 if (!cast<StoreSDNode>(N)->isTruncatingStore()) return false;
return true;

  }
  case 20: {
    // Predicate_truncstorei16
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i16) return false;
 if (!cast<StoreSDNode>(N)->isTruncatingStore()) return false;
return true;

  }
  case 21: {
    // Predicate_extloadvi8
    // Predicate_sextloadvi8
    // Predicate_zextloadvi8
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getMemoryVT().getScalarType() != MVT::i8) return false;
return true;

  }
  case 22: {
    // Predicate_extloadvi16
    // Predicate_sextloadvi16
    // Predicate_zextloadvi16
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getMemoryVT().getScalarType() != MVT::i16) return false;
return true;

  }
  case 23: {
    // Predicate_extloadvi32
    // Predicate_sextloadvi32
    // Predicate_zextloadvi32
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getMemoryVT().getScalarType() != MVT::i32) return false;
return true;

  }
  case 24: {
    // Predicate_add_nuw
    SDNode *N = Node;
    (void)N;
return N->getFlags().hasNoUnsignedWrap();
  }
  case 25: {
    // Predicate_truncstorei32
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i32) return false;
 if (!cast<StoreSDNode>(N)->isTruncatingStore()) return false;
return true;

  }
  case 26: {
    // Predicate_bool_node
    SDNode *N = Node;
    (void)N;

  return CurDAG->computeKnownBits(SDValue(N, 0)).countMinLeadingZeros() == 31;

  }
  }
}
#endif // GET_DAGISEL_BODY

#ifdef GET_DAGISEL_DECL
bool CheckComplexPattern(SDNode *Root, SDNode *Parent,
      SDValue N, unsigned PatternNo,
      SmallVectorImpl<std::pair<SDValue, SDNode *>> &Result) override;
#endif
#if defined(GET_DAGISEL_BODY) || DAGISEL_INLINE
bool DAGISEL_CLASS_COLONCOLON CheckComplexPattern(SDNode *Root, SDNode *Parent,
      SDValue N, unsigned PatternNo,
      SmallVectorImpl<std::pair<SDValue, SDNode *>> &Result)
#if DAGISEL_INLINE
  override
#endif
{
  unsigned NextRes = Result.size();
  switch (PatternNo) {
  default: llvm_unreachable("Invalid pattern # in table?");
  case 0:
    Result.resize(NextRes+2);
  return SelectAddrOperands32(N, Result[NextRes+0].first, Result[NextRes+1].first);
  case 1:
    Result.resize(NextRes+2);
  return SelectAddrOperands64(N, Result[NextRes+0].first, Result[NextRes+1].first);
  }
}
#endif // GET_DAGISEL_BODY


#ifdef DAGISEL_INLINE
#undef DAGISEL_INLINE
#endif
#ifdef DAGISEL_CLASS_COLONCOLON
#undef DAGISEL_CLASS_COLONCOLON
#endif
#ifdef GET_DAGISEL_DECL
#undef GET_DAGISEL_DECL
#endif
#ifdef GET_DAGISEL_BODY
#undef GET_DAGISEL_BODY
#endif
